
#include "dispatch_command.h"
#include <google/protobuf/text_format.h>
#include "../tool/time_tool.h"
#include "dispatch_manager.h"


Dispatch_command::Dispatch_command()
{
	m_dispatch_command_status = E_DISPATCH_COMMAND_UNKNOW;
	m_unit = 0;
	m_device_floor = 0;
	m_dispatch_process_type = Common_data::DISPATCH_PROCESS_TYPE_UNKNOW;
	m_height_level = 0;
	m_wheel_base_level = 0;

	m_dispatch_space_info_count = 0;

//	m_wait_park_count = 0;
//	m_wait_pick_count = 0;
}

Dispatch_command::~Dispatch_command()
{

}

Error_manager Dispatch_command::dispatch_command_init(int dispatch_manager_id)
{
	m_unit = dispatch_manager_id;
	m_dispatch_id = dispatch_manager_id;
	return Error_code::SUCCESS;
}
Error_manager Dispatch_command::dispatch_command_uninit()
{
	return Error_code::SUCCESS;
}

#ifdef SHANGGUJIE_PROJECT_PROJECT
//存车指令入队, 检查节点直接通过rabbitmq发送给调度, 调度接受后数据库指令入队,
Error_manager Dispatch_command::insert_park_command(park_table park_command, int statu)
{
	Dispatch_command_info t_dispatch_command_info;
	t_dispatch_command_info.m_car_number = park_command.car_number();
	t_dispatch_command_info.m_primary_key = park_command.primary_key();
	t_dispatch_command_info.m_unit = park_command.unit_id();
	t_dispatch_command_info.m_terminal_id = park_command.terminal_id();
	//queue_id 当前之间的总秒, (后续排序的权重参数是 搬运器和起点的距离 用户等待时间  ) (当前之间的总秒, 系统时间单位是纳秒, 除以10^9转化为秒)
	t_dispatch_command_info.m_queue_id = std::chrono::system_clock::now().time_since_epoch().count()/1000000000;
	t_dispatch_command_info.m_type = 1;//1表示存车, 2表示取车
	t_dispatch_command_info.m_statu = statu;//0表示排队中, 1表示运行中, 2表示完成, 3表示故障
	t_dispatch_command_info.m_import_id = get_passway_id(park_command.terminal_id(), 1);//
	t_dispatch_command_info.m_export_id = 0;//出口id, 存车时不写
	t_dispatch_command_info.m_space_info_msg;//指令执行的时候，再去分配车位
	t_dispatch_command_info.m_measure_buffer_msg = park_command.entrance_measure_info();
	t_dispatch_command_info.m_car_number_info_msg = park_command.car_number_info();

	//目前雷达感测没有车高。是检查检点填充的。
	t_dispatch_command_info.m_height = park_command.entrance_measure_info().measure_info_to_plc_forward().height();
	//从plc的状态，获取入口车高
	t_dispatch_command_info.m_height_level =
	Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[t_dispatch_command_info.m_import_id-1].m_car_height;

	//只有C单元有轮距， AB单元为0
	t_dispatch_command_info.m_wheel_base = park_command.entrance_measure_info().measure_info_to_plc_forward().wheelbase();
	t_dispatch_command_info.m_wheel_base_level = Common_data::judge_wheel_base_level_new(t_dispatch_command_info.m_wheel_base);


	char insert_command_queue_sql[DB_SQL_SIZE];
	memset(insert_command_queue_sql, 0, DB_SQL_SIZE);
	sprintf(insert_command_queue_sql, "INSERT INTO command_queue (car_number,primary_key, unit, terminal_id , queue_id, queue_time, type, statu, import_id, export_id, height_level, height, wheel_base_level, wheel_base, space_info, measure_buffer, plate_color, plate_type, plate_confidence, recognition_time, plate_full_image, plate_clip_image) values ('%s','%s', %d, %d, %d, '%s', %d, %d, %d, %d, %d, %f, %d, %f, '%s', '%s', '%s', '%s', %d, '%s', '%s', '%s')",
			t_dispatch_command_info.m_car_number.c_str(),
			t_dispatch_command_info.m_primary_key.c_str(),
			t_dispatch_command_info.m_unit,
			t_dispatch_command_info.m_terminal_id,
			t_dispatch_command_info.m_queue_id,
			Time_tool::get_instance_references().get_current_time_seconds().c_str(),
			t_dispatch_command_info.m_type,
			t_dispatch_command_info.m_statu,
			t_dispatch_command_info.m_import_id,
			t_dispatch_command_info.m_export_id,
			t_dispatch_command_info.m_height_level,
			t_dispatch_command_info.m_height,
			t_dispatch_command_info.m_wheel_base_level,
			t_dispatch_command_info.m_wheel_base,
			t_dispatch_command_info.m_space_info_msg.DebugString().c_str(),
			t_dispatch_command_info.m_measure_buffer_msg.DebugString().c_str(),
			t_dispatch_command_info.m_car_number_info_msg.plate_color().c_str(),
			t_dispatch_command_info.m_car_number_info_msg.plate_type().c_str(),
			t_dispatch_command_info.m_car_number_info_msg.plate_confidence(),
			t_dispatch_command_info.m_car_number_info_msg.recognition_time().c_str(),
			t_dispatch_command_info.m_car_number_info_msg.plate_full_image().c_str(),
			t_dispatch_command_info.m_car_number_info_msg.plate_clip_image().c_str()
	);
	LOG(INFO) << " 1 insert_command_queue_sql =  "<< insert_command_queue_sql << "  "  << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_insert(insert_command_queue_sql);
	return ec;


	return Error_code::SUCCESS;
}
//存车指令入队, 检查节点直接通过rabbitmq发送给调度, 调度接受后数据库指令入队,
Error_manager Dispatch_command::insert_park_command(park_table park_command, Dispatch_command::Dispatch_space_info dispatch_space_info, int statu)
{
	Dispatch_command_info t_dispatch_command_info;
	t_dispatch_command_info.m_car_number = park_command.car_number();
	t_dispatch_command_info.m_primary_key = park_command.primary_key();
	t_dispatch_command_info.m_unit = park_command.unit_id();
	t_dispatch_command_info.m_terminal_id = park_command.terminal_id();
	//queue_id 当前之间的总秒, (后续排序的权重参数是 搬运器和起点的距离 用户等待时间  ) (当前之间的总秒, 系统时间单位是纳秒, 除以10^9转化为秒)
	t_dispatch_command_info.m_queue_id = std::chrono::system_clock::now().time_since_epoch().count()/1000000000;
	t_dispatch_command_info.m_type = 1;//1表示存车, 2表示取车
	t_dispatch_command_info.m_statu = statu;//0表示排队中, 1表示运行中, 2表示完成, 3表示故障
	t_dispatch_command_info.m_import_id = get_passway_id(park_command.terminal_id(), 1);//
	t_dispatch_command_info.m_export_id = 0;//出口id, 存车时不写
	t_dispatch_command_info.m_space_info_msg.set_id(dispatch_space_info.m_id);
	t_dispatch_command_info.m_space_info_msg.set_serial_id(dispatch_space_info.m_serial_id);
	t_dispatch_command_info.m_space_info_msg.set_table_id(dispatch_space_info.m_table_id);
	t_dispatch_command_info.m_space_info_msg.set_unit_id(dispatch_space_info.m_unit);
	t_dispatch_command_info.m_space_info_msg.set_floor(dispatch_space_info.m_floor);
	t_dispatch_command_info.m_space_info_msg.set_room_id(dispatch_space_info.m_room_id);
	t_dispatch_command_info.m_space_info_msg.set_height(dispatch_space_info.m_height);
	t_dispatch_command_info.m_measure_buffer_msg = park_command.entrance_measure_info();
	t_dispatch_command_info.m_car_number_info_msg = park_command.car_number_info();

	//目前雷达感测没有车高。是检查检点填充的。
	t_dispatch_command_info.m_height = park_command.entrance_measure_info().measure_info_to_plc_forward().height();
	//从plc的状态，获取入口车高
	t_dispatch_command_info.m_height_level =
	Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[t_dispatch_command_info.m_import_id-1].m_car_height;

	//只有C单元有轮距， AB单元为0
	t_dispatch_command_info.m_wheel_base = park_command.entrance_measure_info().measure_info_to_plc_forward().wheelbase();
	t_dispatch_command_info.m_wheel_base_level = Common_data::judge_wheel_base_level_new(t_dispatch_command_info.m_wheel_base);


	char insert_command_queue_sql[DB_SQL_SIZE];
	memset(insert_command_queue_sql, 0, DB_SQL_SIZE);
	sprintf(insert_command_queue_sql, "INSERT INTO command_queue (car_number,primary_key, unit, terminal_id , queue_id, queue_time, type, statu, import_id, export_id, height_level, height, wheel_base_level, wheel_base, space_info, measure_buffer, plate_color, plate_type, plate_confidence, recognition_time, plate_full_image, plate_clip_image) values ('%s','%s', %d, %d, %d, '%s', %d, %d, %d, %d, %d, %f, %d, %f, '%s', '%s', '%s', '%s', %d, '%s', '%s', '%s')",
			t_dispatch_command_info.m_car_number.c_str(),
			t_dispatch_command_info.m_primary_key.c_str(),
			t_dispatch_command_info.m_unit,
			t_dispatch_command_info.m_terminal_id,
			t_dispatch_command_info.m_queue_id,
			Time_tool::get_instance_references().get_current_time_seconds().c_str(),
			t_dispatch_command_info.m_type,
			t_dispatch_command_info.m_statu,
			t_dispatch_command_info.m_import_id,
			t_dispatch_command_info.m_export_id,
			t_dispatch_command_info.m_height_level,
			t_dispatch_command_info.m_height,
			t_dispatch_command_info.m_wheel_base_level,
			t_dispatch_command_info.m_wheel_base,
			t_dispatch_command_info.m_space_info_msg.DebugString().c_str(),
			t_dispatch_command_info.m_measure_buffer_msg.DebugString().c_str(),
			t_dispatch_command_info.m_car_number_info_msg.plate_color().c_str(),
			t_dispatch_command_info.m_car_number_info_msg.plate_type().c_str(),
			t_dispatch_command_info.m_car_number_info_msg.plate_confidence(),
			t_dispatch_command_info.m_car_number_info_msg.recognition_time().c_str(),
			t_dispatch_command_info.m_car_number_info_msg.plate_full_image().c_str(),
			t_dispatch_command_info.m_car_number_info_msg.plate_clip_image().c_str()
	);
	LOG(INFO) << " 2 insert_command_queue_sql =  "<< insert_command_queue_sql << "  "  << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_insert(insert_command_queue_sql);
	return ec;


	return Error_code::SUCCESS;
}
//取车指令入队, 检查节点直接通过rabbitmq发送给调度, 调度接受后数据库指令入队,
Error_manager Dispatch_command::insert_pick_command(pick_table pick_command, int statu)
{
	Error_manager t_error;
	Dispatch_command_info t_dispatch_command_info;
	//只使用取车表单的唯一码, 其他信息去数据库查.
	t_dispatch_command_info.m_primary_key = pick_command.primary_key();
	t_error =  query_dispatch_space_for_primary_key_ex(t_dispatch_command_info.m_primary_key, t_dispatch_command_info);
	if ( t_error == Error_code::SUCCESS )
	{
		t_dispatch_command_info.m_unit = t_dispatch_command_info.m_space_info_msg.unit_id();
		t_dispatch_command_info.m_terminal_id = pick_command.terminal_id();
		//queue_id 当前之间的总秒, (后续排序的权重参数是 搬运器和起点的距离 用户等待时间  ) (当前之间的总秒, 系统时间单位是纳秒, 除以10^9转化为秒)
		t_dispatch_command_info.m_queue_id = std::chrono::system_clock::now().time_since_epoch().count()/1000000000;
		t_dispatch_command_info.m_type = 2;//1表示存车, 2表示取车
		t_dispatch_command_info.m_statu = statu;//0表示排队中, 1表示运行中, 2表示完成, 3表示故障
		t_dispatch_command_info.m_import_id = 0;//入口id, 取车时不写
		t_dispatch_command_info.m_export_id = 0;//出口id, 入队时不写, 后续运行时补全


		char insert_command_queue_sql[DB_SQL_SIZE];
		memset(insert_command_queue_sql, 0, DB_SQL_SIZE);
		LOG(INFO) << " 3 insert_command_queue_sql =  " << insert_command_queue_sql <<"  "<< this;
		sprintf(insert_command_queue_sql, "INSERT INTO command_queue (car_number,primary_key, unit, terminal_id , queue_id, queue_time, type, statu, import_id, export_id, height_level, height, wheel_base_level, wheel_base, space_info, measure_buffer) values ('%s','%s', %d, %d, %d, '%s', %d, %d, %d, %d, %d, %f, %d, %f, '%s', '%s')",
				t_dispatch_command_info.m_car_number.c_str(),
				t_dispatch_command_info.m_primary_key.c_str(),
				t_dispatch_command_info.m_unit,
				t_dispatch_command_info.m_terminal_id,
				t_dispatch_command_info.m_queue_id,
				Time_tool::get_instance_references().get_current_time_seconds().c_str(),
				t_dispatch_command_info.m_type,
				t_dispatch_command_info.m_statu,
				t_dispatch_command_info.m_import_id,
				t_dispatch_command_info.m_export_id,
				t_dispatch_command_info.m_height_level,
				t_dispatch_command_info.m_height,
				t_dispatch_command_info.m_wheel_base_level,
				t_dispatch_command_info.m_wheel_base,
				t_dispatch_command_info.m_space_info_msg.DebugString().c_str(),
				t_dispatch_command_info.m_measure_buffer_msg.DebugString().c_str()
		);
		Error_manager ec = Database_controller::get_instance_pointer()->sql_insert(insert_command_queue_sql);
		return ec;
	}
	else
	{
		//space 表没有找到， 就查询command表去恢复指令表。
		t_error =  query_command_queue_for_primary_key_ex(t_dispatch_command_info.m_primary_key, t_dispatch_command_info);
		if ( t_error == Error_code::SUCCESS )
		{
			t_dispatch_command_info.m_terminal_id = pick_command.terminal_id();
			//queue_id 当前之间的总秒, (后续排序的权重参数是 搬运器和起点的距离 用户等待时间  ) (当前之间的总秒, 系统时间单位是纳秒, 除以10^9转化为秒)
			t_dispatch_command_info.m_queue_id = std::chrono::system_clock::now().time_since_epoch().count()/1000000000;
			t_dispatch_command_info.m_type = 2;//1表示存车, 2表示取车
			t_dispatch_command_info.m_statu = statu;//0表示排队中, 1表示运行中, 2表示完成, 3表示故障

			char insert_command_queue_sql[DB_SQL_SIZE];
			memset(insert_command_queue_sql, 0, DB_SQL_SIZE);
			LOG(INFO) << " 3 insert_command_queue_sql =  " << insert_command_queue_sql <<"  "<< this;
			sprintf(insert_command_queue_sql, "INSERT INTO command_queue (car_number,primary_key, unit, terminal_id , queue_id, queue_time, type, statu, import_id, export_id, height_level, height, wheel_base_level, wheel_base, space_info, measure_buffer) values ('%s','%s', %d, %d, %d, '%s', %d, %d, %d, %d, %d, %f, %d, %f, '%s', '%s')",
					t_dispatch_command_info.m_car_number.c_str(),
					t_dispatch_command_info.m_primary_key.c_str(),
					t_dispatch_command_info.m_unit,
					t_dispatch_command_info.m_terminal_id,
					t_dispatch_command_info.m_queue_id,
					Time_tool::get_instance_references().get_current_time_seconds().c_str(),
					t_dispatch_command_info.m_type,
					t_dispatch_command_info.m_statu,
					t_dispatch_command_info.m_import_id,
					t_dispatch_command_info.m_export_id,
					t_dispatch_command_info.m_height_level,
					t_dispatch_command_info.m_height,
					t_dispatch_command_info.m_wheel_base_level,
					t_dispatch_command_info.m_wheel_base,
					t_dispatch_command_info.m_space_info_msg.DebugString().c_str(),
					t_dispatch_command_info.m_measure_buffer_msg.DebugString().c_str()
			);
			Error_manager ec = Database_controller::get_instance_pointer()->sql_insert(insert_command_queue_sql);
			return ec;
		}
		else
		{
			return t_error;
		}
	}
	return Error_code::SUCCESS;
}
//取车指令入队, 检查节点直接通过rabbitmq发送给调度, 调度接受后数据库指令入队,
Error_manager Dispatch_command::insert_pick_command(pick_table pick_command, Dispatch_command::Dispatch_space_info dispatch_space_info, int statu)
{
	Error_manager t_error;
	Dispatch_command_info t_dispatch_command_info;
	//只使用取车表单的唯一码, 其他信息去数据库查.
	t_dispatch_command_info.m_primary_key = pick_command.primary_key();
	t_error =  query_dispatch_space_for_primary_key_ex(t_dispatch_command_info.m_primary_key, t_dispatch_command_info);
	if ( t_error != Error_code::SUCCESS )
	{
		return t_error;
	}

	t_dispatch_command_info.m_unit = t_dispatch_command_info.m_space_info_msg.unit_id();
	t_dispatch_command_info.m_terminal_id = pick_command.terminal_id();
	//queue_id 当前之间的总秒, (后续排序的权重参数是 搬运器和起点的距离 用户等待时间  ) (当前之间的总秒, 系统时间单位是纳秒, 除以10^9转化为秒)
	t_dispatch_command_info.m_queue_id = std::chrono::system_clock::now().time_since_epoch().count()/1000000000;
	t_dispatch_command_info.m_type = 2;//1表示存车, 2表示取车
	t_dispatch_command_info.m_statu = statu;//0表示排队中, 1表示运行中, 2表示完成, 3表示故障
	t_dispatch_command_info.m_import_id = 0;//入口id, 取车时不写
	t_dispatch_command_info.m_export_id = 0;//出口id, 入队时不写, 后续运行时补全
	t_dispatch_command_info.m_space_info_msg.set_id(dispatch_space_info.m_id);
	t_dispatch_command_info.m_space_info_msg.set_serial_id(dispatch_space_info.m_serial_id);
	t_dispatch_command_info.m_space_info_msg.set_table_id(dispatch_space_info.m_table_id);
	t_dispatch_command_info.m_space_info_msg.set_unit_id(dispatch_space_info.m_unit);
	t_dispatch_command_info.m_space_info_msg.set_floor(dispatch_space_info.m_floor);
	t_dispatch_command_info.m_space_info_msg.set_room_id(dispatch_space_info.m_room_id);
	t_dispatch_command_info.m_space_info_msg.set_height(dispatch_space_info.m_height);

	char insert_command_queue_sql[DB_SQL_SIZE];
	memset(insert_command_queue_sql, 0, DB_SQL_SIZE);
	sprintf(insert_command_queue_sql, "INSERT INTO command_queue (car_number,primary_key, unit, terminal_id , queue_id, queue_time, type, statu, import_id, export_id, height_level, height, wheel_base_level, wheel_base, space_info, measure_buffer) values ('%s','%s', %d, %d, %d, '%s', %d, %d, %d, %d, %d, %f, %d, %f, '%s', '%s')",
			t_dispatch_command_info.m_car_number.c_str(),
			t_dispatch_command_info.m_primary_key.c_str(),
			t_dispatch_command_info.m_unit,
			t_dispatch_command_info.m_terminal_id,
			t_dispatch_command_info.m_queue_id,
			Time_tool::get_instance_references().get_current_time_seconds().c_str(),
			t_dispatch_command_info.m_type,
			t_dispatch_command_info.m_statu,
			t_dispatch_command_info.m_import_id,
			t_dispatch_command_info.m_export_id,
			t_dispatch_command_info.m_height_level,
			t_dispatch_command_info.m_height,
			t_dispatch_command_info.m_wheel_base_level,
			t_dispatch_command_info.m_wheel_base,
			t_dispatch_command_info.m_space_info_msg.DebugString().c_str(),
			t_dispatch_command_info.m_measure_buffer_msg.DebugString().c_str()
	);
	LOG(INFO) << " 4 insert_command_queue_sql =  " << insert_command_queue_sql <<"  "<< this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_insert(insert_command_queue_sql);
	return ec;

	return Error_code::SUCCESS;
}

#endif//SHANGGUJIE_PROJECT_PROJECT


//调度开始前, 向数据库发送请求的相关操作, 输入 穿梭机所在的楼层, 调度id 0~2, 空闲出口id, 如果不是0,就表示有空闲的出口, 注意了：加锁
Error_manager Dispatch_command::dispatch_request_to_sql(int device_floor, int dispatch_id, int outlet_ready, int plc_park_priority)
{
	std::unique_lock<std::mutex> t_lock(m_lock);
	Error_manager t_error;

	m_device_floor = device_floor;
	m_dispatch_id = dispatch_id;
	m_unit = dispatch_id;
//	m_outlet_ready = outlet_ready; //只有创建取车任务成功之后，才能确认出口被使用。

	//获取调度指令, 与数据库同步 command_queue
	t_error = query_all_dispatch_command(0);
	if ( t_error != Error_code::SUCCESS )
	{
		return t_error;
	}

	//排序
	if ( outlet_ready == 0 )
	{
		//对调度指令进行排序, 选出最优解, 只比较存车
		t_error = sort_dispatch_command_for_park(plc_park_priority);
	}
	else
	{
		//对调度指令进行排序, 选出最优解, 比较存车和取车
		t_error = sort_dispatch_command_for_total(plc_park_priority);
	}

	if ( t_error != Error_code::SUCCESS )
	{
		m_dispatch_process_type = Common_data::DISPATCH_PROCESS_TYPE_UNKNOW;

		//没有找到合适的指令就返回NODATA, 然后设么也不做
		return t_error;
	}
	else
	{
		if ( m_dispatch_command_map[m_primary_key_optimal].m_type == 1 )//存车
		{
			//20230708, 存车之前检查这个车是否在库内，必须保证关外门，并且在库内。
			int t_m_import_id = m_dispatch_command_map[m_primary_key_optimal].m_import_id;
//			int t_height_level = Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[t_m_import_id-1].m_car_height;
//			if ( t_height_level == 0 || t_height_level > CAR_HEIGHT_LEVEL_MAX)

			if( ( Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[t_m_import_id-1].m_sensor_2 & 0x03 ) == 0x03)
			{
				//直接切换为故障。
				LOG(INFO) << "  when park, import have no car = %s,   "<< t_error << " --- " << this;
				//删除车牌图片信息,
				update_parkspace_clear_car_number_info(0);
				//更新 车位状态, 找到车牌号, 写NULL
				update_parkspace_clear_car_number(0);
				//更新 指令队列, 根据车牌号 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
				update_command_queue_for_statu(3);
				return Error_code::NODATA;
			}
			else
			{
				//外门关闭
				if ( Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[t_m_import_id-1].m_outside_door_status == 2 )
				{
					//注注注注注意了
					//20230621, 排队存车进入指令表， 提前预约车位，提前写入指令表，车位表，记录表

					//判断车位是否提前预约，
					if ( m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.id() == 0 )
					{
						LOG(INFO) << " congxinfeipei================================================== congxinfeipei   "<< this;
						LOG(INFO) << " m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg " << m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.DebugString() << "  " << this;
						//如果没有预约， 那么再次分配一次。
						//查询空闲车位最优解,    存车指令 根据调度指令最优解 获取 空闲车位最优解 m_dispatch_space_info
						t_error = query_dispatch_space_optimal_ex(m_dispatch_command_map[m_primary_key_optimal].m_unit,
																  m_dispatch_command_map[m_primary_key_optimal].m_height_level,
																  m_dispatch_command_map[m_primary_key_optimal].m_wheel_base_level,
																  m_dispatch_space_info[0]);
						if ( t_error != Error_code::SUCCESS )
						{
							update_command_queue_for_statu(3);
							return t_error;
						}
						else
						{
							//将最优解车位信息 补充到指令表
							m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_id(m_dispatch_space_info[0].m_id);
							m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_serial_id(m_dispatch_space_info[0].m_serial_id);
							m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_table_id(m_dispatch_space_info[0].m_table_id);
							m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_unit_id(m_dispatch_space_info[0].m_unit);
							m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_floor(m_dispatch_space_info[0].m_floor);
							m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_room_id(m_dispatch_space_info[0].m_room_id);
							m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_height(m_dispatch_space_info[0].m_height);
							m_dispatch_command_map[m_primary_key_optimal].m_height_level = m_dispatch_space_info[0].m_height_level;
							m_dispatch_command_map[m_primary_key_optimal].m_height = m_dispatch_space_info[0].m_height;
							m_dispatch_command_map[m_primary_key_optimal].m_wheel_base_level = m_dispatch_space_info[0].m_wheel_base_level;
							m_dispatch_command_map[m_primary_key_optimal].m_wheel_base = m_dispatch_space_info[0].m_wheel_base;
							m_dispatch_command_map[m_primary_key_optimal].m_space_info_string = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.DebugString();
						}
					}
					else
					{
						//如果是入队时提前分配了，那么这里需要把 m_dispatch_command_map[m_primary_key_optimal] 的车位信息 传给 m_dispatch_space_info[0]
						//这样在换车位后，可以删除车位。
						m_dispatch_space_info[0].m_id = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.id();
						m_dispatch_space_info[0].m_serial_id = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.serial_id();
						m_dispatch_space_info[0].m_table_id = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.table_id();
						m_dispatch_space_info[0].m_unit = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.unit_id();
						m_dispatch_space_info[0].m_floor = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.floor();
						m_dispatch_space_info[0].m_room_id = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.room_id();
						m_dispatch_space_info[0].m_height = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.height();
						m_dispatch_space_info[0].m_height_level = m_dispatch_command_map[m_primary_key_optimal].m_height_level;
						m_dispatch_space_info[0].m_height = m_dispatch_command_map[m_primary_key_optimal].m_height;
						m_dispatch_space_info[0].m_wheel_base_level = m_dispatch_command_map[m_primary_key_optimal].m_wheel_base_level;
						m_dispatch_space_info[0].m_wheel_base = m_dispatch_command_map[m_primary_key_optimal].m_wheel_base;
					}

					//完善数据库
					m_dispatch_process_type = Common_data::DISPATCH_PROCESS_STORE;
					//更新 指令队列, 根据车牌号 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
					t_error = update_command_queue_for_statu(1);
					//更新 车位状态, 根据车位ID 写入车牌号即可
					t_error = update_parkspace_write_car_number(1);

					//制作存车表单
					t_error = create_park_table(m_dispatch_command_map[m_primary_key_optimal].m_import_id);
					m_height_level = m_dispatch_space_info[0].m_height_level;
					m_wheel_base_level = m_dispatch_space_info[0].m_wheel_base_level;

					t_error = check_record_for_no_primary_key(m_dispatch_command_map[m_primary_key_optimal].m_primary_key);
					if ( t_error == SUCCESS )
					{
						//增加 记录表, 存车指令 完成后添加存车记录
						t_error =  insert_record_for_park_start();
					}
					else
					{
						//更新 记录表, 存车指令 完成后只更新存车开始时间
						t_error =  updata_record_for_park_start();
					}


					LOG(INFO) << " create_park_table =  "<< m_park_table_msg.DebugString() << " --- " << this;
					return Error_code::SUCCESS;
				}
				else
				{
					//无限等待外门关闭
				    return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
				    					" fun error ");
				}
			}
		}
		else if ( m_dispatch_command_map[m_primary_key_optimal].m_type == 2 )//取车
		{
			//注注注注注意了
			//取车自带车位信息,没有感测信息, 需要查询车辆表,补全车辆信息

			//查询 取车的车辆位置信息和感测信息    取车指令 根据key 查询感测信息
			parkspace_info t_parkspace_info;
			measure_buffer t_measure_buffer;
			t_error = query_dispatch_space_for_car_number(m_dispatch_command_map[m_primary_key_optimal].m_car_number, t_parkspace_info, t_measure_buffer);
			if ( t_error != Error_code::SUCCESS )
			{
				update_command_queue_for_statu(3);
				return t_error;
			}
			else
			{
				//补充出口id
				m_outlet_ready = outlet_ready;//只有创建取车任务成功之后，才能确认出口被使用。

				m_dispatch_command_map[m_primary_key_optimal].m_export_id = outlet_ready;
				m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg = t_parkspace_info;
				m_dispatch_command_map[m_primary_key_optimal].m_measure_buffer_msg = t_measure_buffer;

				m_dispatch_process_type = Common_data::DISPATCH_PROCESS_PICKUP;

				//20230810, 取车也要记录车位信息， 失败后要删除车位。
				m_dispatch_space_info[0].m_id = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.id();
				m_dispatch_space_info[0].m_serial_id = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.serial_id();
				m_dispatch_space_info[0].m_table_id = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.table_id();
				m_dispatch_space_info[0].m_unit = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.unit_id();
				m_dispatch_space_info[0].m_floor = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.floor();
				m_dispatch_space_info[0].m_room_id = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.room_id();
				m_dispatch_space_info[0].m_height = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.height();
				m_dispatch_space_info[0].m_height_level = m_dispatch_command_map[m_primary_key_optimal].m_height_level;
				m_dispatch_space_info[0].m_height = m_dispatch_command_map[m_primary_key_optimal].m_height;
				m_dispatch_space_info[0].m_wheel_base_level = m_dispatch_command_map[m_primary_key_optimal].m_wheel_base_level;
				m_dispatch_space_info[0].m_wheel_base = m_dispatch_command_map[m_primary_key_optimal].m_wheel_base;

				//更新 指令队列, 根据车牌号 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
				t_error = update_command_queue_for_statu(1);
				//制作取车表单
				t_error = create_pick_table(outlet_ready);
				m_height_level = m_dispatch_command_map[m_primary_key_optimal].m_height_level;
				m_wheel_base_level = m_dispatch_command_map[m_primary_key_optimal].m_wheel_base_level;

				//更新 记录表, 取车指令 完成后更新取车记录
				t_error =  updata_record_for_pick_start();

				LOG(INFO) << " create_pick_table  =  "<< m_pick_table_msg.DebugString() << " --- " << this;
			}
		}
		else
		{
			return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
								 " fun error ");
		}
	}
	return Error_code::SUCCESS;
}

//调度完成后, 向数据库发送答复的相关操作
Error_manager Dispatch_command::dispatch_response_to_sql(Error_manager dispatch_result)
{
	std::unique_lock<std::mutex> t_lock(m_lock);
	Error_manager t_error;

	if ( dispatch_result == Error_code::SUCCESS )
	{
		//调度成功, 完善数据库
		if ( m_dispatch_process_type == Common_data::DISPATCH_PROCESS_STORE )
		{
			LOG(INFO) << " dispatch_response_to_sql DISPATCH_PROCESS_STORE :park response succeed =  "<< m_dispatch_command_map[m_primary_key_optimal].m_car_number << ", error= "<< t_error << " --- " << this;
			//增加 车辆表, 存车指令 完成后添加车辆信息
//			t_error = insert_vehicle_for_car_number();
			//更新车牌图片信息,
			update_parkspace_write_car_number_info(2);
			//更新 指令队列, 根据车牌号 删除指令
			t_error = delete_command_queue_for_car_number(m_dispatch_command_map[m_primary_key_optimal].m_car_number, m_dispatch_command_map[m_primary_key_optimal].m_type);
			//增加 记录表, 存车指令 完成后添加存车记录
			t_error =  updata_record_for_park_end();
		}
		else if ( m_dispatch_process_type == Common_data::DISPATCH_PROCESS_PICKUP )
		{
			LOG(INFO) << " dispatch_response_to_sql DISPATCH_PROCESS_PICKUP :pick response succeed =  "<< m_dispatch_command_map[m_primary_key_optimal].m_car_number << ", error= "<< t_error << " --- " << this;

			//删除 车辆表, 取车指令 完成后删除车辆信息
//			t_error = delete_vehicle_for_car_number();
			//删除车牌图片信息,
			t_error = update_parkspace_clear_car_number_info(0);
			//更新 车位状态, 找到车牌号, 写NULL
			t_error = update_parkspace_clear_car_number(0);
			//更新 指令队列, 根据车牌号 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
			t_error = update_command_queue_for_statu(2);
			//更新 记录表, 取车指令 完成后更新取车记录
			t_error =  updata_record_for_pick_end();
		}
		else if ( m_dispatch_process_type == Common_data::DISPATCH_PROCESS_REALLOCATE )
		{
			LOG(INFO) << " dispatch_response_to_sql DISPATCH_PROCESS_REALLOCATE :reallocate response succeed =  "<< m_dispatch_command_map[m_primary_key_optimal].m_car_number << ", error= "<< t_error << " --- " << this;
			//增加 车辆表, 存车指令 完成后添加车辆信息
//			t_error = insert_vehicle_for_car_number();
			//如果多次重新分配, 需要把之前申请的车位清除,
			for (int i = 0; i < m_dispatch_space_info_count; ++i)//改到答复成功，保留最后一个车位
			{
				//如果多次重新分配, 需要把之前申请的车位清除  //更新 车位状态, 找到车牌号, 写NULL
				t_error = update_parkspace_clear_car_number_by_id(m_dispatch_space_info[i].m_id, 10);
			}
			m_dispatch_space_info_count = 0;
			//更新车牌图片信息,
			update_parkspace_write_car_number_info(2);
			//更新 指令队列, 根据车牌号 删除指令
			t_error = delete_command_queue_for_car_number(m_dispatch_command_map[m_primary_key_optimal].m_car_number, m_dispatch_command_map[m_primary_key_optimal].m_type);
			//增加 记录表, 存车指令 完成后添加存车记录
			t_error =  updata_record_for_park_end();
		}
		else if ( m_dispatch_process_type == Common_data::DISPATCH_PROCESS_REVOCATION )
		{
			//20230810， 注意了：存车改到出口，和 取车改到出口， 逻辑不同
			if ( m_dispatch_command_map[m_primary_key_optimal].m_type == 1 )
			{
				//存车改到出口
				LOG(INFO) << " dispatch_response_to_sql DISPATCH_PROCESS_REVOCATION :revocation park response succeed =  "<< m_dispatch_command_map[m_primary_key_optimal].m_car_number << ", error= "<< t_error << " --- " << this;
				//如果多次重新分配, 需要把之前申请的车位清除,
				LOG(INFO)  << " huli test :::: 645645645 " << " m_dispatch_space_info_count = " << m_dispatch_space_info_count << this;
				for (int i = 0; i < m_dispatch_space_info_count+1; ++i)//撤销存车 答复成功，删除所有，包括最后一个车位
				{
					//如果多次重新分配, 需要把之前申请的车位清除  //更新 车位状态, 找到车牌号, 写NULL
					t_error = update_parkspace_clear_car_number_by_id(m_dispatch_space_info[i].m_id, 10);
				}
				m_dispatch_space_info_count = 0;
				//删除车牌图片信息,
				t_error = update_parkspace_clear_car_number_info(0);
				//更新 车位状态, 找到车牌号, 写NULL
				t_error = update_parkspace_clear_car_number(0);
				//更新 指令队列, 根据车牌号 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
				t_error = update_command_queue_for_statu(2);
				//更新 记录表, 取车指令 完成后更新取车记录, 撤销指令, 没有取车时间差
				t_error =  updata_record_for_pick_end_ex();
			}
			else if ( m_dispatch_command_map[m_primary_key_optimal].m_type == 2 )
			{
				//取车改到出口
				LOG(INFO) << " dispatch_response_to_sql DISPATCH_PROCESS_REVOCATION :revocation pick response succeed =  "<< m_dispatch_command_map[m_primary_key_optimal].m_car_number << ", error= "<< t_error << " --- " << this;

				m_dispatch_space_info_count = 0;
				//删除车牌图片信息,
				t_error = update_parkspace_clear_car_number_info(0);
				//更新 车位状态, 找到车牌号, 写NULL
				t_error = update_parkspace_clear_car_number(0);
				//更新 指令队列, 根据车牌号 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
				t_error = update_command_queue_for_statu(2);
				//更新 记录表, 取车指令 完成后更新取车记录
				t_error =  updata_record_for_pick_end();
			}
		}
		else
		{
			return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
								 " fun error ");
		}

		return t_error;
	}
	else
	{
		//调度失败, 回退 数据库
		if ( m_dispatch_process_type == Common_data::DISPATCH_PROCESS_STORE )
		{
			LOG(INFO) << " dispatch_response_to_sql DISPATCH_PROCESS_STORE :park response fail =  "<< m_dispatch_command_map[m_primary_key_optimal].m_car_number << ", error= "<< t_error << " --- " << this;
			//删除车牌图片信息,
			update_parkspace_clear_car_number_info(0);
			//更新 车位状态, 找到车牌号, 写NULL
			update_parkspace_clear_car_number(0);
			//更新 指令队列, 根据车牌号 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
			update_command_queue_for_statu(3);
		}
		else if ( m_dispatch_process_type == Common_data::DISPATCH_PROCESS_PICKUP )
		{
			LOG(INFO) << " dispatch_response_to_sql DISPATCH_PROCESS_PICKUP :pick response fail =  "<< m_dispatch_command_map[m_primary_key_optimal].m_car_number << ", error= "<< t_error << " --- " << this;
			//更新 指令队列, 根据车牌号 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
			update_command_queue_for_statu(3);
		}
		else if ( m_dispatch_process_type == Common_data::DISPATCH_PROCESS_REALLOCATE )
		{
			LOG(INFO) << " dispatch_response_to_sql DISPATCH_PROCESS_STORE :reallocate response fail =  "<< t_error << " --- " << this;
			//如果多次重新分配, 需要把之前申请的车位清除,
			for (int i = 0; i < m_dispatch_space_info_count+1; ++i)//改到答复失败，删除所有，包括最后一个车位
			{
				//如果多次重新分配, 需要把之前申请的车位清除  //更新 车位状态, 找到车牌号, 写NULL
				t_error = update_parkspace_clear_car_number_by_id(m_dispatch_space_info[i].m_id, 10);
			}
			m_dispatch_space_info_count = 0;
			//删除车牌图片信息,
			update_parkspace_clear_car_number_info(0);
			//更新 车位状态, 找到车牌号, 写NULL
			update_parkspace_clear_car_number(0);
			//更新 指令队列, 根据车牌号 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
			update_command_queue_for_statu(3);
		}
		else if ( m_dispatch_process_type == Common_data::DISPATCH_PROCESS_REVOCATION )
		{
			//20230810， 注意了：存车改到出口，和 取车改到出口， 逻辑不同
			if ( m_dispatch_command_map[m_primary_key_optimal].m_type == 1 )
			{
				//存车改到出口
				LOG(INFO) << " dispatch_response_to_sql DISPATCH_PROCESS_PICKUP :revocation park response fail =  "
						  << m_dispatch_command_map[m_primary_key_optimal].m_car_number << ", error= " << t_error
						  << " --- " << this;
				//如果多次重新分配, 需要把之前申请的车位清除,
				for (int i = 0; i < m_dispatch_space_info_count + 1; ++i)//撤销存车 答复失败，删除所有，包括最后一个车位
				{
					//如果多次重新分配, 需要把之前申请的车位清除  //更新 车位状态, 找到车牌号, 写NULL
					t_error = update_parkspace_clear_car_number_by_id(m_dispatch_space_info[i].m_id, 10);
				}
				m_dispatch_space_info_count = 0;
				//删除车牌图片信息,
				update_parkspace_clear_car_number_info(0);
				//更新 车位状态, 找到车牌号, 写NULL
				update_parkspace_clear_car_number(0);
				//更新 指令队列, 根据车牌号 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
				update_command_queue_for_statu(3);
			}
			else if ( m_dispatch_command_map[m_primary_key_optimal].m_type == 2 )
			{
				//取车改到出口
				LOG(INFO) << " dispatch_response_to_sql DISPATCH_PROCESS_PICKUP :revocation pick response fail =  "
						  << m_dispatch_command_map[m_primary_key_optimal].m_car_number << ", error= " << t_error
						  << " --- " << this;
				//更新 指令队列, 根据车牌号 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
				update_command_queue_for_statu(3);
			}
		}
		else
		{
			return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
								 " fun error ");
		}
	}

	return Error_code::SUCCESS;
}

//调度 , 向数据库 重新分配车位,
Error_manager Dispatch_command::dispatch_reallocate_to_sql(int height_level, int wheel_base_level, int outlet_ready)
{
	std::unique_lock<std::mutex> t_lock(m_lock);
	Error_manager t_error;
	Error_manager t_error2;

//	m_outlet_ready = outlet_ready;//只有创建取车任务成功之后，才能确认出口被使用。


	//重新申请车位
	//查询空闲车位最优解,    存车指令 根据调度指令最优解 获取 空闲车位最优解
	//huli 20230703, 重大问题，  必须在 query_dispatch_space_optimal_ex 找到车位返回成功之后，才能 计数+1
	m_dispatch_space_info_count = m_dispatch_space_info_count +1;

	//重新申请车位时，做好保护。。。。。
	int t_height_level_reallocate = m_dispatch_command_map[m_primary_key_optimal].m_height_level;
	//自身等级和请求等级，取最大值
	if ( t_height_level_reallocate < height_level )
	{
		t_height_level_reallocate = height_level;
	}
		//如果请求等级为0，并且请求次数>=2, 那么申请更大的车位。
	else if ( t_height_level_reallocate < CAR_HEIGHT_LEVEL_MAX &&
			  m_dispatch_space_info_count >= 3)
	{
		t_height_level_reallocate++;
	}

	int t_wheel_base_level_reallocate = m_dispatch_command_map[m_primary_key_optimal].m_wheel_base_level;
	//自身等级和请求等级，取最大值
	if ( t_wheel_base_level_reallocate < wheel_base_level )
	{
		t_wheel_base_level_reallocate = wheel_base_level;
	}
		//如果请求等级为0，并且请求次数>=2, 那么申请更大的车位。
	else if ( t_wheel_base_level_reallocate < CAR_WHEEL_BASE_LEVEL_MAX &&
			  m_dispatch_space_info_count >= 3)
	{
		t_wheel_base_level_reallocate++;
	}

	t_error = query_dispatch_space_optimal_ex(m_dispatch_id, t_height_level_reallocate, t_wheel_base_level_reallocate, m_dispatch_space_info[m_dispatch_space_info_count]);


	if ( t_error != Error_code::SUCCESS )
	{
//		std::cout << " huli test :::: grgsrvsrysvtgdg" << " outlet_ready = " << outlet_ready << std::endl;

		//huli 20230703, 重大问题，  必须在 query_dispatch_space_optimal_ex 找到车位返回成功之后，才能 计数+1
		m_dispatch_space_info_count = m_dispatch_space_info_count -1;

		//没找到车位, 就把车放到出口
		if ( outlet_ready != 0 )
		{
			m_dispatch_process_type = Common_data::DISPATCH_PROCESS_REVOCATION;

			//补充出口id
			m_outlet_ready = outlet_ready;//只有创建取车任务成功之后，才能确认出口被使用。
			m_dispatch_command_map[m_primary_key_optimal].m_export_id = outlet_ready;

			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_id(0);
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_serial_id(0);
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_table_id(0);
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_unit_id(0);
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_floor(0);
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_room_id(0);
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_height(0);
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_string = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.DebugString();

			//更新 指令队列, 根据车牌号 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
//			t_error = update_command_queue_for_statu(1);
			//制作取车表单
			t_error = create_pick_table(outlet_ready);
			m_height_level = m_dispatch_command_map[m_primary_key_optimal].m_height_level;
			m_wheel_base_level = m_dispatch_command_map[m_primary_key_optimal].m_wheel_base_level;
			LOG(INFO) << " create_pick_table :revocation to outlet =  "<< m_pick_table_msg.DebugString() << " --- " << this;

			return t_error;
		}
		else
		{
			//无限等待, 等待出口空闲
			return Error_code::NODATA;
		}
	}
	else
	{
		//huli 20230703, 重大问题，  必须在 query_dispatch_space_optimal_ex 找到车位返回成功之后，才能 计数+1

		m_dispatch_process_type = Common_data::DISPATCH_PROCESS_REALLOCATE;

		//找到新的车位, 重新执行任务
		m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_id(m_dispatch_space_info[m_dispatch_space_info_count].m_id);
		m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_serial_id(m_dispatch_space_info[m_dispatch_space_info_count].m_serial_id);
		m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_table_id(m_dispatch_space_info[m_dispatch_space_info_count].m_table_id);
		m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_unit_id(m_dispatch_space_info[m_dispatch_space_info_count].m_unit);
		m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_floor(m_dispatch_space_info[m_dispatch_space_info_count].m_floor);
		m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_room_id(m_dispatch_space_info[m_dispatch_space_info_count].m_room_id);
		m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.set_height(m_dispatch_space_info[m_dispatch_space_info_count].m_height);
		m_dispatch_command_map[m_primary_key_optimal].m_space_info_string = m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.DebugString();
		//更新 车位状态, 根据车位ID 写入车牌号即可
		t_error = update_parkspace_write_car_number(1);
		//更新 指令队列, 根据车牌号 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
//		t_error = update_command_queue_for_statu(1);
		//制作存车表单

		if ( m_dispatch_command_map[m_primary_key_optimal].m_type == 1 )
		{
			t_error = create_park_table(m_dispatch_command_map[m_primary_key_optimal].m_import_id);
		}
		else if ( m_dispatch_command_map[m_primary_key_optimal].m_type == 2 )
		{
			t_error = create_park_table(m_dispatch_command_map[m_primary_key_optimal].m_export_id);
		}



		m_height_level = m_dispatch_command_map[m_primary_key_optimal].m_height_level;
		m_wheel_base_level = m_dispatch_command_map[m_primary_key_optimal].m_wheel_base_level;

		LOG(INFO) << " create_park_table :reallocate to new space =  "<< m_park_table_msg.DebugString() << " --- " << this;
	}

	return Error_code::SUCCESS;
}


//检查出口是否空闲, 检查指令队列的取车完成的出口id是否存在, 不存在就是空闲,返回成功
Error_manager Dispatch_command::check_export_id_is_ready(int export_id)
{
	std::unique_lock<std::mutex> t_lock(m_lock);
	//检查指令队列, 查询指定单元的取车完成状态指令的 出口id是否存在
	char check_export_id_sql[DB_SQL_SIZE];
	memset(check_export_id_sql, 0, DB_SQL_SIZE);
	sprintf(check_export_id_sql,"select * from command_queue where statu = 2 and type = 2 and export_id = %d",export_id);
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager t_error = Database_controller::get_instance_pointer()->sql_query(check_export_id_sql, tp_result);

	if(t_error == Error_code::SUCCESS)
	{
		if (tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}

		//如果存在, 就报错,   不存在就是空闲,返回成功
		if ( tp_result->next() )
		{
			return Error_manager(Error_code::DB_QUERY_OUTLET_OCCUPY, Error_level::MINOR_ERROR,
								 " check_export_id_is_ready fun error, 数据库 查询出口被占用 ");
		}
		else
		{
			return Error_code::SUCCESS;
		}
	}
	else
	{
		return t_error;
	}
	return Error_code::SUCCESS;
}

//检查出口取车是否完成, 指定的出口有取车完成指令就返回成功, 否则报错.
Error_manager Dispatch_command::check_pickup_is_finish(int unit_id, int export_id)
{
	std::unique_lock<std::mutex> t_lock(m_lock);
	//检查指令队列, 查询指定单元的取车完成状态指令的 出口id是否存在
	char check_export_id_sql[DB_SQL_SIZE];
	memset(check_export_id_sql, 0, DB_SQL_SIZE);
	sprintf(check_export_id_sql,"select * from command_queue where statu = 2 and unit = %d and export_id = %d",unit_id, export_id);
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager t_error = Database_controller::get_instance_pointer()->sql_query(check_export_id_sql, tp_result);

	if(t_error == Error_code::SUCCESS)
	{
		if (tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}

		//如果存在, 就报错,   不存在就是空闲,返回成功
		if ( tp_result->next() )
		{
			return Error_code::SUCCESS;
		}
		else
		{
			return Error_manager(Error_code::DB_QUERY_OUTLET_OCCUPY, Error_level::MINOR_ERROR,
								 " check_export_id_is_ready fun error, 数据库 查询出口被占用 ");
		}
	}
	else
	{
		return t_error;
	}
	return Error_code::SUCCESS;
}

//检查入口存车是否开始, 指定的入口有存车开始指令就返回成功, 否则报错.
Error_manager Dispatch_command::check_park_is_start(int import_id)
{
	std::unique_lock<std::mutex> t_lock(m_lock);
	//检查指令队列, 查询指定单元的取车完成状态指令的 出口id是否存在
	char check_export_id_sql[DB_SQL_SIZE];
	memset(check_export_id_sql, 0, DB_SQL_SIZE);
	sprintf(check_export_id_sql,"select * from command_queue where type = 1 and import_id = %d and (statu=0 or statu =1)",import_id);
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager t_error = Database_controller::get_instance_pointer()->sql_query(check_export_id_sql, tp_result);

	if(t_error == Error_code::SUCCESS)
	{
		if (tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}

		//如果存在, 就报错,   不存在就是空闲,返回成功
		if ( tp_result->next() )
		{
			return Error_code::SUCCESS;
		}
		else
		{
			return Error_manager(Error_code::DB_QUERY_OUTLET_OCCUPY, Error_level::MINOR_ERROR,
								 " check_export_id_is_ready fun error, 数据库 查询出口被占用 ");
		}
	}
	else
	{
		return t_error;
	}
	return Error_code::SUCCESS;
}

//获取指定入口的 存车流程的 唯一码,
Error_manager Dispatch_command::get_primary_key_for_store(int import_id, std::string & primary_key )
{
	std::unique_lock<std::mutex> t_lock(m_lock);
	//检查指令队列, 查询指定单元的取车完成状态指令的 出口id是否存在
	char check_export_id_sql[DB_SQL_SIZE];
	memset(check_export_id_sql, 0, DB_SQL_SIZE);
	sprintf(check_export_id_sql,"select * from command_queue where type = 1 and import_id = %d and (statu=0 or statu =1)",import_id);
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager t_error = Database_controller::get_instance_pointer()->sql_query(check_export_id_sql, tp_result);

	if(t_error == Error_code::SUCCESS)
	{
		if (tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}

		//如果存在, 就报错,   不存在就是空闲,返回成功
		if ( tp_result->next() )
		{
			char buf[DB_SQL_SIZE];
			memset(buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据
				primary_key = tp_result->getString("primary_key");
			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(), e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			return Error_code::SUCCESS;
		}
		else
		{
			return Error_manager(Error_code::DB_QUERY_OUTLET_OCCUPY, Error_level::MINOR_ERROR,
								 " check_export_id_is_ready fun error, 数据库 查询出口被占用 ");
		}
	}
	else
	{
		return t_error;
	}
	return Error_code::SUCCESS;
}

//查重 指令队列， 根据存车终端id。
Error_manager Dispatch_command::check_command_queue_for_terminal_id(int unit_id, int terminal_id)
{
	//查重 指令队列
	char query_command_queue_sql[DB_SQL_SIZE];
	memset(query_command_queue_sql, 0, DB_SQL_SIZE);
	int t_statu = 0; //车位状态, 0可用, 1故障
	sprintf(query_command_queue_sql,"select * from command_queue where unit = %d and terminal_id = %d ", unit_id, terminal_id );
//	std::cout<<"query_parkspace_sql = "<<query_parkspace_sql<<std::endl;
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_query(query_command_queue_sql, tp_result);
	if(ec == SUCCESS)
	{
		if(tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}
		//只取第一条结果, 默认是id最小的,
		if (tp_result->next())
		{
			char buf[DB_SQL_SIZE];
			memset(buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据

			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(), e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
		}
		else
		{
			return Error_manager(Error_code::DB_QUERY_NOT_DATA, Error_level::MINOR_ERROR,
								 "数据库未查询到数据 Parkspace_operating_function::query_one_parkspace_with_license error ");

		}
		return SUCCESS;
	}
	else
	{
		return ec;
	}
	return SUCCESS;
}

//删除 指令队列, 根据出口编号
Error_manager Dispatch_command::delete_command_queue_for_export_id(int unit_id, int export_id)
{
	std::unique_lock<std::mutex> t_lock(m_lock);

	char delete_command_sql[DB_SQL_SIZE];
	memset(delete_command_sql, 0, DB_SQL_SIZE);
	sprintf(delete_command_sql, "delete from command_queue where statu = 2 and unit = %d and export_id = %d ",
			unit_id, export_id );
	Error_manager ec = Database_controller::get_instance_pointer()->sql_delete(delete_command_sql);
	return ec;
}

//查重 指令队列， 根据存车唯一码
Error_manager Dispatch_command::check_command_queue_for_primary_key(int unit_id, std::string primary_key, int type, int statu)
{
	//查重 指令队列
	char query_command_queue_sql[DB_SQL_SIZE];
	memset(query_command_queue_sql, 0, DB_SQL_SIZE);
	int t_statu = 0; //车位状态, 0可用, 1故障
	sprintf(query_command_queue_sql,"select * from command_queue where unit = %d and primary_key = '%s' and type = %d and statu = %d",
	unit_id, primary_key.c_str(), type, statu );
//	std::cout<<"query_parkspace_sql = "<<query_parkspace_sql<<std::endl;
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_query(query_command_queue_sql, tp_result);
	if(ec == SUCCESS)
	{
		if(tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}
		//只取第一条结果, 默认是id最小的,
		if (tp_result->next())
		{
			char buf[DB_SQL_SIZE];
			memset(buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据

			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(), e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
		}
		else
		{
			return Error_manager(Error_code::DB_QUERY_NOT_DATA, Error_level::MINOR_ERROR,
								 "数据库未查询到数据 Parkspace_operating_function::query_one_parkspace_with_license error ");

		}
		return SUCCESS;
	}
	else
	{
		return ec;
	}
	return SUCCESS;
}

//查询 指令队列,    取车指令 根据唯一码 恢复指令表
Error_manager Dispatch_command::query_command_queue_for_primary_key_ex(std::string primary_key, Dispatch_command_info & dispatch_command_info)
{
	//查重 指令队列
	char query_command_queue_sql[DB_SQL_SIZE];
	memset(query_command_queue_sql, 0, DB_SQL_SIZE);
	int t_statu = 0; //车位状态, 0可用, 1故障
	sprintf(query_command_queue_sql,"select * from command_queue where primary_key = '%s' ",primary_key.c_str());
//	std::cout<<"query_parkspace_sql = "<<query_parkspace_sql<<std::endl;
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_query(query_command_queue_sql, tp_result);
	if(ec == SUCCESS)
	{
		if(tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}
		//只取第一条结果, 默认是id最小的,
		if (tp_result->next())
		{
			char buf[DB_SQL_SIZE];
			memset(buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据
				dispatch_command_info.m_unit = tp_result->getInt("unit");
				dispatch_command_info.m_car_number = tp_result->getString("car_number");
				dispatch_command_info.m_height_level = tp_result->getInt("height_level");
				dispatch_command_info.m_height = tp_result->getDouble("height");
				dispatch_command_info.m_wheel_base_level = tp_result->getInt("wheel_base_level");
				dispatch_command_info.m_wheel_base = tp_result->getDouble("wheel_base");

				dispatch_command_info.m_import_id = tp_result->getInt("import_id");
				dispatch_command_info.m_export_id = tp_result->getInt("export_id");

				std::string parkspace_info_string = tp_result->getString("space_info");
				if(! google::protobuf::TextFormat::ParseFromString(parkspace_info_string, &dispatch_command_info.m_space_info_msg))
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "ParseFromString fun error, m_space_info ");
				}

				std::string measure_buffer_string = tp_result->getString("measure_buffer");
				if(! google::protobuf::TextFormat::ParseFromString(measure_buffer_string, &dispatch_command_info.m_measure_buffer_msg))
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "ParseFromString fun error, m_space_info ");
				}
			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(), e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
		}
		else
		{
			return Error_manager(Error_code::DB_QUERY_NOT_DATA, Error_level::MINOR_ERROR,
								 "数据库未查询到数据 Parkspace_operating_function::query_one_parkspace_with_license error ");

		}
		return SUCCESS;
	}
	else
	{
		return ec;
	}
	return SUCCESS;
}


//添加plc数据储存
Error_manager Dispatch_command::insert_plc_data(std::string plc_data, float hearbeat)
{
	std::unique_lock<std::mutex> t_lock(m_lock);
	char insert_vehicle_sql[4096];
	memset(insert_vehicle_sql, 0, 4096);
	sprintf(insert_vehicle_sql, "INSERT INTO plc_data (data, hearbeat) values ('%s',%f)",
			plc_data.c_str(), hearbeat  );
	Error_manager ec = Database_controller::get_instance_pointer()->sql_insert(insert_vehicle_sql);
	std::cout << " huli test :::: " << " ec = " << ec << std::endl;
	return ec;
}

//查重 存车的车位检查是否重复， where is car_number or primary_key
Error_manager Dispatch_command::check_dispatch_space_for_car_number_or_primary_key(std::string car_number, std::string primary_key)
{
//查询车位表
	char query_parkspace_sql[DB_SQL_SIZE];
	memset(query_parkspace_sql, 0, DB_SQL_SIZE);
	int t_statu = 0; //车位状态, 0可用, 1故障
	sprintf(query_parkspace_sql,"select * from space where car_number = '%s' or primary_key = '%s' ",car_number.c_str(), primary_key.c_str());
//	std::cout<<"query_parkspace_sql = "<<query_parkspace_sql<<std::endl;
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_query(query_parkspace_sql, tp_result);
	if(ec == SUCCESS)
	{
		if(tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}
		//只取第一条结果, 默认是id最小的,
		if (tp_result->next())
		{
			char buf[DB_SQL_SIZE];
			memset(buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据

			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(), e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
		}
		else
		{
			return Error_manager(Error_code::DB_QUERY_NOT_DATA, Error_level::MINOR_ERROR,
								 "数据库未查询到数据 Parkspace_operating_function::query_one_parkspace_with_license error ");

		}
		return SUCCESS;
	}
	else
	{
		return ec;
	}
	return SUCCESS;
}

//查询 取车的车位    取车指令 根据车牌号 查询对应的车位
Error_manager Dispatch_command::query_dispatch_space_for_car_number(std::string car_number, parkspace_info & parkspace_info, measure_buffer & measure_buffer)
{
//查询车位表
	char query_parkspace_sql[DB_SQL_SIZE];
	memset(query_parkspace_sql, 0, DB_SQL_SIZE);
	int t_statu = 0; //车位状态, 0可用, 1故障
	sprintf(query_parkspace_sql,"select * from space where car_number = '%s' ",car_number.c_str());
//	std::cout<<"query_parkspace_sql = "<<query_parkspace_sql<<std::endl;
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_query(query_parkspace_sql, tp_result);
	if(ec == SUCCESS)
	{
		if(tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}
		//只取第一条结果, 默认是id最小的,
		if (tp_result->next())
		{
			char buf[DB_SQL_SIZE];
			memset(buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据
				parkspace_info.set_id(tp_result->getInt("id"));
				parkspace_info.set_serial_id(tp_result->getInt("serial_id"));
				parkspace_info.set_table_id( tp_result->getInt("table_id"));
				parkspace_info.set_unit_id( tp_result->getInt("unit"));
				parkspace_info.set_floor( tp_result->getInt("floor"));
				parkspace_info.set_room_id( tp_result->getInt("room_id"));
				parkspace_info.set_height(tp_result->getDouble("height"));

				//解析数据
				std::string measure_buffer_string = tp_result->getString("measure_buffer");

				//取车, 数据库特有车位信息
				if(! google::protobuf::TextFormat::ParseFromString(measure_buffer_string, &measure_buffer))
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "ParseFromString fun error, m_space_info ");
				}
			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(), e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
		}
		else
		{
			return Error_manager(Error_code::DB_QUERY_NOT_DATA, Error_level::MINOR_ERROR,
								 "数据库未查询到数据 Parkspace_operating_function::query_one_parkspace_with_license error ");

		}
		return SUCCESS;
	}
	else
	{
		return ec;
	}
	return SUCCESS;
}


//查询 取车的车位    取车指令 根据唯一码 查询对应的车位
Error_manager Dispatch_command::query_dispatch_space_for_primary_key(std::string primary_key, parkspace_info & parkspace_info, measure_buffer & measure_buffer)
{
//查询车位表
	char query_parkspace_sql[DB_SQL_SIZE];
	memset(query_parkspace_sql, 0, DB_SQL_SIZE);
	int t_statu = 0; //车位状态, 0可用, 1故障
	sprintf(query_parkspace_sql,"select * from space where primary_key = '%s' ",primary_key.c_str());
//	std::cout<<"query_parkspace_sql = "<<query_parkspace_sql<<std::endl;
//	LOG(INFO) << " ++++++++++++++++++++++++++++++++++++ query_parkspace_sql =  "<< query_parkspace_sql << " --- " << this;
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_query(query_parkspace_sql, tp_result);
	if(ec == SUCCESS)
	{
		if(tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}
		//只取第一条结果, 默认是id最小的,
		if (tp_result->next())
		{
			char buf[DB_SQL_SIZE];
			memset(buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据
				parkspace_info.set_id(tp_result->getInt("id"));
				parkspace_info.set_serial_id(tp_result->getInt("serial_id"));
				parkspace_info.set_table_id( tp_result->getInt("table_id"));
				parkspace_info.set_unit_id( tp_result->getInt("unit"));
				parkspace_info.set_floor( tp_result->getInt("floor"));
				parkspace_info.set_room_id( tp_result->getInt("room_id"));
				parkspace_info.set_height(tp_result->getDouble("height"));

				//解析数据
				std::string measure_buffer_string = tp_result->getString("measure_buffer");

				//取车, 数据库特有车位信息
				if(! google::protobuf::TextFormat::ParseFromString(measure_buffer_string, &measure_buffer))
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "ParseFromString fun error, m_space_info ");
				}
			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(), e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
		}
		else
		{
			return Error_manager(Error_code::DB_QUERY_NOT_DATA, Error_level::MINOR_ERROR,
								 "数据库未查询到数据 Parkspace_operating_function::query_one_parkspace_with_license error ");

		}
		return SUCCESS;
	}
	else
	{
		return ec;
	}
	return SUCCESS;
}

//查询 取车的车位    取车指令 根据唯一码 恢复指令表
Error_manager Dispatch_command::query_dispatch_space_for_primary_key_ex(std::string primary_key, Dispatch_command_info & dispatch_command_info)
{
	//查询车位表
	char query_parkspace_sql[DB_SQL_SIZE];
	memset(query_parkspace_sql, 0, DB_SQL_SIZE);
	int t_statu = 0; //车位状态, 0可用, 1故障
	sprintf(query_parkspace_sql,"select * from space where primary_key = '%s' ",primary_key.c_str());
//	std::cout<<"query_parkspace_sql = "<<query_parkspace_sql<<std::endl;
//	LOG(INFO) << " ++++++++++++++++++++++++++++++++++++ query_parkspace_sql =  "<< query_parkspace_sql << " --- " << this;
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_query(query_parkspace_sql, tp_result);
	if(ec == SUCCESS)
	{
		if(tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}
		//只取第一条结果, 默认是id最小的,
		if (tp_result->next())
		{
			char buf[DB_SQL_SIZE];
			memset(buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据
				dispatch_command_info.m_car_number = tp_result->getString("car_number");
				dispatch_command_info.m_height_level = tp_result->getInt("height_level");
				dispatch_command_info.m_height = tp_result->getDouble("height");
				dispatch_command_info.m_wheel_base_level = tp_result->getInt("wheel_base_level");
				dispatch_command_info.m_wheel_base = tp_result->getDouble("wheel_base");

				std::string parkspace_info_string = tp_result->getString("space_info");
				if(! google::protobuf::TextFormat::ParseFromString(parkspace_info_string, &dispatch_command_info.m_space_info_msg))
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "ParseFromString fun error, m_space_info ");
				}

				std::string measure_buffer_string = tp_result->getString("measure_buffer");
				if(! google::protobuf::TextFormat::ParseFromString(measure_buffer_string, &dispatch_command_info.m_measure_buffer_msg))
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "ParseFromString fun error, m_space_info ");
				}
			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(), e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
		}
		else
		{
			return Error_manager(Error_code::DB_QUERY_NOT_DATA, Error_level::MINOR_ERROR,
								 "数据库未查询到数据 Parkspace_operating_function::query_one_parkspace_with_license error ");

		}
		return SUCCESS;
	}
	else
	{
		return ec;
	}
	return SUCCESS;
}

//查询 取车的车辆感测信息    取车指令 根据key 查询感测信息, 楚天旧版
Error_manager Dispatch_command::query_dispatch_vehicle_for_primary_key(std::string primary_key, measure_buffer & measure_buffer)
{
	//查询 车辆表
	char query_parkspace_sql[DB_SQL_SIZE];
	memset(query_parkspace_sql, 0, DB_SQL_SIZE);
	int t_statu = 0; //车位状态, 0可用, 1故障
	sprintf(query_parkspace_sql,"select * from vehicle where primary_key = '%s' ",primary_key.c_str());
//	std::cout<<"query_parkspace_sql = "<<query_parkspace_sql<<std::endl;
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_query(query_parkspace_sql, tp_result);
	if(ec == SUCCESS)
	{
		if(tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}
		//只取第一条结果, 默认是id最小的,
		if (tp_result->next())
		{
			char buf[DB_SQL_SIZE];
			memset(buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据
				std::string measure_buffer_string = tp_result->getString("actually_measure_buffer");

				//取车, 数据库特有车位信息
				if(! google::protobuf::TextFormat::ParseFromString(measure_buffer_string, &measure_buffer))
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "ParseFromString fun error, m_space_info ");
				}
			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(), e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
		}
		else
		{
			return Error_manager(Error_code::DB_QUERY_NOT_DATA, Error_level::MINOR_ERROR,
								 "数据库未查询到数据 Parkspace_operating_function::query_one_parkspace_with_license error ");

		}
		return SUCCESS;
	}
	else
	{
		return ec;
	}
	return SUCCESS;
}

//获取调度指令, 与数据库同步 command_queue, statu指令状态, 0:排队等待, 1正在运行, 2:已经完成
Error_manager Dispatch_command::query_all_dispatch_command(int statu)
{
	//从command_queue获取所有排队的指令,
	char query_all_dispatch_command_sql[DB_SQL_SIZE];
	memset(query_all_dispatch_command_sql, 0, DB_SQL_SIZE);
	sprintf(query_all_dispatch_command_sql,"select * from command_queue where statu = %d and unit = %d",statu, m_unit);
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager t_error = Database_controller::get_instance_pointer()->sql_query(query_all_dispatch_command_sql, tp_result);

	m_dispatch_command_map.clear();
	unsigned short			t_wait_small_park_count = 0;			//排队小车存车的数量
	unsigned short			t_wait_middle_park_count = 0;			//排队中车存车的数量
	unsigned short			t_wait_big_park_count = 0;				//排队大车存车的数量
	unsigned short			t_wait_total_park_count = 0;			//排队总车存车的数量
	unsigned short			t_wait_small_pick_count = 0;			//排队小车存车的数量
	unsigned short			t_wait_middle_pick_count = 0;			//排队中车存车的数量
	unsigned short			t_wait_big_pick_count = 0;				//排队大车存车的数量
	unsigned short			t_wait_total_pick_count = 0;			//排队总车存车的数量

	if(t_error == Error_code::SUCCESS)
	{
		if (tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}



		//循环检查所有行
		while (tp_result->next())
		{
			Dispatch_command_info t_dispatch_command_info;
			char t_error_buf[DB_SQL_SIZE];
			memset(t_error_buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据
				t_dispatch_command_info.m_car_number = tp_result->getString("car_number");
				t_dispatch_command_info.m_primary_key = tp_result->getString("primary_key");
				t_dispatch_command_info.m_unit = tp_result->getInt("unit");
				t_dispatch_command_info.m_terminal_id = tp_result->getInt("terminal_id");
				t_dispatch_command_info.m_queue_id = tp_result->getInt("queue_id");
				t_dispatch_command_info.m_type = tp_result->getInt("type");
				t_dispatch_command_info.m_statu = tp_result->getInt("statu");
				t_dispatch_command_info.m_export_id = tp_result->getInt("export_id");
				t_dispatch_command_info.m_import_id = tp_result->getInt("import_id");
				t_dispatch_command_info.m_height_level = tp_result->getInt("height_level");
				t_dispatch_command_info.m_height = tp_result->getDouble("height");
				t_dispatch_command_info.m_wheel_base_level = tp_result->getInt("wheel_base_level");
				t_dispatch_command_info.m_wheel_base = tp_result->getDouble("wheel_base");
				t_dispatch_command_info.m_space_info_string = tp_result->getString("space_info");
				t_dispatch_command_info.m_measure_buffer_string = tp_result->getString("measure_buffer");

				t_dispatch_command_info.m_car_number_info_msg.set_plate_color(tp_result->getString("plate_color") );
				t_dispatch_command_info.m_car_number_info_msg.set_plate_type(tp_result->getString("plate_type") );
				t_dispatch_command_info.m_car_number_info_msg.set_plate_confidence(tp_result->getInt("plate_confidence") );
				t_dispatch_command_info.m_car_number_info_msg.set_recognition_time(tp_result->getString("recognition_time") );
				t_dispatch_command_info.m_car_number_info_msg.set_plate_full_image(tp_result->getString("plate_full_image") );
				t_dispatch_command_info.m_car_number_info_msg.set_plate_clip_image(tp_result->getString("plate_clip_image") );
				t_dispatch_command_info.m_car_number_info_string = t_dispatch_command_info.m_car_number_info_msg.DebugString();

				//存车, 数据库特有 雷达信息,  没有车位信息, 需要根据车高,再去车位表申请车位
				if(! google::protobuf::TextFormat::ParseFromString(t_dispatch_command_info.m_measure_buffer_string, &t_dispatch_command_info.m_measure_buffer_msg))
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "ParseFromString fun error, m_measure_buffer ");
				}
				//取车, 数据库特有车位信息
				if(! google::protobuf::TextFormat::ParseFromString(t_dispatch_command_info.m_space_info_string, &t_dispatch_command_info.m_space_info_msg))
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "ParseFromString fun error, m_space_info ");
				}
				//取车, 数据库特有 车牌图片信息
//				if(! google::protobuf::TextFormat::ParseFromString(t_dispatch_command_info.m_car_number_info_string, &t_dispatch_command_info.m_car_number_info_msg))
//				{
//					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
//										 "ParseFromString fun error, m_space_info ");
//				}
//				if(! t_dispatch_command_info.m_car_number_info_msg.ParseFromString(t_dispatch_command_info.m_car_number_info_string) )
//				{
//					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
//										 "ParseFromString fun error, m_space_info ");
//				}



				//m_type指令类型, 0无效, 1存车, 2取车,
				if ( t_dispatch_command_info.m_type == 1)
				{
					t_dispatch_command_info.m_useless_distance = m_device_floor-1;
				}
				else if ( t_dispatch_command_info.m_type == 2 )
				{
					t_dispatch_command_info.m_useless_distance = t_dispatch_command_info.m_space_info_msg.floor()-m_device_floor;
				}
				else
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "command_queue m_type error ");
				}

				if ( t_dispatch_command_info.m_useless_distance <0 )
				{
					t_dispatch_command_info.m_useless_distance = 0-t_dispatch_command_info.m_useless_distance;
				}

				//20230813, huli 如果有同一辆车， 又存又取， 那么只保留存车，保证先存后取
				if ( m_dispatch_command_map.find(t_dispatch_command_info.m_primary_key) == m_dispatch_command_map.end() )
				{
					//没找到，就加入map
					m_dispatch_command_map[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
				}
				else if( m_dispatch_command_map[t_dispatch_command_info.m_primary_key].m_type == 2 )
				{
					//找到取车，就用新的覆盖
					m_dispatch_command_map[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
				}
				//else //找到存车，保留存车的


				//20230811, huli 改到 query_all_dispatch_command_ex()
				//huli 20230612, 统计排队信息
//				if ( t_dispatch_command_info.m_type == 1 )
//				{
//					if ( t_dispatch_command_info.m_height_level == 1)
//					{
//						t_wait_small_park_count++;
//					}
//					if ( t_dispatch_command_info.m_height_level == 2)
//					{
//						t_wait_middle_park_count++;
//					}
//					if ( t_dispatch_command_info.m_height_level == 3)
//					{
//						t_wait_big_park_count++;
//					}
//				}
//				if ( t_dispatch_command_info.m_type == 2 )
//				{
//					if ( t_dispatch_command_info.m_height_level == 1 )
//					{
//						t_wait_small_pick_count++;
//					}
//					if ( t_dispatch_command_info.m_height_level == 2)
//					{
//						t_wait_middle_pick_count++;
//					}
//					if ( t_dispatch_command_info.m_height_level == 3)
//					{
//						t_wait_big_pick_count++;
//					}
//				}
			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(t_error_buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(),
						e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, t_error_buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(t_error_buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, t_error_buf);
			}
		}

		//20230811, huli 改到 query_all_dispatch_command_ex()
//		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_small_park_count = t_wait_small_park_count;
//		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_middle_park_count = t_wait_middle_park_count;
//		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_big_park_count = t_wait_big_park_count;
//		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_total_park_count = t_wait_small_park_count + t_wait_middle_park_count + t_wait_big_park_count;
//		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_small_pick_count = t_wait_small_pick_count;
//		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_middle_pick_count = t_wait_middle_pick_count;
//		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_big_pick_count = t_wait_big_pick_count;
//		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_total_pick_count = t_wait_small_pick_count + t_wait_middle_pick_count + t_wait_big_pick_count;
//		return SUCCESS;
	}
	else
	{
		return t_error;
	}

	return Error_code::SUCCESS;
}

//对调度指令进行排序, 选出最优解, 比较存车和取车
Error_manager Dispatch_command::sort_dispatch_command_for_total(int plc_park_priority)
{
	int t_optimal_loss=0x7fffffff;		//最优loss值
	m_primary_key_optimal.clear();

	//筛选最优任务
	for (auto iter = m_dispatch_command_map.begin(); iter != m_dispatch_command_map.end(); ++iter)
	{
		//loss = 空跑路程 + 排队编号, 求最小值
		int t_current_loss = iter->second.m_useless_distance * SORT_LOSS_RATIO + iter->second.m_queue_id;
		if ( Dispatch_manager::get_instance_references().m_dispatch_manager_status_last == Dispatch_manager::E_DISPATCH_MANAGER_STORE)
		{
			if ( t_optimal_loss > t_current_loss && iter->second.m_type == 2)
			{
				t_optimal_loss = t_current_loss;
				m_primary_key_optimal = iter->first;
			}
		}
		else
		{
			if ( iter->second.m_type == 1 )
			{
				//20230824, huli 对C单元特殊处理， 存车优先级
				if ( iter->second.m_import_id == plc_park_priority )
				{
					t_current_loss = t_current_loss - SORT_LOSS_RATIO_UNIT_C;
				}
				if ( t_optimal_loss > t_current_loss && iter->second.m_type == 1)
				{
					t_optimal_loss = t_current_loss;
					m_primary_key_optimal = iter->first;
				}
			}
		}
	}
//	std::cout << " huli test :::: " << " sort_dispatch_command_for_total = " << Dispatch_manager::get_instance_references().m_dispatch_manager_status_last << std::endl;

	if ( m_primary_key_optimal.empty() )
	{
		//没找到也要切换上一次的存取车状态.
		if ( Dispatch_manager::get_instance_references().m_dispatch_manager_status_last == Dispatch_manager::E_DISPATCH_MANAGER_STORE )
		{
			Dispatch_manager::get_instance_references().m_dispatch_manager_status_last = Dispatch_manager::E_DISPATCH_MANAGER_PICKUP;

		}
		else
		{
			Dispatch_manager::get_instance_references().m_dispatch_manager_status_last = Dispatch_manager::E_DISPATCH_MANAGER_STORE;
		}
		//没找到合适的, 返回无效数据
		return Error_code::NODATA;
	}
	else
	{
		if ( m_dispatch_command_map[m_primary_key_optimal].m_type == 1 )
		{
			Dispatch_manager::get_instance_references().m_dispatch_manager_status_last = Dispatch_manager::E_DISPATCH_MANAGER_STORE;
		}
		else
		{
			Dispatch_manager::get_instance_references().m_dispatch_manager_status_last = Dispatch_manager::E_DISPATCH_MANAGER_PICKUP;
		}

		return Error_code::SUCCESS;
	}
	return Error_code::SUCCESS;
}


//对调度指令进行排序, 选出最优解, 只比较存车
Error_manager Dispatch_command::sort_dispatch_command_for_park(int plc_park_priority)
{
	int t_optimal_loss=0x7fffffff;		//最优loss值
	m_primary_key_optimal.clear();
	for (auto iter = m_dispatch_command_map.begin(); iter != m_dispatch_command_map.end(); ++iter)
	{
		//loss = 空跑路程 + 排队编号, 求最小值
		int t_current_loss = iter->second.m_useless_distance * SORT_LOSS_RATIO + iter->second.m_queue_id;

		if ( iter->second.m_type == 1 )
		{
			//20230824, huli 对C单元特殊处理， 存车优先级
			if ( iter->second.m_import_id == plc_park_priority )
			{
				t_current_loss = t_current_loss - SORT_LOSS_RATIO_UNIT_C;
			}
			if ( t_optimal_loss > t_current_loss && iter->second.m_type == 1)
			{
				t_optimal_loss = t_current_loss;
				m_primary_key_optimal = iter->first;
			}
		}



	}
	std::cout << " huli test :::: " << " sort_dispatch_command_for_park = " << Dispatch_manager::get_instance_references().m_dispatch_manager_status_last << std::endl;

	if ( m_primary_key_optimal.empty() )
	{
		return Error_code::NODATA;
	}
	return Error_code::SUCCESS;
}


//获取调度指令, 与数据库同步所有的指令信息，注意了：内部加锁，
Error_manager Dispatch_command::query_all_dispatch_command_ex()
{
	std::unique_lock<std::mutex> t_lock(m_lock);
	//从command_queue获取所有排队的指令,
	char query_all_dispatch_command_sql[DB_SQL_SIZE];
	memset(query_all_dispatch_command_sql, 0, DB_SQL_SIZE);
	sprintf(query_all_dispatch_command_sql,"select * from command_queue where unit = %d", m_unit);
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager t_error = Database_controller::get_instance_pointer()->sql_query(query_all_dispatch_command_sql, tp_result);

	m_dispatch_command_collect_now.clear();
	unsigned short			t_wait_small_park_count = 0;			//排队小车存车的数量
	unsigned short			t_wait_middle_park_count = 0;			//排队中车存车的数量
	unsigned short			t_wait_big_park_count = 0;				//排队大车存车的数量
	unsigned short			t_wait_total_park_count = 0;			//排队总车存车的数量
	unsigned short			t_wait_small_pick_count = 0;			//排队小车存车的数量
	unsigned short			t_wait_middle_pick_count = 0;			//排队中车存车的数量
	unsigned short			t_wait_big_pick_count = 0;				//排队大车存车的数量
	unsigned short			t_wait_total_pick_count = 0;			//排队总车存车的数量

	if(t_error == Error_code::SUCCESS)
	{
		if (tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}

		//循环检查所有行
		while (tp_result->next())
		{

			Dispatch_command_info t_dispatch_command_info;
			char t_error_buf[DB_SQL_SIZE];
			memset(t_error_buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据
				t_dispatch_command_info.m_car_number = tp_result->getString("car_number");
				t_dispatch_command_info.m_primary_key = tp_result->getString("primary_key");
				t_dispatch_command_info.m_unit = tp_result->getInt("unit");
				t_dispatch_command_info.m_terminal_id = tp_result->getInt("terminal_id");
				t_dispatch_command_info.m_queue_id = tp_result->getInt("queue_id");
				t_dispatch_command_info.m_type = tp_result->getInt("type");
				t_dispatch_command_info.m_statu = tp_result->getInt("statu");
				t_dispatch_command_info.m_export_id = tp_result->getInt("export_id");
				t_dispatch_command_info.m_import_id = tp_result->getInt("import_id");
				t_dispatch_command_info.m_height_level = tp_result->getInt("height_level");
				t_dispatch_command_info.m_height = tp_result->getDouble("height");
				t_dispatch_command_info.m_wheel_base_level = tp_result->getInt("wheel_base_level");
				t_dispatch_command_info.m_wheel_base = tp_result->getDouble("wheel_base");
				t_dispatch_command_info.m_space_info_string = tp_result->getString("space_info");
				t_dispatch_command_info.m_measure_buffer_string = tp_result->getString("measure_buffer");

				t_dispatch_command_info.m_car_number_info_msg.set_plate_color(tp_result->getString("plate_color") );
				t_dispatch_command_info.m_car_number_info_msg.set_plate_type(tp_result->getString("plate_type") );
				t_dispatch_command_info.m_car_number_info_msg.set_plate_confidence(tp_result->getInt("plate_confidence") );
				t_dispatch_command_info.m_car_number_info_msg.set_recognition_time(tp_result->getString("recognition_time") );
				t_dispatch_command_info.m_car_number_info_msg.set_plate_full_image(tp_result->getString("plate_full_image") );
				t_dispatch_command_info.m_car_number_info_msg.set_plate_clip_image(tp_result->getString("plate_clip_image") );
				t_dispatch_command_info.m_car_number_info_string = t_dispatch_command_info.m_car_number_info_msg.DebugString();

				//存车, 数据库特有 雷达信息,  没有车位信息, 需要根据车高,再去车位表申请车位
				if(! google::protobuf::TextFormat::ParseFromString(t_dispatch_command_info.m_measure_buffer_string, &t_dispatch_command_info.m_measure_buffer_msg))
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "ParseFromString fun error, m_measure_buffer ");
				}
				//取车, 数据库特有车位信息
				if(! google::protobuf::TextFormat::ParseFromString(t_dispatch_command_info.m_space_info_string, &t_dispatch_command_info.m_space_info_msg))
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "ParseFromString fun error, m_space_info ");
				}
				//取车, 数据库特有 车牌图片信息
//				if(! google::protobuf::TextFormat::ParseFromString(t_dispatch_command_info.m_car_number_info_string, &t_dispatch_command_info.m_car_number_info_msg))
//				{
//					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
//										 "ParseFromString fun error, m_space_info ");
//				}
//				if(! t_dispatch_command_info.m_car_number_info_msg.ParseFromString(t_dispatch_command_info.m_car_number_info_string) )
//				{
//					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
//										 "ParseFromString fun error, m_space_info ");
//				}

				//huli 20230612, 统计排队信息
				if ( t_dispatch_command_info.m_type == 1 )
				{
					if ( t_dispatch_command_info.m_statu == 0 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_park_0[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;

						if ( t_dispatch_command_info.m_height_level == 1)
						{
							t_wait_small_park_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 2)
						{
							t_wait_middle_park_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 3)
						{
							t_wait_big_park_count++;
						}
					}
					else if ( t_dispatch_command_info.m_statu == 1 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_park_1[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
						if ( t_dispatch_command_info.m_height_level == 1)
						{
							t_wait_small_park_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 2)
						{
							t_wait_middle_park_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 3)
						{
							t_wait_big_park_count++;
						}
					}
					else if ( t_dispatch_command_info.m_statu == 2 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_park_2[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
					}
					else if ( t_dispatch_command_info.m_statu == 10 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_park_10[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
					}
				}
				if ( t_dispatch_command_info.m_type == 2 )
				{
					if ( t_dispatch_command_info.m_statu == 0 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_pick_0[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
						m_dispatch_command_collect_now.m_dispatch_command_vector_pick_0.push_back(t_dispatch_command_info);
						if ( t_dispatch_command_info.m_height_level == 1)
						{
							t_wait_small_pick_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 2)
						{
							t_wait_middle_pick_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 3)
						{
							t_wait_big_pick_count++;
						}
					}
					else if ( t_dispatch_command_info.m_statu == 1 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_pick_1[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
						if ( t_dispatch_command_info.m_height_level == 1)
						{
							t_wait_small_pick_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 2)
						{
							t_wait_middle_pick_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 3)
						{
							t_wait_big_pick_count++;
						}
					}
					else if ( t_dispatch_command_info.m_statu == 2 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_pick_2[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
					}
					else if ( t_dispatch_command_info.m_statu == 10 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_pick_10[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
					}
				}
			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(t_error_buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(),
						e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, t_error_buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(t_error_buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, t_error_buf);
			}
		}

		m_dispatch_command_collect_now.m_wait_small_park_count = t_wait_small_park_count;
		m_dispatch_command_collect_now.m_wait_middle_park_count = t_wait_middle_park_count;
		m_dispatch_command_collect_now.m_wait_big_park_count = t_wait_big_park_count;
		m_dispatch_command_collect_now.m_wait_total_park_count = t_wait_small_park_count + t_wait_middle_park_count + t_wait_big_park_count;
		m_dispatch_command_collect_now.m_wait_small_pick_count = t_wait_small_pick_count;
		m_dispatch_command_collect_now.m_wait_middle_pick_count = t_wait_middle_pick_count;
		m_dispatch_command_collect_now.m_wait_big_pick_count = t_wait_big_pick_count;
		m_dispatch_command_collect_now.m_wait_total_pick_count = t_wait_small_pick_count + t_wait_middle_pick_count + t_wait_big_pick_count;

//		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_total.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_total.size();
//		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_park_0.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_park_0.size();
//		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_park_1.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_park_1.size();
//		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_park_2.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_park_2.size();
//		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_park_10.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_park_10.size();
//		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_pick_0.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_pick_0.size();
//		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_pick_1.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_pick_1.size();
//		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_pick_2.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_pick_2.size();
//		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_pick_10.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_pick_10.size();
//		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_vector_pick_0.size() = " << m_dispatch_command_collect_now.m_dispatch_command_vector_pick_0.size();
//

		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_small_park_count = t_wait_small_park_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_middle_park_count = t_wait_middle_park_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_big_park_count = t_wait_big_park_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_total_park_count = t_wait_small_park_count + t_wait_middle_park_count + t_wait_big_park_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_small_pick_count = t_wait_small_pick_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_middle_pick_count = t_wait_middle_pick_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_big_pick_count = t_wait_big_pick_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_total_pick_count = t_wait_small_pick_count + t_wait_middle_pick_count + t_wait_big_pick_count;
		return SUCCESS;
	}
	else
	{
		return t_error;
	}

	return Error_code::SUCCESS;
}


//获取调度指令, 与数据库同步所有的指令信息，注意了：内部加锁，
Error_manager Dispatch_command::query_all_dispatch_command_ex_unlock()
{
//	std::unique_lock<std::mutex> t_lock(m_lock);
	//从command_queue获取所有排队的指令,
	char query_all_dispatch_command_sql[DB_SQL_SIZE];
	memset(query_all_dispatch_command_sql, 0, DB_SQL_SIZE);
	sprintf(query_all_dispatch_command_sql,"select * from command_queue where unit = %d", m_unit);
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager t_error = Database_controller::get_instance_pointer()->sql_query(query_all_dispatch_command_sql, tp_result);

	m_dispatch_command_collect_now.clear();
	unsigned short			t_wait_small_park_count = 0;			//排队小车存车的数量
	unsigned short			t_wait_middle_park_count = 0;			//排队中车存车的数量
	unsigned short			t_wait_big_park_count = 0;				//排队大车存车的数量
	unsigned short			t_wait_total_park_count = 0;			//排队总车存车的数量
	unsigned short			t_wait_small_pick_count = 0;			//排队小车存车的数量
	unsigned short			t_wait_middle_pick_count = 0;			//排队中车存车的数量
	unsigned short			t_wait_big_pick_count = 0;				//排队大车存车的数量
	unsigned short			t_wait_total_pick_count = 0;			//排队总车存车的数量

	if(t_error == Error_code::SUCCESS)
	{
		if (tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}

		//循环检查所有行
		while (tp_result->next())
		{

			Dispatch_command_info t_dispatch_command_info;
			char t_error_buf[DB_SQL_SIZE];
			memset(t_error_buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据
				t_dispatch_command_info.m_car_number = tp_result->getString("car_number");
				t_dispatch_command_info.m_primary_key = tp_result->getString("primary_key");
				t_dispatch_command_info.m_unit = tp_result->getInt("unit");
				t_dispatch_command_info.m_terminal_id = tp_result->getInt("terminal_id");
				t_dispatch_command_info.m_queue_id = tp_result->getInt("queue_id");
				t_dispatch_command_info.m_type = tp_result->getInt("type");
				t_dispatch_command_info.m_statu = tp_result->getInt("statu");
				t_dispatch_command_info.m_export_id = tp_result->getInt("export_id");
				t_dispatch_command_info.m_import_id = tp_result->getInt("import_id");
				t_dispatch_command_info.m_height_level = tp_result->getInt("height_level");
				t_dispatch_command_info.m_height = tp_result->getDouble("height");
				t_dispatch_command_info.m_wheel_base_level = tp_result->getInt("wheel_base_level");
				t_dispatch_command_info.m_wheel_base = tp_result->getDouble("wheel_base");
				t_dispatch_command_info.m_space_info_string = tp_result->getString("space_info");
				t_dispatch_command_info.m_measure_buffer_string = tp_result->getString("measure_buffer");

				t_dispatch_command_info.m_car_number_info_msg.set_plate_color(tp_result->getString("plate_color") );
				t_dispatch_command_info.m_car_number_info_msg.set_plate_type(tp_result->getString("plate_type") );
				t_dispatch_command_info.m_car_number_info_msg.set_plate_confidence(tp_result->getInt("plate_confidence") );
				t_dispatch_command_info.m_car_number_info_msg.set_recognition_time(tp_result->getString("recognition_time") );
				t_dispatch_command_info.m_car_number_info_msg.set_plate_full_image(tp_result->getString("plate_full_image") );
				t_dispatch_command_info.m_car_number_info_msg.set_plate_clip_image(tp_result->getString("plate_clip_image") );
				t_dispatch_command_info.m_car_number_info_string = t_dispatch_command_info.m_car_number_info_msg.DebugString();

				//存车, 数据库特有 雷达信息,  没有车位信息, 需要根据车高,再去车位表申请车位
				if(! google::protobuf::TextFormat::ParseFromString(t_dispatch_command_info.m_measure_buffer_string, &t_dispatch_command_info.m_measure_buffer_msg))
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "ParseFromString fun error, m_measure_buffer ");
				}
				//取车, 数据库特有车位信息
				if(! google::protobuf::TextFormat::ParseFromString(t_dispatch_command_info.m_space_info_string, &t_dispatch_command_info.m_space_info_msg))
				{
					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
										 "ParseFromString fun error, m_space_info ");
				}
				//取车, 数据库特有 车牌图片信息
//				if(! google::protobuf::TextFormat::ParseFromString(t_dispatch_command_info.m_car_number_info_string, &t_dispatch_command_info.m_car_number_info_msg))
//				{
//					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
//										 "ParseFromString fun error, m_space_info ");
//				}
//				if(! t_dispatch_command_info.m_car_number_info_msg.ParseFromString(t_dispatch_command_info.m_car_number_info_string) )
//				{
//					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
//										 "ParseFromString fun error, m_space_info ");
//				}

				//huli 20230612, 统计排队信息
				if ( t_dispatch_command_info.m_type == 1 )
				{
					if ( t_dispatch_command_info.m_statu == 0 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_park_0[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;

						if ( t_dispatch_command_info.m_height_level == 1)
						{
							t_wait_small_park_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 2)
						{
							t_wait_middle_park_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 3)
						{
							t_wait_big_park_count++;
						}
					}
					else if ( t_dispatch_command_info.m_statu == 1 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_park_1[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
						if ( t_dispatch_command_info.m_height_level == 1)
						{
							t_wait_small_park_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 2)
						{
							t_wait_middle_park_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 3)
						{
							t_wait_big_park_count++;
						}
					}
					else if ( t_dispatch_command_info.m_statu == 2 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_park_2[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
					}
					else if ( t_dispatch_command_info.m_statu == 10 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_park_10[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
					}
				}
				if ( t_dispatch_command_info.m_type == 2 )
				{
					if ( t_dispatch_command_info.m_statu == 0 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_pick_0[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
						m_dispatch_command_collect_now.m_dispatch_command_vector_pick_0.push_back(t_dispatch_command_info);
						if ( t_dispatch_command_info.m_height_level == 1)
						{
							t_wait_small_pick_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 2)
						{
							t_wait_middle_pick_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 3)
						{
							t_wait_big_pick_count++;
						}
					}
					else if ( t_dispatch_command_info.m_statu == 1 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_pick_1[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
						if ( t_dispatch_command_info.m_height_level == 1)
						{
							t_wait_small_pick_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 2)
						{
							t_wait_middle_pick_count++;
						}
						if ( t_dispatch_command_info.m_height_level == 3)
						{
							t_wait_big_pick_count++;
						}
					}
					else if ( t_dispatch_command_info.m_statu == 2 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_pick_2[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
					}
					else if ( t_dispatch_command_info.m_statu == 10 )
					{
						m_dispatch_command_collect_now.m_dispatch_command_map_pick_10[t_dispatch_command_info.m_primary_key] = t_dispatch_command_info;
					}
				}
			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(t_error_buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(),
						e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, t_error_buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(t_error_buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, t_error_buf);
			}
		}

		m_dispatch_command_collect_now.m_wait_small_park_count = t_wait_small_park_count;
		m_dispatch_command_collect_now.m_wait_middle_park_count = t_wait_middle_park_count;
		m_dispatch_command_collect_now.m_wait_big_park_count = t_wait_big_park_count;
		m_dispatch_command_collect_now.m_wait_total_park_count = t_wait_small_park_count + t_wait_middle_park_count + t_wait_big_park_count;
		m_dispatch_command_collect_now.m_wait_small_pick_count = t_wait_small_pick_count;
		m_dispatch_command_collect_now.m_wait_middle_pick_count = t_wait_middle_pick_count;
		m_dispatch_command_collect_now.m_wait_big_pick_count = t_wait_big_pick_count;
		m_dispatch_command_collect_now.m_wait_total_pick_count = t_wait_small_pick_count + t_wait_middle_pick_count + t_wait_big_pick_count;

		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_total.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_total.size();
		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_park_0.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_park_0.size();
		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_park_1.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_park_1.size();
		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_park_2.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_park_2.size();
		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_park_10.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_park_10.size();
		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_pick_0.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_pick_0.size();
		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_pick_1.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_pick_1.size();
		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_pick_2.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_pick_2.size();
		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_map_pick_10.size() = " << m_dispatch_command_collect_now.m_dispatch_command_map_pick_10.size();
		LOG(INFO) << " m_dispatch_command_collect_now.m_dispatch_command_vector_pick_0.size() = " << m_dispatch_command_collect_now.m_dispatch_command_vector_pick_0.size();
//

		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_small_park_count = t_wait_small_park_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_middle_park_count = t_wait_middle_park_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_big_park_count = t_wait_big_park_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_total_park_count = t_wait_small_park_count + t_wait_middle_park_count + t_wait_big_park_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_small_pick_count = t_wait_small_pick_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_middle_pick_count = t_wait_middle_pick_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_big_pick_count = t_wait_big_pick_count;
		Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_wait_total_pick_count = t_wait_small_pick_count + t_wait_middle_pick_count + t_wait_big_pick_count;
		return SUCCESS;
	}
	else
	{
		return t_error;
	}

	return Error_code::SUCCESS;
}

//查询车位表, 与数据库同步所有的剩余车位信息，注意了：内部加锁，
Error_manager Dispatch_command::query_all_dispatch_ready_space_ex()
{
	std::unique_lock<std::mutex> t_lock(m_lock);

	int t_ready_small_space_count = 0;
	Dispatch_manager::get_instance_references().m_dispatch_command.query_specify_height_unit_parkspace_info(m_dispatch_id, 1, t_ready_small_space_count);
	m_dispatch_command_collect_now.m_ready_small_space_count = t_ready_small_space_count;
	int t_ready_middle_space_count = 0;
	Dispatch_manager::get_instance_references().m_dispatch_command.query_specify_height_unit_parkspace_info(m_dispatch_id, 2, t_ready_middle_space_count);
	m_dispatch_command_collect_now.m_ready_middle_space_count = t_ready_middle_space_count;
	int t_ready_big_space_count = 0;
	Dispatch_manager::get_instance_references().m_dispatch_command.query_specify_height_unit_parkspace_info(m_dispatch_id, 3, t_ready_big_space_count);
	m_dispatch_command_collect_now.m_ready_big_space_count = t_ready_big_space_count;
	m_dispatch_command_collect_now.m_ready_total_space_count = m_dispatch_command_collect_now.m_ready_small_space_count +
															   m_dispatch_command_collect_now.m_ready_middle_space_count +
															   m_dispatch_command_collect_now.m_ready_big_space_count;

	Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_ready_small_space_count = m_dispatch_command_collect_now.m_ready_small_space_count;
	Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_ready_middle_space_count = m_dispatch_command_collect_now.m_ready_middle_space_count;
	Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_ready_big_space_count = m_dispatch_command_collect_now.m_ready_big_space_count;
	Dispatch_manager::get_instance_references().m_dispatch_plc.m_dispatch_plc_status_from_manager_to_plc.m_ready_total_space_count = m_dispatch_command_collect_now.m_ready_total_space_count;


	return Error_code::SUCCESS;
}


//存车指令 获取 指定车高 指定单元 的车位信息，用于车位分配
Error_manager Dispatch_command::query_specify_height_unit_parkspace_info(int unit, int height_level, int wheel_base_level, Dispatch_space_info & dispatch_space_info)
{
	//查询车位表
	char query_parkspace_sql[DB_SQL_SIZE];
	memset(query_parkspace_sql, 0, DB_SQL_SIZE);
	int t_statu = 0; //车位状态, 0空闲, 1预约, 2占有, 3锁定, 6入口, 7出口, 10故障
	sprintf(query_parkspace_sql,"select * from space where car_number is NULL and height_level = %d and wheel_base_level =%d and statu = %d and unit = %d",height_level,wheel_base_level,t_statu,unit);
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_query(query_parkspace_sql, tp_result);
//	std::cout << " huli test :::: " << " query_parkspace_sql = " << query_parkspace_sql << std::endl;
	LOG(INFO) << " sssssssssssssssssssssssssssssssssss " << query_parkspace_sql << " "<< this;

	if(ec == SUCCESS)
	{
		if(tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}
		//只取第一条结果, 默认是id最小的,
		if (tp_result->next())
		{
			char buf[DB_SQL_SIZE];
			memset(buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据
				dispatch_space_info.m_id = tp_result->getInt("id");
				dispatch_space_info.m_serial_id = tp_result->getInt("serial_id");
				dispatch_space_info.m_table_id = tp_result->getInt("table_id");
				dispatch_space_info.m_unit = tp_result->getInt("unit");
				dispatch_space_info.m_floor = tp_result->getInt("floor");
				dispatch_space_info.m_room_id = tp_result->getInt("room_id");
				dispatch_space_info.m_height_level = tp_result->getInt("height_level");
				dispatch_space_info.m_height = tp_result->getDouble("height");
				dispatch_space_info.m_wheel_base_level = tp_result->getInt("wheel_base_level");
				dispatch_space_info.m_wheel_base = tp_result->getDouble("wheel_base");
//				dispatch_space_info.m_primary_key = tp_result->getString("primary_key");
//				dispatch_space_info.m_car_number = tp_result->getString("car_number");
				dispatch_space_info.m_statu = tp_result->getInt("statu");

//				dispatch_space_info.m_space_info_string = tp_result->getString("space_info");
//				dispatch_space_info.m_measure_buffer_string = tp_result->getString("measure_buffer");
//				//存车, 数据库特有 雷达信息,  没有车位信息, 需要根据车高,再去车位表申请车位
//				if(! google::protobuf::TextFormat::ParseFromString(dispatch_space_info.m_measure_buffer_string, &dispatch_space_info.m_measure_buffer_msg))
//				{
//					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
//										 "ParseFromString fun error, m_measure_buffer ");
//				}
//				//取车, 数据库特有车位信息
//				if(! google::protobuf::TextFormat::ParseFromString(dispatch_space_info.m_space_info_string, &dispatch_space_info.m_space_info_msg))
//				{
//					return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
//										 "ParseFromString fun error, m_space_info ");
//				}
			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(), e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
		}
		else
		{
			return Error_manager(Error_code::DB_NOT_QUERY_EMPTY_PARKSPACE, Error_level::MINOR_ERROR,
								 "数据库未查询到空车位 Parkspace_operating_function::query_one_empty_parkspace error ");
		}
		return SUCCESS;
	}
	else
	{
		return ec;
	}
	return SUCCESS;
}

//获取 指定车高 指定单元 的空闲车位数量，
Error_manager Dispatch_command::query_specify_height_unit_parkspace_info(int unit, int height_level, int & dispatch_space_count)
{
	//查询车位表
	char query_parkspace_sql[DB_SQL_SIZE];
	memset(query_parkspace_sql, 0, DB_SQL_SIZE);
	int t_statu = 0; //车位状态, 0空闲, 1预约, 2占有, 3锁定, 6入口, 7出口, 10故障
	sprintf(query_parkspace_sql,"select count(*) from (select * from space where car_number is NULL and height_level = %d and statu = %d and unit = %d) as tablename2",height_level,t_statu,unit);
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_query(query_parkspace_sql, tp_result);
//	std::cout << " huli test :::: " << " query_parkspace_sql = " << query_parkspace_sql << std::endl;
//	LOG(INFO) << " query_parkspace_sql "<< query_parkspace_sql;
	if(ec == SUCCESS)
	{
		if(tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}
		//只取第一条结果, 默认是id最小的,
		if (tp_result->next())
		{
			char buf[DB_SQL_SIZE];
			memset(buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据
				dispatch_space_count = tp_result->getInt("count(*)");
			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(), e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
		}
		else
		{
			return Error_manager(Error_code::DB_NOT_QUERY_EMPTY_PARKSPACE, Error_level::MINOR_ERROR,
								 "数据库未查询到空车位 Parkspace_operating_function::query_one_empty_parkspace error ");
		}
		return SUCCESS;
	}
	else
	{
		return ec;
	}
	return SUCCESS;
}

//查询空闲车位最优解,    存车指令 根据调度指令最优解 获取 空闲车位最优解
Error_manager Dispatch_command::query_dispatch_space_optimal(int unit, int height_level, int wheel_base_level, unsigned short & car_type, Dispatch_space_info & dispatch_space_info)
{
	Error_manager t_error;

	//同一高度，先找小轴距，再找大轴距，
	//如果没有，在增加高度，然后 先找小轴距，再找大轴距，........
	for (int i = height_level; i <=CAR_HEIGHT_LEVEL_MAX; ++i)
	{
		for (int j = wheel_base_level; j <=CAR_WHEEL_BASE_LEVEL_MAX; ++j)
		{
			t_error = query_specify_height_unit_parkspace_info(unit, i, j, dispatch_space_info);
			if ( t_error == Error_code::SUCCESS )
			{
				car_type = i;
				return t_error;
			}
		}
	}

	return Error_manager(Error_code::DB_NOT_QUERY_EMPTY_PARKSPACE, Error_level::MINOR_ERROR,
						 " query_dispatch_space_optimal error ");

//	int t_unit = unit;
//	float t_height = height;
//
//	//小车对应小车位  中车对应中车位 大车对应大车位
//	if ( 0 < t_height && t_height <= CAR_HEIGHT_LIMIT_SMALL +0.000001)
//	{
//		t_error = query_specify_height_unit_parkspace_info(t_unit, CAR_HEIGHT_LIMIT_SMALL, CAR_WHEEL_BASE_LIMIT_SHORT, dispatch_space_info);
//		if ( t_error == Error_code::SUCCESS )
//		{
//			car_type = Common_data::Car_type::MIN_SHORT_CAR;
//			return t_error;
//		}
//		t_error = query_specify_height_unit_parkspace_info(t_unit, CAR_HEIGHT_LIMIT_SMALL, CAR_WHEEL_BASE_LIMIT_LONG, dispatch_space_info);
//		if ( t_error == Error_code::SUCCESS )
//		{
//			car_type = Common_data::Car_type::MIN_LONG_CAR;
//			return t_error;
//		}
//	}
//	if (  t_height <= CAR_HEIGHT_LIMIT_MIDDLE +0.000001)
//	{
//		t_error = query_specify_height_unit_parkspace_info(t_unit, CAR_HEIGHT_LIMIT_MIDDLE, CAR_WHEEL_BASE_LIMIT_SHORT, dispatch_space_info);
//		if ( t_error == Error_code::SUCCESS )
//		{
//			car_type = Common_data::Car_type::MID_SHORT_CAR;
//			return t_error;
//		}
//		t_error = query_specify_height_unit_parkspace_info(t_unit, CAR_HEIGHT_LIMIT_MIDDLE, CAR_WHEEL_BASE_LIMIT_LONG, dispatch_space_info);
//		if ( t_error == Error_code::SUCCESS )
//		{
//			car_type = Common_data::Car_type::MID_LONG_CAR;
//			return t_error;
//		}
//	}
//	if ( t_height <= CAR_HEIGHT_LIMIT_BIG +0.000001)
//	{
//		t_error = query_specify_height_unit_parkspace_info(t_unit, CAR_HEIGHT_LIMIT_BIG, CAR_WHEEL_BASE_LIMIT_SHORT, dispatch_space_info);
//		if ( t_error == Error_code::SUCCESS )
//		{
//			car_type = Common_data::Car_type::BIG_SHORT_CAR;
//			return t_error;
//		}
//		t_error = query_specify_height_unit_parkspace_info(t_unit, CAR_HEIGHT_LIMIT_BIG, CAR_WHEEL_BASE_LIMIT_LONG, dispatch_space_info);
//		if ( t_error == Error_code::SUCCESS )
//		{
//			car_type = Common_data::Car_type::BIG_LONG_CAR;
//			return t_error;
//		}
//	}
//	return Error_manager(Error_code::DB_NOT_QUERY_EMPTY_PARKSPACE, Error_level::MINOR_ERROR,
//						 " query_dispatch_space_optimal error ");
}

//查询空闲车位最优解,    存车指令 根据调度指令最优解 获取 空闲车位最优解
Error_manager Dispatch_command::query_dispatch_space_optimal_ex(int unit, int height_level, int wheel_base_level, Dispatch_space_info & dispatch_space_info)
{
	Error_manager t_error;

	//同一高度，先找小轴距，再找大轴距，
	//如果没有，在增加高度，然后 先找小轴距，再找大轴距，........
	for (int i = height_level; i <=CAR_HEIGHT_LEVEL_MAX; ++i)
	{
		for (int j = wheel_base_level; j <=CAR_WHEEL_BASE_LEVEL_MAX; ++j)
		{

			t_error = query_specify_height_unit_parkspace_info(unit, i, j, dispatch_space_info);
			if ( t_error == Error_code::SUCCESS )
			{
//				car_type = (Common_data::Car_type)i;
				return t_error;
			}
		}
	}

	return Error_manager(Error_code::DB_NOT_QUERY_EMPTY_PARKSPACE, Error_level::MINOR_ERROR,
						 " query_dispatch_space_optimal error ");
}

//查询 取车的车位    取车指令 根据车牌号 查询对应的车位
Error_manager Dispatch_command::query_dispatch_space_for_car_number()
{
//查询车位表
	char query_parkspace_sql[DB_SQL_SIZE];
	memset(query_parkspace_sql, 0, DB_SQL_SIZE);
	int t_statu = 2; //车位状态, 0空闲, 1预约, 2占有, 3锁定, 6入口, 7出口, 10故障
	sprintf(query_parkspace_sql,"select * from space where car_number = '%s' ",m_dispatch_command_map[m_primary_key_optimal].m_car_number.c_str());
//	std::cout<<"query_parkspace_sql = "<<query_parkspace_sql<<std::endl;
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_query(query_parkspace_sql, tp_result);
	if(ec == SUCCESS)
	{
		if(tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}
		//只取第一条结果, 默认是id最小的,
		if (tp_result->next())
		{
			char buf[DB_SQL_SIZE];
			memset(buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据
				m_dispatch_space_info[0].m_id = tp_result->getInt("id");
				m_dispatch_space_info[0].m_serial_id = tp_result->getInt("serial_id");
				m_dispatch_space_info[0].m_table_id = tp_result->getInt("table_id");
				m_dispatch_space_info[0].m_unit = tp_result->getInt("unit");
				m_dispatch_space_info[0].m_floor = tp_result->getInt("floor");
				m_dispatch_space_info[0].m_room_id = tp_result->getInt("room_id");
				m_dispatch_space_info[0].m_height = tp_result->getDouble("height");
				m_dispatch_space_info[0].m_primary_key = tp_result->getString("primary_key");
				m_dispatch_space_info[0].m_car_number = tp_result->getString("car_number");
				m_dispatch_space_info[0].m_statu = tp_result->getInt("statu");


			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(), e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
		}
		else
		{
			return Error_manager(Error_code::DB_QUERY_NOT_DATA, Error_level::MINOR_ERROR,
								 "数据库未查询到数据 Parkspace_operating_function::query_one_parkspace_with_license error ");

		}
		return SUCCESS;
	}
	else
	{
		return ec;
	}
	return SUCCESS;
}

//更新 车位状态, 根据唯一码 只修状态
Error_manager Dispatch_command::update_parkspace_statu_by_primary_key(int statu, std::string primary_key)
{
	//执行sql操作
	char update_space_sql[DB_SQL_SIZE];
	memset(update_space_sql, 0, DB_SQL_SIZE);
	//int t_statu = 2; //车位状态, 0空闲, 1预约, 2占有, 3锁定, 6入口, 7出口, 10故障
	sprintf(update_space_sql, "update space set statu = %d where primary_key = '%s' ",
			statu,
			primary_key.c_str()
	);
	LOG(INFO) << " update_space_sql =  "<< update_space_sql << " --- " << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_space_sql);
	return ec;
}

//更新 车位状态, 根据车位ID 写入车牌号即可
Error_manager Dispatch_command::update_parkspace_write_car_number(int statu)
{
	//执行sql操作
	char update_space_sql[DB_SQL_SIZE];
	memset(update_space_sql, 0, DB_SQL_SIZE);
	//int t_statu = 2; //车位状态, 0空闲, 1预约, 2占有, 3锁定, 6入口, 7出口, 10故障
	sprintf(update_space_sql, "update space set car_number = '%s', primary_key = '%s', statu = %d, space_info = '%s', measure_buffer = '%s' where id = %d",
			m_dispatch_command_map[m_primary_key_optimal].m_car_number.c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_primary_key.c_str(),
			statu,
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.DebugString().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_measure_buffer_string.c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.id()
	);
	LOG(INFO) << " update_space_sql =  "<< update_space_sql << " --- " << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_space_sql);
	return ec;
}

//更新 车位状态,  存车排队预约车位
Error_manager Dispatch_command::update_parkspace_write_car_number(park_table park_command, Dispatch_command::Dispatch_space_info dispatch_space_info, int statu)
{
	parkspace_info	t_space_info_msg;
	t_space_info_msg.set_id(dispatch_space_info.m_id);
	t_space_info_msg.set_serial_id(dispatch_space_info.m_serial_id);
	t_space_info_msg.set_table_id(dispatch_space_info.m_table_id);
	t_space_info_msg.set_unit_id(dispatch_space_info.m_unit);
	t_space_info_msg.set_floor(dispatch_space_info.m_floor);
	t_space_info_msg.set_room_id(dispatch_space_info.m_room_id);
	t_space_info_msg.set_height(dispatch_space_info.m_height);

	//执行sql操作
	char update_space_sql[DB_SQL_SIZE];
	memset(update_space_sql, 0, DB_SQL_SIZE);
	//int t_statu = 2; //车位状态, 0空闲, 1预约, 2占有, 3锁定, 6入口, 7出口, 10故障
	sprintf(update_space_sql, "update space set car_number = '%s', primary_key = '%s', statu = %d, space_info = '%s', measure_buffer = '%s',plate_color = '%s', plate_type = '%s', plate_confidence = %d, recognition_time = '%s', plate_full_image = '%s', plate_clip_image = '%s' where id = %d",
			park_command.car_number().c_str(),
			park_command.primary_key().c_str(),
			statu,
			t_space_info_msg.DebugString().c_str(),
			park_command.entrance_measure_info().DebugString().c_str(),
			park_command.car_number_info().plate_color().c_str(),
			park_command.car_number_info().plate_type().c_str(),
			park_command.car_number_info().plate_confidence(),
			park_command.car_number_info().recognition_time().c_str(),
			park_command.car_number_info().plate_full_image().c_str(),
			park_command.car_number_info().plate_clip_image().c_str(),
			t_space_info_msg.id()
	);
	LOG(INFO) << " update_space_sql =  "<< update_space_sql << " --- " << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_space_sql);
	return ec;
}

//更新 车位状态, 找到车牌号, 写NULL
Error_manager Dispatch_command::update_parkspace_clear_car_number(int statu)
{
	//执行sql操作
	char update_space_sql[DB_SQL_SIZE];
	memset(update_space_sql, 0, DB_SQL_SIZE);
	//int t_statu = 2; //车位状态, 0空闲, 1预约, 2占有, 3锁定, 6入口, 7出口, 10故障
	sprintf(update_space_sql, "update space set car_number = null, primary_key = null, statu = %d, space_info = null, measure_buffer = null where car_number = '%s' ",
			statu,
			m_dispatch_command_map[m_primary_key_optimal].m_car_number.c_str());
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_space_sql);
	return ec;
}


//更新 车位状态, 找到车牌号, 写NULL by id
Error_manager Dispatch_command::update_parkspace_clear_car_number_by_id(int space_id, int statu, std::string str)
{
	//执行sql操作
	char update_space_sql[DB_SQL_SIZE];
	memset(update_space_sql, 0, DB_SQL_SIZE);
	//int t_statu = 2; //车位状态, 0空闲, 1预约, 2占有, 3锁定, 6入口, 7出口, 10故障
	std::string t_str;
	if ( str == "" )
	{
		t_str = "故障, 更换车位";
	}
	else
	{
		t_str = str;
	}
	t_str = t_str + "  " + Time_tool::get_instance_references().get_current_time_seconds();
	sprintf(update_space_sql, "update space set car_number = null, primary_key = null, statu = %d, space_info = null, measure_buffer = null, plate_color = null, plate_type = null, plate_confidence = null, recognition_time = null, plate_full_image = null, plate_clip_image = null, remark = '%s' where id = %d ",
			statu,
			t_str.c_str(),
			space_id
			);

	LOG(INFO) << " update_parkspace_clear_car_number_by_id =  " << update_space_sql << "    "<< this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_space_sql);
	return ec;
}

//更新车牌图片信息,
Error_manager Dispatch_command::update_parkspace_write_car_number_info(int statu)
{
	//执行sql操作
	char update_space_sql[DB_SQL_SIZE];
	memset(update_space_sql, 0, DB_SQL_SIZE);
	//int t_statu = 2; //车位状态, 0空闲, 1预约, 2占有, 3锁定, 6入口, 7出口, 10故障
	sprintf(update_space_sql, "update space set statu = %d, plate_color = '%s', plate_type = '%s', plate_confidence = %d, recognition_time = '%s', plate_full_image = '%s', plate_clip_image = '%s' where car_number = '%s' ",
			statu,
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_color().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_type().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_confidence(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.recognition_time().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_full_image().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_clip_image().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number.c_str()
	);
	LOG(INFO) << "  huli 123123 update_parkspace_write_car_number_info =  " << update_space_sql << "    "<< this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_space_sql);
	return ec;
}
//删除车牌图片信息,
Error_manager Dispatch_command::update_parkspace_clear_car_number_info(int statu)
{
	//执行sql操作
	char update_space_sql[DB_SQL_SIZE];
	memset(update_space_sql, 0, DB_SQL_SIZE);
	//int t_statu = 2; //车位状态, 0空闲, 1预约, 2占有, 3锁定, 6入口, 7出口, 10故障
	sprintf(update_space_sql, "update space set statu = %d, plate_color = null, plate_type = null, plate_confidence = null, recognition_time = null, plate_full_image = null, plate_clip_image = null where car_number = '%s' ",
			statu,
			m_dispatch_command_map[m_primary_key_optimal].m_car_number.c_str()
	);
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_space_sql);
	return ec;
}

//更新 指令队列, 根据唯一码和存取类型 修改状态即可,  //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
Error_manager Dispatch_command::update_command_queue_for_statu(int statu)
{
	char update_command_sql[DB_SQL_SIZE];
	memset(update_command_sql, 0, DB_SQL_SIZE);

	//设置为3故障后，清除预分配的车位。
	if ( statu == 3 )
	{
		sprintf(update_command_sql, "update command_queue set statu = %d, export_id = %d, space_info = null where primary_key = '%s' and type = %d",
				statu,
				m_dispatch_command_map[m_primary_key_optimal].m_export_id,
				m_dispatch_command_map[m_primary_key_optimal].m_primary_key.c_str(),
				m_dispatch_command_map[m_primary_key_optimal].m_type
		);
	}
	else
	{
		sprintf(update_command_sql, "update command_queue set statu = %d, export_id = %d, space_info = '%s' where primary_key = '%s' and type = %d",
				statu,
				m_dispatch_command_map[m_primary_key_optimal].m_export_id,
				m_dispatch_command_map[m_primary_key_optimal].m_space_info_string.c_str(),
				m_dispatch_command_map[m_primary_key_optimal].m_primary_key.c_str(),
				m_dispatch_command_map[m_primary_key_optimal].m_type
		);
	}

	LOG(INFO) << "update_command_queue_for_statu  update_command_sql =  "<< update_command_sql << " --- " << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_command_sql);
	return ec;
}

//更新 指令队列, 根据唯一码和存取类型 修改状态即可,   //指令状态, 0排队中, 1正在工作, 2已完成, 3故障异常
Error_manager Dispatch_command::update_command_queue_for_statu_ex(std::string primary_key, int statu, int type)
{
	char update_command_sql[DB_SQL_SIZE];
	memset(update_command_sql, 0, DB_SQL_SIZE);

	sprintf(update_command_sql, "update command_queue set statu = %d where primary_key = '%s' and type = %d",
			statu,
			primary_key.c_str(),
			type
	);

	LOG(INFO) << "update_command_queue_for_statu_ex  update_command_sql =  "<< update_command_sql << " --- " << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_command_sql);
	return ec;
}

//把整个单元的排队指令改为故障
Error_manager Dispatch_command::update_command_queue_from_wait_to_fault_for_unit(int unit_id)
{
	char update_command_sql[DB_SQL_SIZE];
	memset(update_command_sql, 0, DB_SQL_SIZE);
	sprintf(update_command_sql, "update command_queue set statu = 3 where statu = 0 and unit = %d",
			unit_id
	);
//	LOG(INFO) << "jjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjj update_command_sql =  "<< update_command_sql << " --- " << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_command_sql);
	return ec;
}

//删除 指令队列, 根据车牌号 删除指令 20230810 输入车牌号和存取车类型
Error_manager Dispatch_command::delete_command_queue_for_car_number(std::string car_number, int type)
{
	char delete_command_sql[DB_SQL_SIZE];
	memset(delete_command_sql, 0, DB_SQL_SIZE);
	sprintf(delete_command_sql, "delete from command_queue where car_number = '%s' and type = %d",
			car_number.c_str(), type);
	LOG(INFO) << "  huli 456456 delete_command_queue_for_car_number =  " << delete_command_sql << "    "<< this;

	Error_manager ec = Database_controller::get_instance_pointer()->sql_delete(delete_command_sql);
	return ec;
}

//制作存车表单
Error_manager Dispatch_command::create_park_table(int inlet_ready)
{
	park_table t_park_table;
	t_park_table.mutable_statu()->set_execute_statu(eNormal);
	t_park_table.set_queue_id(m_dispatch_command_map[m_primary_key_optimal].m_queue_id);
	t_park_table.set_car_number(m_dispatch_command_map[m_primary_key_optimal].m_car_number);
	t_park_table.set_unit_id(m_dispatch_command_map[m_primary_key_optimal].m_unit);
	t_park_table.set_primary_key(m_dispatch_command_map[m_primary_key_optimal].m_primary_key);
	t_park_table.mutable_entrance_measure_info()->CopyFrom(m_dispatch_command_map[m_primary_key_optimal].m_measure_buffer_msg);
	t_park_table.mutable_allocated_space_info()->CopyFrom(m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg);
	t_park_table.set_terminal_id(m_dispatch_command_map[m_primary_key_optimal].m_unit*100+inlet_ready);

	m_park_table_msg = t_park_table;
	return Error_code::SUCCESS;
}

//制作取车表单
Error_manager Dispatch_command::create_pick_table(int outlet_ready)
{
	pick_table t_pick_table;
	t_pick_table.mutable_statu()->set_execute_statu(eNormal);
	t_pick_table.set_queue_id(m_dispatch_command_map[m_primary_key_optimal].m_queue_id);
	t_pick_table.set_car_number(m_dispatch_command_map[m_primary_key_optimal].m_car_number);
	t_pick_table.set_unit_id(m_dispatch_command_map[m_primary_key_optimal].m_unit);
	t_pick_table.set_primary_key(m_dispatch_command_map[m_primary_key_optimal].m_primary_key);
	t_pick_table.mutable_actually_measure_info()->CopyFrom(m_dispatch_command_map[m_primary_key_optimal].m_measure_buffer_msg);
	t_pick_table.mutable_actually_space_info()->CopyFrom(m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg);

	t_pick_table.set_terminal_id(m_dispatch_command_map[m_primary_key_optimal].m_unit*100+outlet_ready);

//	LOG(INFO) << " outlet_ready =  "<< outlet_ready << " --- " << this;
//
//	LOG(INFO) << " m_device_floor =  "<< m_device_floor << " --- " << this;
//	LOG(INFO) << " m_dispatch_id =  "<< m_dispatch_id << " --- " << this;
//	LOG(INFO) << " m_unit =  "<< m_unit << " --- " << this;
//	LOG(INFO) << " m_outlet_ready =  "<< m_outlet_ready << " --- " << this;


	m_pick_table_msg = t_pick_table;
	return Error_code::SUCCESS;
}

//增加 车辆表, 存车指令 完成后添加车辆信息
Error_manager Dispatch_command::insert_vehicle_for_car_number()
{
	char insert_vehicle_sql[DB_SQL_SIZE];
	memset(insert_vehicle_sql, 0, DB_SQL_SIZE);
	sprintf(insert_vehicle_sql, "INSERT INTO vehicle (car_number,primary_key,actually_measure_buffer) values ('%s','%s','%s')",
			m_dispatch_command_map[m_primary_key_optimal].m_car_number.c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_primary_key.c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_measure_buffer_string.c_str()   );
	Error_manager ec = Database_controller::get_instance_pointer()->sql_insert(insert_vehicle_sql);
	return ec;
}
//删除 车辆表, 取车指令 完成后删除车辆信息
Error_manager Dispatch_command::delete_vehicle_for_car_number()
{
	char delete_vehicle_sql[DB_SQL_SIZE];
	memset(delete_vehicle_sql, 0, DB_SQL_SIZE);
	sprintf(delete_vehicle_sql, "delete from vehicle where car_number = '%s'",
			m_dispatch_command_map[m_primary_key_optimal].m_car_number.c_str());
	Error_manager ec = Database_controller::get_instance_pointer()->sql_delete(delete_vehicle_sql);
	return ec;
}

//检查记录表是否提前创建。没有创建就返回成功
Error_manager Dispatch_command::check_record_for_no_primary_key(std::string primary_key)
{
	//查询车位表
	char query_record_sql[DB_SQL_SIZE];
	memset(query_record_sql, 0, DB_SQL_SIZE);
	sprintf(query_record_sql,"select * from record where primary_key = '%s' ",primary_key.c_str());
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_query(query_record_sql, tp_result);
	if(ec == SUCCESS)
	{
		if(tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}

		if (tp_result->next() == false)
		{
			return Error_code::SUCCESS;
		}
		else
		{
			return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
								 "error, check_record_for_no_primary_key has  primary_key ");
		}
		return SUCCESS;
	}
	else
	{
		return ec;
	}
	return SUCCESS;
}

//增加 记录表, 存车指令 完成后添加存车记录
Error_manager Dispatch_command::insert_record_for_park_start()
{
	Time_tool::get_instance_references().time_start(PARK_TIME_FLAG);

	int t_terminal = 0;
#ifdef CHUTIAN_PROJECT_PROJECT

#endif//CHUTIAN_PROJECT_PROJECT

#ifdef SHANGGUJIE_PROJECT_PROJECT
	t_terminal = m_dispatch_command_map[m_primary_key_optimal].m_import_id;
#endif //SHANGGUJIE_PROJECT_PROJECT

	char insert_record_sql[DB_SQL_SIZE];
	memset(insert_record_sql, 0, DB_SQL_SIZE);
	sprintf(insert_record_sql, "INSERT INTO record (primary_key,car_number,import_id,enqueue_time, in_time_start, height_level, wheel_base_level, measure_buffer,center_x,center_y,theta,width,height,wheelbase,front_theta, space_info,space_id,table_id,unit_id,floor_id,room_id,plate_color,plate_type,plate_confidence,recognition_time,plate_full_image,plate_clip_image) values ('%s','%s',%d,'%s','%s',%d,%d,'%s',%f,%f,%f,%f,%f,%f,%f,'%s',%d,%d,%d,%d,%d,'%s','%s',%d,'%s','%s','%s')",
			m_dispatch_command_map[m_primary_key_optimal].m_primary_key.c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number.c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_import_id,
			Time_tool::get_instance_references().get_current_time_seconds().c_str(),
			Time_tool::get_instance_references().get_current_time_seconds().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_height_level,
			m_dispatch_command_map[m_primary_key_optimal].m_wheel_base_level,
			m_dispatch_command_map[m_primary_key_optimal].m_measure_buffer_msg.DebugString().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_measure_buffer_msg.measure_info_to_plc_forward().cx(),
			m_dispatch_command_map[m_primary_key_optimal].m_measure_buffer_msg.measure_info_to_plc_forward().cy(),
			m_dispatch_command_map[m_primary_key_optimal].m_measure_buffer_msg.measure_info_to_plc_forward().theta(),
			m_dispatch_command_map[m_primary_key_optimal].m_measure_buffer_msg.measure_info_to_plc_forward().width(),
			m_dispatch_command_map[m_primary_key_optimal].m_measure_buffer_msg.measure_info_to_plc_forward().height(),
			m_dispatch_command_map[m_primary_key_optimal].m_measure_buffer_msg.measure_info_to_plc_forward().wheelbase(),
			m_dispatch_command_map[m_primary_key_optimal].m_measure_buffer_msg.measure_info_to_plc_forward().front_theta(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.DebugString().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.id(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.table_id(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.unit_id(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.floor(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.room_id(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_color().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_type().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_confidence(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.recognition_time().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_full_image().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_clip_image().c_str()
	);
	LOG(INFO) << " insert_record_sql =  "<< insert_record_sql << " --- " << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_insert(insert_record_sql);
	return ec;
}

//更新 记录表, 存车指令 完成后只更新存车开始时间
Error_manager Dispatch_command::updata_record_for_park_start()
{
	Time_tool::get_instance_references().time_start(PARK_TIME_FLAG);

	//执行sql操作
	char update_record_sql[DB_SQL_SIZE];
	memset(update_record_sql, 0, DB_SQL_SIZE);
	sprintf(update_record_sql, "update record set in_time_start = '%s', import_id = %d , space_info = '%s',space_id = %d,table_id = %d,unit_id = %d,floor_id = %d,room_id = %d where primary_key = '%s' ",
			Time_tool::get_instance_references().get_current_time_seconds().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_import_id,
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.DebugString().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.id(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.table_id(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.unit_id(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.floor(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.room_id(),
			m_dispatch_command_map[m_primary_key_optimal].m_primary_key.c_str()	);
	LOG(INFO) << " update_record_sql =  "<< update_record_sql << " --- " << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_record_sql);
	return ec;
}

//增加 记录表, 存车指令 完成后添加存车记录
Error_manager Dispatch_command::insert_record_for_park_start(park_table park_command, Dispatch_command::Dispatch_space_info dispatch_space_info)
{
//	Time_tool::get_instance_references().time_start(PARK_TIME_FLAG);

	int t_terminal = 0;
#ifdef CHUTIAN_PROJECT_PROJECT

#endif//CHUTIAN_PROJECT_PROJECT

#ifdef SHANGGUJIE_PROJECT_PROJECT
	t_terminal = m_dispatch_command_map[m_primary_key_optimal].m_import_id;
#endif //SHANGGUJIE_PROJECT_PROJECT


	parkspace_info	t_space_info_msg;
	t_space_info_msg.set_id(dispatch_space_info.m_id);
	t_space_info_msg.set_serial_id(dispatch_space_info.m_serial_id);
	t_space_info_msg.set_table_id(dispatch_space_info.m_table_id);
	t_space_info_msg.set_unit_id(dispatch_space_info.m_unit);
	t_space_info_msg.set_floor(dispatch_space_info.m_floor);
	t_space_info_msg.set_room_id(dispatch_space_info.m_room_id);
	t_space_info_msg.set_height(dispatch_space_info.m_height);


	char insert_record_sql[DB_SQL_SIZE];
	memset(insert_record_sql, 0, DB_SQL_SIZE);
	sprintf(insert_record_sql, "INSERT INTO record (primary_key,car_number,import_id,enqueue_time, height_level, wheel_base_level, measure_buffer,center_x,center_y,theta,width,height,wheelbase,front_theta, space_info,space_id,table_id,unit_id,floor_id,room_id,plate_color,plate_type,plate_confidence,recognition_time,plate_full_image,plate_clip_image) values ('%s','%s',%d,'%s',%d,%d,'%s',%f,%f,%f,%f,%f,%f,%f,'%s',%d,%d,%d,%d,%d,'%s','%s',%d,'%s','%s','%s')",
			park_command.primary_key().c_str(),
			park_command.car_number().c_str(),
			get_passway_id(park_command.terminal_id(), 1),
			Time_tool::get_instance_references().get_current_time_seconds().c_str(),
			dispatch_space_info.m_height_level,
			dispatch_space_info.m_wheel_base_level,
			park_command.entrance_measure_info().DebugString().c_str(),
			park_command.entrance_measure_info().measure_info_to_plc_forward().cx(),
			park_command.entrance_measure_info().measure_info_to_plc_forward().cy(),
			park_command.entrance_measure_info().measure_info_to_plc_forward().theta(),
			park_command.entrance_measure_info().measure_info_to_plc_forward().width(),
			park_command.entrance_measure_info().measure_info_to_plc_forward().height(),
			park_command.entrance_measure_info().measure_info_to_plc_forward().wheelbase(),
			park_command.entrance_measure_info().measure_info_to_plc_forward().front_theta(),
			t_space_info_msg.DebugString().c_str(),
			t_space_info_msg.id(),
			t_space_info_msg.table_id(),
			t_space_info_msg.unit_id(),
			t_space_info_msg.floor(),
			t_space_info_msg.room_id(),
			park_command.car_number_info().plate_color().c_str(),
			park_command.car_number_info().plate_type().c_str(),
			park_command.car_number_info().plate_confidence(),
			park_command.car_number_info().recognition_time().c_str(),
			park_command.car_number_info().plate_full_image().c_str(),
			park_command.car_number_info().plate_clip_image().c_str()
	);
	LOG(INFO) << " insert_record_sql =  "<< insert_record_sql << " --- " << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_insert(insert_record_sql);
	return ec;
}

//增加 记录表, 存车指令 完成后添加存车记录
Error_manager Dispatch_command::updata_record_for_park_end()
{
	Time_tool::get_instance_references().time_end(PARK_TIME_FLAG);
	int in_time_difference = Time_tool::get_instance_references().get_time_seconds(PARK_TIME_FLAG);

	//C单元的夹车杆雷达
	std::string t_clamp_lidar_string;
	if ( m_dispatch_id == 31 || m_dispatch_id == 32)
	{
		Dispatch_communication::Clamp_lidar_request_from_plc_to_manager& clamp_lidar_request_from_plc_to_manager =
		Dispatch_communication::get_instance_references().m_clamp_lidar_request_from_plc_to_manager;

		Clamp_lidar_buffer t_clamp_lidar_buffer;
		Dispatch_manager::get_instance_references().judge_clamp_lidar_DB_to_message(clamp_lidar_request_from_plc_to_manager, t_clamp_lidar_buffer);

		t_clamp_lidar_string = t_clamp_lidar_buffer.DebugString();
	}


	//执行sql操作
	char update_record_sql[DB_SQL_SIZE];
	memset(update_record_sql, 0, DB_SQL_SIZE);
//	sprintf(update_record_sql, "update record set in_time_end = '%s', in_time_difference = %d, space_id = %d, space_info = '%s' where primary_key = '%s' ",
	sprintf(update_record_sql, "update record set in_time_end = '%s', in_time_difference = %d, space_id = %d, table_id = %d, unit_id = %d, floor_id = %d, room_id = %d, plate_color = '%s', plate_type = '%s', plate_confidence = %d, recognition_time = '%s', plate_full_image = '%s', plate_clip_image = '%s', park_clamp_lidar_buffer = '%s'  where primary_key = '%s' ",
			Time_tool::get_instance_references().get_current_time_seconds().c_str(),
			in_time_difference,
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.id(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.table_id(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.unit_id(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.floor(),
			m_dispatch_command_map[m_primary_key_optimal].m_space_info_msg.room_id(),
//			m_dispatch_command_map[m_primary_key_optimal].m_parkspace_info_msg.DebugString().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_color().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_type().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_confidence(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.recognition_time().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_full_image().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_car_number_info_msg.plate_clip_image().c_str(),
			t_clamp_lidar_string.c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_primary_key.c_str()
	);
	LOG(INFO) << "  huli 78978978 updata_record_for_park_end =  " << update_record_sql << "    "<< this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_record_sql);
	return ec;
}

//更新 记录表, 取车指令 完成后更新取车记录
Error_manager Dispatch_command::updata_record_for_pick_start()
{
	Time_tool::get_instance_references().time_start(PICK_TIME_FLAG);

	//执行sql操作
	char update_record_sql[DB_SQL_SIZE];
	memset(update_record_sql, 0, DB_SQL_SIZE);
	sprintf(update_record_sql, "update record set out_time_start = '%s', export_id = %d where primary_key = '%s' ",
			Time_tool::get_instance_references().get_current_time_seconds().c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_export_id,
			m_dispatch_command_map[m_primary_key_optimal].m_primary_key.c_str()	);
	LOG(INFO) << " update_record_sql =  "<< update_record_sql << " --- " << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_record_sql);
	return ec;
}

//更新 记录表, 取车指令 完成后更新取车记录
Error_manager Dispatch_command::updata_record_for_pick_end()
{
	Time_tool::get_instance_references().time_end(PICK_TIME_FLAG);
	int out_time_difference = Time_tool::get_instance_references().get_time_seconds(PICK_TIME_FLAG);

	int parking_time;
	get_parking_time(m_dispatch_command_map[m_primary_key_optimal].m_primary_key, parking_time);
	char parking_time_string[256] = "";
	int hour = parking_time / 3600;
	int min = (parking_time / 60)%60;
	int sec = parking_time % 60;
	sprintf(parking_time_string, " %d:%02d:%02d", hour, min, sec);

	//C单元的夹车杆雷达
	std::string t_clamp_lidar_string;
	if ( m_dispatch_id == 31 || m_dispatch_id == 32)
	{
		Dispatch_communication::Clamp_lidar_request_from_plc_to_manager& clamp_lidar_request_from_plc_to_manager =
		Dispatch_communication::get_instance_references().m_clamp_lidar_request_from_plc_to_manager;

		Clamp_lidar_buffer t_clamp_lidar_buffer;
		Dispatch_manager::get_instance_references().judge_clamp_lidar_DB_to_message(clamp_lidar_request_from_plc_to_manager, t_clamp_lidar_buffer);

		t_clamp_lidar_string = t_clamp_lidar_buffer.DebugString();
	}

	//执行sql操作
	char update_record_sql[DB_SQL_SIZE];
	memset(update_record_sql, 0, DB_SQL_SIZE);
	sprintf(update_record_sql, "update record set out_time_end = '%s', out_time_difference = %d, parking_time = '%s' , pick_clamp_lidar_buffer = '%s' where primary_key = '%s' ",
			Time_tool::get_instance_references().get_current_time_seconds().c_str(),
			out_time_difference,
			parking_time_string,
			t_clamp_lidar_string.c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_primary_key.c_str()	);
	LOG(INFO) << " update_record_sql =  "<< update_record_sql << " --- " << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_record_sql);
	return ec;
}

//更新 记录表, 取车指令 完成后更新取车记录, 撤销指令, 没有取车时间差
Error_manager Dispatch_command::updata_record_for_pick_end_ex()
{
	int parking_time;
	get_parking_time(m_dispatch_command_map[m_primary_key_optimal].m_primary_key, parking_time);
	char parking_time_string[256] = "";
	int hour = parking_time / 3600;
	int min = parking_time / 60;
	int sec = parking_time % 60;
	sprintf(parking_time_string, " %d:%02d:%02d", hour, min, sec);

	//C单元的夹车杆雷达
	std::string t_clamp_lidar_string;
	if ( m_dispatch_id == 31 || m_dispatch_id == 32)
	{
		Dispatch_communication::Clamp_lidar_request_from_plc_to_manager& clamp_lidar_request_from_plc_to_manager =
		Dispatch_communication::get_instance_references().m_clamp_lidar_request_from_plc_to_manager;

		Clamp_lidar_buffer t_clamp_lidar_buffer;
		Dispatch_manager::get_instance_references().judge_clamp_lidar_DB_to_message(clamp_lidar_request_from_plc_to_manager, t_clamp_lidar_buffer);

		t_clamp_lidar_string = t_clamp_lidar_buffer.DebugString();
	}

	//执行sql操作
	char update_record_sql[DB_SQL_SIZE];
	memset(update_record_sql, 0, DB_SQL_SIZE);
	sprintf(update_record_sql, "update record set out_time_end = '%s', parking_time = '%s' , pick_clamp_lidar_buffer = '%s' where primary_key = '%s' ",
			Time_tool::get_instance_references().get_current_time_seconds().c_str(),
			parking_time_string,
			t_clamp_lidar_string.c_str(),
			m_dispatch_command_map[m_primary_key_optimal].m_primary_key.c_str()	);
	LOG(INFO) << " update_record_sql =  "<< update_record_sql << " --- " << this;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_update(update_record_sql);
	return ec;
}

//计算汽车在车库的存车时间, 从存车开始到取车结束, 返回 parking_time, 单位秒.
Error_manager Dispatch_command::get_parking_time(std::string primary_key, int & parking_time )
{
	//查询存车时间 in_time_start
	char query_record_sql[DB_SQL_SIZE];
	memset(query_record_sql, 0, DB_SQL_SIZE);
	sprintf(query_record_sql,"select * from record where primary_key = '%s' ", primary_key.c_str() );
	boost::shared_ptr<sql::ResultSet>  tp_result = nullptr;
	Error_manager ec = Database_controller::get_instance_pointer()->sql_query(query_record_sql, tp_result);
	if(ec == SUCCESS)
	{
		if(tp_result == nullptr)
		{
			return DB_RESULT_SET_EMPTY;
		}
		//只取第一条结果, 默认是id最小的,
		if (tp_result->next())
		{
			char buf[DB_SQL_SIZE];
			memset(buf, 0, DB_SQL_SIZE);
			try
			{
				//解析数据
				std::string in_time_start_string = tp_result->getString("in_time_start");
				std::chrono::system_clock::time_point in_time_start = Time_tool::get_instance_references().transform_time_string_seconds(in_time_start_string);
				std::chrono::system_clock::time_point out_time_end = std::chrono::system_clock::now();
				double t_parking_time = (out_time_end - in_time_start).count() / 1000000000;
				parking_time = t_parking_time;
				return Error_code::SUCCESS;
			}
			catch (sql::SQLException &e)
			{
				/* Use what() (derived from std::runtime_error) to fetch the error message */
				sprintf(buf, "# ERR: %s\n (MySQL error code: %d, SQLState: %s", e.what(), e.getErrorCode(), e.getSQLState().c_str());
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
			catch (std::runtime_error &e)
			{
				sprintf(buf, "# ERR: %s\n ERR: runtime_error in  %s ", e.what(), __FILE__);
				return Error_manager(DB_RESULT_SET_PARSE_ERROR, NEGLIGIBLE_ERROR, buf);
			}
		}
		else
		{
			return Error_manager(Error_code::DB_NOT_QUERY_EMPTY_PARKSPACE, Error_level::MINOR_ERROR,
								 "数据库未查询到空车位 Parkspace_operating_function::query_one_empty_parkspace error ");
		}
		return SUCCESS;
	}
	else
	{
		return ec;
	}

	return Error_code::SUCCESS;
}


//获取出入口id 1~2为入口, 3~4为出口,
//输入terminal_id 1~19,   输入 action_mode 1:存车, 2:取车
int Dispatch_command::get_passway_id(int terminal_id, int action_mode)
{
	terminal_id = terminal_id%100;
	int passway_id = 0;
	switch ( terminal_id )
	{
		case 1:
		case 2:
		case 4:
		case 6:
		case 8:
		case 10:
		case 12:
		case 14:
		case 16:
		case 17:
		case 19:
		{
			passway_id = 1 + (action_mode-1)*2;
			break;
		}
		case 3:
		case 5:
		case 7:
		case 9:
		case 11:
		case 13:
		case 15:
		case 18:
		{
			passway_id = 2 + (action_mode-1)*2;
			break;
		}
		default:
		{

			break;
		}
	}
	return passway_id;
}
