//
// Created by huli on 2021/8/3.
//

#include "dispatch_plc.h"
#include "../system/system_communication.h"
#include "dispatch_manager.h"
#include <stdlib.h>

Dispatch_plc::Dispatch_plc()
{
	m_dispatch_plc_status = Dispatch_plc::Dispatch_plc_status::DISPATCH_PLC_UNKNOW;
	m_plc_id = 0;
	mp_execute_thread = NULL;
	mp_data_storage_thread = NULL;

}

Dispatch_plc::~Dispatch_plc()
{
	dispatch_plc_uninit();
}

//调度plc 初始化
Error_manager Dispatch_plc::dispatch_plc_init(int plc_id)
{
	m_plc_id = plc_id;

	m_last_update_time = std::chrono::system_clock::now();
	m_last_heartbeat = 0;

	//	线程默认开启
	m_execute_condition.reset(false, true, false);
	mp_execute_thread = new std::thread(&Dispatch_plc::execute_thread_fun, this);

//	m_data_storage_condition.reset(false, true, false);
//	mp_data_storage_thread = new std::thread(&Dispatch_plc::data_storage_thread_fun, this);

	last_import_have_car[0] = 0;
	last_import_have_car[1] = 0;
	park_safe_lock[0] = 0;
	park_safe_lock[1] = 0;

	m_dispatch_plc_status = Dispatch_plc::Dispatch_plc_status::DISPATCH_PLC_READY;

	carry_board_coordinate_init(101, 2, 1);
	carry_board_coordinate_init(103, 2, 2);//小故障
	carry_board_coordinate_init(105, 2, 3);//小故障
	carry_board_coordinate_init(107, 2, 4);//修好
	carry_board_coordinate_init(109, 2, 5);
	carry_board_coordinate_init(111, 2, 6);


	carry_board_coordinate_init(112, 5, 1);
	carry_board_coordinate_init(110, 5, 2);
	carry_board_coordinate_init(108, 5, 3);
	carry_board_coordinate_init(106, 5, 4);//大故障, 下降不到位
	carry_board_coordinate_init(104, 5, 5);//小故障
	carry_board_coordinate_init(102, 5, 6);

	carry_board_coordinate_init(113, 7, 1);
	carry_board_coordinate_init(115, 7, 2);
	carry_board_coordinate_init(117, 7, 3);
	carry_board_coordinate_init(119, 7, 4);
	carry_board_coordinate_init(121, 7, 5);
	carry_board_coordinate_init(123, 7, 6);//禁用

	carry_board_coordinate_init(124, 9, 4);
	carry_board_coordinate_init(122, 9, 5);
	carry_board_coordinate_init(120, 9, 6);//大故障, 下降不到位
	carry_board_coordinate_init(118, 9, 7);
	carry_board_coordinate_init(116, 9, 8);
	carry_board_coordinate_init(114, 9, 9);

	carry_board_coordinate_init(141, 6, 1);//禁用
	carry_board_coordinate_init(139, 6, 2);
	carry_board_coordinate_init(137, 6, 3);
	carry_board_coordinate_init(135, 6, 4);
	carry_board_coordinate_init(133, 6, 5);
	carry_board_coordinate_init(131, 6, 6);
	carry_board_coordinate_init(129, 6, 7);
	carry_board_coordinate_init(127, 6, 8);
	carry_board_coordinate_init(125, 6, 9);

	carry_board_coordinate_init(126, 8, 1);
	carry_board_coordinate_init(128, 8, 2);
	carry_board_coordinate_init(130, 8, 3);
	carry_board_coordinate_init(132, 8, 4);
	carry_board_coordinate_init(134, 8, 5);
	carry_board_coordinate_init(136, 8, 6);
	carry_board_coordinate_init(138, 8, 7);
	carry_board_coordinate_init(140, 8, 8);//大故障, 下降不到位
	carry_board_coordinate_init(142, 8, 9);

	carry_board_coordinate_init(143, 4, 1);
	carry_board_coordinate_init(145, 4, 2);
	carry_board_coordinate_init(147, 4, 3);
	carry_board_coordinate_init(149, 4, 4);//大故障，钢丝绳松了
	carry_board_coordinate_init(151, 4, 5);
	carry_board_coordinate_init(153, 4, 6);
	carry_board_coordinate_init(155, 1, 1);
	carry_board_coordinate_init(157, 1, 2);
	carry_board_coordinate_init(159, 1, 3);//禁用



	carry_board_coordinate_init(160, 3, 1);
	carry_board_coordinate_init(158, 3, 2);
	carry_board_coordinate_init(156, 3, 3);
	carry_board_coordinate_init(154, 3, 4);
	carry_board_coordinate_init(152, 3, 5);
	carry_board_coordinate_init(150, 3, 6);
	carry_board_coordinate_init(148, 3, 7);
	carry_board_coordinate_init(146, 3, 8);
	carry_board_coordinate_init(144, 3, 9);


	return Error_code::SUCCESS;
}

//载车板坐标的结构体
Error_manager Dispatch_plc::carry_board_coordinate_init(int carry_board_index, int carry_board_control_buf_index, int carry_board_control_data_inde)
{
	Carry_board_coordinate t_Carry_board_coordinate;
	t_Carry_board_coordinate.m_carry_board_control_buf_index = carry_board_control_buf_index;
	t_Carry_board_coordinate.m_carry_board_control_data_index = carry_board_control_data_inde;
	m_carry_board_coordinate_map[carry_board_index] = t_Carry_board_coordinate;

	return Error_code::SUCCESS;
}

//调度plc 反初始化
Error_manager Dispatch_plc::dispatch_plc_uninit()
{
	if (mp_execute_thread)
	{
		m_execute_condition.kill_all();
	}
	if (mp_data_storage_thread)
	{
		m_data_storage_condition.kill_all();
	}


	if (mp_execute_thread)
	{
		mp_execute_thread->join();
		delete mp_execute_thread;
		mp_execute_thread = NULL;
	}
	if (mp_data_storage_thread)
	{
		mp_data_storage_thread->join();
		delete mp_data_storage_thread;
		mp_data_storage_thread = NULL;
	}

	m_dispatch_plc_status = Dispatch_plc::Dispatch_plc_status::DISPATCH_PLC_UNKNOW;

	return Error_code::SUCCESS;
}

//调度plc 执行请求
//Error_manager Dispatch_plc::execute_for_dispatch_request_msg(message::Dispatch_request_msg& dispatch_request_msg)
//{
//
//	if ( m_dispatch_plc_status == Dispatch_plc::Dispatch_plc_status::DISPATCH_PLC_READY )
//	{
//		std::unique_lock<std::mutex> t_lock(m_lock);
//
//		//设定超时时间, 默认比任务指令里面的时间少10秒,
//		if ( dispatch_request_msg.base_info().has_timeout_ms() )
//		{
//			m_timeout_ms = dispatch_request_msg.base_info().timeout_ms() - DISPATCH_PROCESS_ATTENUATION_TIMEOUT_MS;
//		}
//		else
//		{
//			m_timeout_ms = DISPATCH_PROCESS_TIMEOUT_MS - DISPATCH_PROCESS_ATTENUATION_TIMEOUT_MS;
//		}
//		m_command_key = dispatch_request_msg.command_key();
//		m_start_time = std::chrono::system_clock::now();
//
//
////		m_dispatch_request_msg = dispatch_request_msg;
////		if ( dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_STORE_CAR )
////		{
////			m_dispatch_process_type = Common_data::Dispatch_process_type::DISPATCH_PROCESS_STORE;
////		}
////		else if ( dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_PICKUP_CAR )
////		{
////			m_dispatch_process_type = Common_data::Dispatch_process_type::DISPATCH_PROCESS_PICKUP;
////		}
////		else
////		{
////			return Error_manager(Error_code::DISPATCH_PLC_REQUEST_ERROR, Error_level::MINOR_ERROR,
////								 " dispatch_request_msg.dispatch_motion_direction() PARAMRTER ERROR ");
////		}
//
//		m_dispatch_process_type = Common_data::Dispatch_process_type::DISPATCH_PROCESS_TYPE_UNKNOW;
//		m_dispatch_plc_status = Dispatch_plc::Dispatch_plc_status::DISPATCH_PLC_REQUEST;
//	}
//	else
//	{
//		return Error_manager(Error_code::DISPATCH_PLC_STATUS_ERROR, Error_level::MINOR_ERROR,
//							 " m_dispatch_plc_status error ");
//	}
//
//	return Error_code::SUCCESS;
//}


//新版调度plc 执行请求 存车
Error_manager Dispatch_plc::execute_for_dispatch_request_msg(park_table &park_table_msg, Common_data::Dispatch_process_type dispatch_process_type, unsigned short height_level, unsigned short wheel_base_level)
{
	if ( m_dispatch_plc_status == Dispatch_plc::Dispatch_plc_status::DISPATCH_PLC_READY )
	{
		std::unique_lock<std::mutex> t_lock(m_lock);

		//超时默认一小时.
		m_timeout_ms = DISPATCH_PROCESS_TIMEOUT_MS - DISPATCH_PROCESS_ATTENUATION_TIMEOUT_MS;
		//合成唯一码.
//		char t_buf[256] = {0};
//		sprintf(t_buf, "%d+%s+%s", park_table_msg.queue_id(), park_table_msg.car_number().c_str(), park_table_msg.primary_key().c_str());
//		m_command_key = park_table_msg.primary_key()+"_park";
		m_start_time = std::chrono::system_clock::now();

		m_park_table_msg = park_table_msg;
		m_dispatch_process_type = dispatch_process_type;
		m_height_level = height_level;
		m_wheel_base_level = wheel_base_level;

		//防止重复的一个 后缀编号。
		static unsigned char t_count ;
		t_count++;
		char buf[256] = {0};
		sprintf(buf, "_%d", t_count);

		if ( m_dispatch_process_type == Common_data::DISPATCH_PROCESS_STORE )
		{
			m_command_key = park_table_msg.primary_key()+"_store"+buf;
		}
		if ( m_dispatch_process_type == Common_data::DISPATCH_PROCESS_REALLOCATE )
		{
			m_command_key = park_table_msg.primary_key()+"_reallo"+buf;
		}

		LOG(INFO) << " execute_for_dispatch_request_msg :: "
				  << " park_table_msg = " << park_table_msg.DebugString()
				  << " dispatch_process_type = " << dispatch_process_type
				  << " m_height_level = " << m_height_level
				  << " m_wheel_base_level = " << m_wheel_base_level << this;
		m_dispatch_plc_status = Dispatch_plc::Dispatch_plc_status::DISPATCH_PLC_REQUEST;
	}
	else
	{
		return Error_manager(Error_code::DISPATCH_PLC_STATUS_ERROR, Error_level::MINOR_ERROR,
							 " m_dispatch_plc_status error ");
	}

	return Error_code::SUCCESS;
}
//新版调度plc 执行请求 取车
Error_manager Dispatch_plc::execute_for_dispatch_request_msg(pick_table &pick_table_msg, Common_data::Dispatch_process_type dispatch_process_type, unsigned short height_level, unsigned short wheel_base_level)
{
	if ( m_dispatch_plc_status == Dispatch_plc::Dispatch_plc_status::DISPATCH_PLC_READY )
	{
		std::unique_lock<std::mutex> t_lock(m_lock);

		//超时默认一小时.
		m_timeout_ms = DISPATCH_PROCESS_TIMEOUT_MS - DISPATCH_PROCESS_ATTENUATION_TIMEOUT_MS;
		//合成唯一码.
//		char t_buf[256] = {0};
//		sprintf(t_buf, "%d+%s+%s", pick_table_msg.queue_id(), pick_table_msg.car_number().c_str(), pick_table_msg.primary_key().c_str());
//		m_command_key = pick_table_msg.primary_key()+"_pick";
		m_start_time = std::chrono::system_clock::now();

		m_pick_table_msg = pick_table_msg;
		m_dispatch_process_type = dispatch_process_type;
		m_height_level = height_level;
		m_wheel_base_level = wheel_base_level;

		//防止重复的一个 后缀编号。
		static unsigned char t_count ;
		t_count++;
		char buf[256] = {0};
		sprintf(buf, "_%d", t_count);

		if ( m_dispatch_process_type == Common_data::DISPATCH_PROCESS_PICKUP )
		{
			m_command_key = pick_table_msg.primary_key()+"_pickup"+buf;
		}
		if ( m_dispatch_process_type == Common_data::DISPATCH_PROCESS_REVOCATION )
		{
			m_command_key = pick_table_msg.primary_key()+"_revoca"+buf;

			if ( m_plc_id == 31 || m_plc_id == 32 )
			{
				if ( Dispatch_manager::get_instance_references().m_dispatch_command.m_dispatch_command_map[Dispatch_manager::get_instance_references().m_dispatch_command.m_primary_key_optimal].m_type == 1 )
				{
					m_dispatch_process_type = Common_data::DISPATCH_PROCESS_REVOCATION_EX;
				}
			}
		}

		m_dispatch_plc_status = Dispatch_plc::Dispatch_plc_status::DISPATCH_PLC_REQUEST;
	}
	else
	{
		return Error_manager(Error_code::DISPATCH_PLC_STATUS_ERROR, Error_level::MINOR_ERROR,
							 " m_dispatch_plc_status error ");
	}

	return Error_code::SUCCESS;
}

Dispatch_plc::Dispatch_plc_status Dispatch_plc::get_dispatch_plc_status()
{
	return m_dispatch_plc_status;
}

//message::Dispatch_request_msg Dispatch_plc::get_dispatch_request_msg()
//{
//	std::unique_lock<std::mutex> t_lock(m_lock);
//	return m_dispatch_request_msg;
//}

Error_manager Dispatch_plc::get_result()
{
	return m_result;
}

float Dispatch_plc::get_response_working_total_time()
{
	std::unique_lock<std::mutex> t_lock(m_lock);
	return m_response_working_total_time;
}

float Dispatch_plc::get_response_working_remaining_time()
{
	std::unique_lock<std::mutex> t_lock(m_lock);
	return m_response_working_remaining_time;
}

void Dispatch_plc::clear_request_msg()
{
	m_request_key.clear();                //请求唯一码, 用作识别
	m_request_status = 0;            //请求确认标志
// 调度指令的起点,终点,方向
	m_request_dispatch_motion_direction = Common_data::Dispatch_process_type::DISPATCH_PROCESS_TYPE_UNKNOW;        //调度方向	0=未知，1=存车，2=取车
	m_request_passageway_id = 0;                    //出入口id	6个入口和6个出口
	m_request_passageway_direction = Common_data::Passageway_direction::PASSAGEWAY_DIRECTION_UNKNOWN;                //出入口方向	0=未知，1=入口，2=出口
	m_request_height_level = 0;
	m_request_wheel_base_level = 0;
	m_request_parkingspace_index_id = 0;            //楼上车位索引id	1~180(3*6*13)
	m_request_parkingspace_unit_id = 0;                //楼上车位单元号	1~3
	m_request_parkingspace_label_id = 0;                //楼上车位标签号  1~78
	m_request_parkingspace_floor_id = 0;            //楼上车位楼层号	2~11
	m_request_parkingspace_room_id = 0;                //楼上车位房间号	1~6
	m_request_parkingspace_direction = Common_data::Parkingspace_direction::PARKINGSPACE_DIRECTION_UNKNOWN;            //楼上车位方向	0=未知，1=朝南，2=朝北
//汽车的定位信息(地面雷达)
	m_request_car_center_x = 0;                //整车的中心点x值, 四轮的中心, 单位:米 m
	m_request_car_center_y = 0;                //整车的中心点y值, 四轮的中心, 单位:米 m
	m_request_car_angle = 0;                //整车的车身旋转角, 单位:度 (-90~90)
	m_request_car_front_theta = 0;            //整车的前轮的旋转角, 单位:度 (-90~90)
	m_request_car_length = 0;                //整车的长度, 用于规避碰撞, 单位:米 m
	m_request_car_width = 0;                //整车的宽度, 用于规避碰撞, 单位:米 m
	m_request_car_height = 0;                //整车的高度, 用于规避碰撞, 单位:米 m
	m_request_car_wheel_base = 0;            //整车的轮距, 前后轮的距离, 用于机器人或agv的抓车, 单位:米 m
	m_request_car_wheel_width = 0;            //整车的轮距, 左右轮的距离, 用于机器人或agv的抓车, 单位:米 m
	m_request_car_license.clear();                    //车牌号(汽车唯一标示)	例如: 鄂A12345

	m_request_car_type = 0;                    //车的大小
	m_request_uniformed_car_x = 0;                //转角复位后,车辆中心点x
	m_request_uniformed_car_y = 0;                //转角复位后,车辆中心点y

//防撞雷达
	m_request_anticollision_lidar_flag = Common_data::Anticollision_lidar_flag::ANTICOLLISION_LIDAR_UNKNOWN;        //汽车是否停到正确的位置, 防撞雷达	预留, 楚天暂时不用,0=未知，1=位置正常，2=位置异常
//轮距雷达
	m_request_car_wheel_base_exact_value = 0;    //汽车前后轮距,轮距雷达的精确值	预留, 楚天暂时不用,单位:米 m

	m_request_car_center_x2 = 0;                //整车的中心点x值, 四轮的中心, 单位:米 m
	m_request_car_center_y2 = 0;                //整车的中心点y值, 四轮的中心, 单位:米 m
	m_request_car_angle2 = 0;                //整车的车身旋转角, 单位:度 (-90~90)
	m_request_car_front_theta2 = 0;            //整车的前轮的旋转角, 单位:度 (-90~90)
	m_request_car_length2 = 0;                //整车的长度, 用于规避碰撞, 单位:米 m
	m_request_car_width2 = 0;                //整车的宽度, 用于规避碰撞, 单位:米 m
	m_request_car_height2 = 0;                //整车的高度, 用于规避碰撞, 单位:米 m
	m_request_car_wheel_base2 = 0;            //整车的轮距, 前后轮的距离, 用于机器人或agv的抓车, 单位:米 m
	m_request_car_wheel_width2 = 0;            //整车的轮距, 左右轮的距离, 用于机器人或agv的抓车, 单位:米 m
	m_request_uniformed_car_x2 = 0;                //转角复位后,车辆中心点x
	m_request_uniformed_car_y2 = 0;                //转角复位后,车辆中心点y
}

//jiancha qingqiu xiaoxi
//Error_manager Dispatch_plc::check_dispatch_request_msg(message::Dispatch_request_msg & dispatch_request_msg)
//{
//	return Error_code::SUCCESS;
//	/*
//    Error_manager t_error;
//
//    if(dispatch_request_msg.has_locate_information() &&
//            dispatch_request_msg.has_dispatch_motion_direction() &&
//            dispatch_request_msg.has_car_type() &&
//            dispatch_request_msg.has_id_struct() &&
//            dispatch_request_msg.has_command_key())
//    {
//		if ( m_dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_STORE_CAR )
//		{
//			if ( dispatch_request_msg.id_struct().has_unit_id() )
//			{
//
//			}
//		}
//		else if( m_dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_PICKUP_CAR )
//
//        return Error_code::SUCCESS;
//    }
//    else
//    {
//        return Error_manager(Error_code::DISPATCH_PLC_REQUEST_ERROR, Error_level::MINOR_ERROR,
//                             " m_dispatch_plc_status error ");
//    }
//    */
//    return Error_code::SUCCESS;
//}


//控制外门， 调度发给plc的状态，
//door_index 1~2是入口外门, 3~4是出口外门
//door_mode 0是无效, 1是开门, 2是关门
Error_manager Dispatch_plc::control_ouside_door(int door_index, int door_mode)
{
//	switch ( door_index )
//	{
//		case 1:
//		{
//			m_dispatch_plc_status_from_manager_to_plc.m_inlet_door_control_1 = door_mode;
//			break;
//		}
//		case 2:
//		{
//			m_dispatch_plc_status_from_manager_to_plc.m_inlet_door_control_2 = door_mode;
//			break;
//		}
//		case 3:
//		{
//			m_dispatch_plc_status_from_manager_to_plc.m_outlet_door_control_3 = door_mode;
//			break;
//		}
//		case 4:
//		{
//			m_dispatch_plc_status_from_manager_to_plc.m_outlet_door_control_4 = door_mode;
//			break;
//		}
//		default:
//		{
//
//			break;
//		}
//	}
	return Error_code::SUCCESS;
}

//控制门， 调度发给plc的状态，
//entry_index 1~2通道口id
//door_index 1是外门, 2是内门
//door_mode 0是无效, 1是开门, 2是关门
Error_manager Dispatch_plc::control_door(int entry_index, int door_index, int door_mode)
{
	if ( entry_index == 1 && door_index == 1)
	{
		m_dispatch_plc_status_from_manager_to_plc.m_entry1_outside_door_control = door_mode;
	}
	if ( entry_index == 1 && door_index == 2)
	{
		m_dispatch_plc_status_from_manager_to_plc.m_entry1_inside_door_control = door_mode;
	}
	if ( entry_index == 2 && door_index == 1)
	{
		m_dispatch_plc_status_from_manager_to_plc.m_entry2_outside_door_control = door_mode;
	}
	if ( entry_index == 2 && door_index == 2)
	{
		m_dispatch_plc_status_from_manager_to_plc.m_entry2_inside_door_control = door_mode;
	}
	return Error_code::SUCCESS;
}


//控制载车板， 调度发给plc
//carry_board_index   载车板编号101~127
//carry_board_mode 0是无效, 1是上升, 2是下降, 3是屏蔽
Error_manager Dispatch_plc::set_carry_board(int carry_board_index, int carry_board_mode)
{
	m_carry_board_space_id = carry_board_index;
	m_carry_board_target = carry_board_mode;
	m_carry_board_control = carry_board_mode;

	if ( carry_board_mode == 0 )
	{
		init_all_carry_board();
		return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
							 " fun error ");
	}
	if ( m_carry_board_coordinate_map.find(carry_board_index) == m_carry_board_coordinate_map.end() )
	{
		return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
							 " fun error ");
	}

	return set_carry_board(m_carry_board_coordinate_map[carry_board_index].m_carry_board_control_buf_index,
						   m_carry_board_coordinate_map[carry_board_index].m_carry_board_control_data_index,
						   carry_board_mode);
}

//控制载车板， 调度发给plc
//carry_board_control_buf_index;	//1~21组载车板模块的编号
//carry_board_control_data_index;	//1~10个载车板的编号
// carry_board_mode 0是无效, 1是上升, 2是下降, 3是屏蔽
Error_manager Dispatch_plc::set_carry_board(int carry_board_control_buf_index, int carry_board_control_data_index, int carry_board_mode)
{
	if ( carry_board_mode == 0 )
	{
		init_all_carry_board();
		return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
							 " fun error ");
	}

	int t_carry_board_control_buf_index = carry_board_control_buf_index;
	int t_carry_board_control_data_index = carry_board_control_data_index;

	int t_bit_index =  t_carry_board_control_data_index*3 + carry_board_mode+6;
	int t_byte_index = t_bit_index /8;
	int t_displace = t_bit_index%8;

	//判断载车板的自动模式和故障码
	if ( (m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[1] & 0x02) == 0x02
		 && m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[16] == 0
		 && m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[17] == 0 )
	{
		m_carry_board_control_from_manager_to_plc.carry_board_control_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[t_byte_index] |= (1<<t_displace);

		int tt = 0;
		get_carry_board_status(t_carry_board_control_buf_index, t_carry_board_control_data_index,tt);
		LOG(INFO) << " set_carry_board SUCCESS, control = " << carry_board_mode <<" , status = "<< tt;
		return Error_code::SUCCESS;
	}
	else
	{
		int tt = 0;
		get_carry_board_status(t_carry_board_control_buf_index, t_carry_board_control_data_index,tt);
		LOG(INFO) << " set_carry_board error, get_carry_board_status = " <<  tt;
		LOG(INFO) << " m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[1] = " << (int)m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[1];
		LOG(INFO) << " m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[16] = " << (int)m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[16];
		LOG(INFO) << " m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[17] = " << (int)m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[17];
		init_all_carry_board();
		return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
							 " fun error ");
	}

	return Error_code::SUCCESS;
}

//急停所有载车板， 调度发给plc
Error_manager Dispatch_plc::stop_all_carry_board()
{
	memset( &m_carry_board_control_from_manager_to_plc, 0, sizeof(Dispatch_communication::Carry_board_control_from_manager_to_plc));
	for (int i = 0; i < 21; ++i)
	{
		m_carry_board_control_from_manager_to_plc.carry_board_control_buf_vector[i].carry_board_data[0] = 0x02;
	}

	return Error_code::SUCCESS;
}
//复位所有载车板， 调度发给plc
Error_manager Dispatch_plc::reset_all_carry_board()
{
return Error_code::SUCCESS;
	for (int i = 0; i < 21; ++i)
	{
		m_carry_board_control_from_manager_to_plc.carry_board_control_buf_vector[i].carry_board_data[0] = 0x01;
	}
	return Error_code::SUCCESS;
}

//初始化所有载车板， 调度发给plc
Error_manager Dispatch_plc::init_all_carry_board()
{
	int asd = 0;
	get_carry_board_control(m_carry_board_space_id, asd);
	if ( asd != 0  )
	{
	    LOG(INFO) << " init_all_carry_board ////////////////////////////////////////////////////////////////////////////// = " << 1;
		LOG(INFO) << "get_carry_board  //////////////////////////////////////////////////// =  "
				  << m_carry_board_space_id << "  " << m_carry_board_control_buf_index << "  " << m_carry_board_control_data_index << "  "
				  << " ,,,,,,, "
				  << m_carry_board_target << "  " << m_carry_board_control << "  " << m_carry_board_status << "  "
				  << " ,,,,,,, "
				  << m_carry_board_flag << "  " << m_carry_board_status_0 << "  " << m_carry_board_status_1 << "  " << m_carry_board_status_16 << "  " << m_carry_board_status_17 << "  " ;

	}
	memset( &m_carry_board_control_from_manager_to_plc, 0, sizeof(Dispatch_communication::Carry_board_control_from_manager_to_plc));
	return Error_code::SUCCESS;
}

//获取载车板状态
//carry_board_index   载车板编号101~127
//carry_board_mode 0是无效, 1是上升, 2是下降, 11正在上升， 12正在下降
Error_manager Dispatch_plc::get_carry_board_status(int carry_board_index, int & carry_board_mode)
{
	if ( m_carry_board_coordinate_map.find(carry_board_index) == m_carry_board_coordinate_map.end() )
	{
		return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
							 " fun error ");
	}

	return get_carry_board_status(m_carry_board_coordinate_map[carry_board_index].m_carry_board_control_buf_index,
								  m_carry_board_coordinate_map[carry_board_index].m_carry_board_control_data_index,
								  carry_board_mode);
}

//获取载车板状态
//carry_board_control_buf_index;	//1~21组载车板模块的编号
//carry_board_control_data_index;	//1~10个载车板的编号
//carry_board_mode 0是无效, 1是上升, 2是下降, 11正在上升， 12正在下降
Error_manager Dispatch_plc::get_carry_board_status(int carry_board_control_buf_index, int carry_board_control_data_index, int & carry_board_mode)
{
	carry_board_mode = 0;

	int t_carry_board_control_buf_index = carry_board_control_buf_index;
	int t_carry_board_control_data_index = carry_board_control_data_index;
	int t_bit_index =  t_carry_board_control_data_index*10 + 12;
	int t_byte_index = t_bit_index /8;
	int t_displace = t_bit_index%8;
	if ( (m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[t_byte_index] & (1<<t_displace) ) == (1<<t_displace) )
	{
		carry_board_mode = 1;
	}
	t_bit_index =  t_carry_board_control_data_index*10 + 13;
	t_byte_index = t_bit_index /8;
	t_displace = t_bit_index%8;
	if ( (m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[t_byte_index] & (1<<t_displace) ) == (1<<t_displace) )
	{
		carry_board_mode = 2;
	}
	t_bit_index =  t_carry_board_control_data_index*10 + 10;
	t_byte_index = t_bit_index /8;
	t_displace = t_bit_index%8;
	if ( (m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[t_byte_index] & (1<<t_displace) ) == (1<<t_displace) )
	{
		carry_board_mode = 11;
	}
	t_bit_index =  t_carry_board_control_data_index*10 + 11;
	t_byte_index = t_bit_index /8;
	t_displace = t_bit_index%8;
	if ( (m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[t_byte_index] & (1<<t_displace) ) == (1<<t_displace) )
	{
		carry_board_mode = 12;
	}
	return Error_code::SUCCESS;
}

//获取载车板状态
//carry_board_index   载车板编号101~127
//carry_board_mode 0是无效, 1是上升, 2是下降, 3正在上升， 4正在下降
Error_manager Dispatch_plc::get_carry_board_control(int carry_board_index, int & carry_board_mode)
{
	carry_board_mode = 0;

	if ( m_carry_board_coordinate_map.find(carry_board_index) == m_carry_board_coordinate_map.end() )
	{
		return Error_manager(Error_code::ERROR, Error_level::MINOR_ERROR,
							 " fun error ");
	}

	return get_carry_board_control(m_carry_board_coordinate_map[carry_board_index].m_carry_board_control_buf_index,
								   m_carry_board_coordinate_map[carry_board_index].m_carry_board_control_data_index,
								   carry_board_mode);
}

//获取载车板状态
//carry_board_control_buf_index;	//1~21组载车板模块的编号
//carry_board_control_data_index;	//1~10个载车板的编号
//carry_board_mode 0是无效, 1是上升, 2是下降
Error_manager Dispatch_plc::get_carry_board_control(int carry_board_control_buf_index, int carry_board_control_data_index, int & carry_board_mode)
{
	carry_board_mode = 0;

	int t_carry_board_control_buf_index = carry_board_control_buf_index;
	int t_carry_board_control_data_index = carry_board_control_data_index;
	int t_bit_index =  t_carry_board_control_data_index*3 + 1+6;
	int t_byte_index = t_bit_index /8;
	int t_displace = t_bit_index%8;
	if ( (m_carry_board_control_from_manager_to_plc.carry_board_control_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[t_byte_index] & (1<<t_displace) ) == (1<<t_displace) )
	{
		carry_board_mode = 1;
	}
	t_bit_index =  t_carry_board_control_data_index*3 + 2+6;
	t_byte_index = t_bit_index /8;
	t_displace = t_bit_index%8;
	if ( (m_carry_board_control_from_manager_to_plc.carry_board_control_buf_vector[t_carry_board_control_buf_index-1].carry_board_data[t_byte_index] & (1<<t_displace) ) == (1<<t_displace) )
	{
		carry_board_mode = 2;
	}
	return Error_code::SUCCESS;
}



//获取plc搬运器的状态  0=故障 1=存车 2=取车 3=空闲 4=维护
int Dispatch_plc::get_plc_carrier_status()
{
	return m_dispatch_plc_status_from_plc_to_manager.m_plc_carrier_status;
}

//执行外界任务的执行函数
void Dispatch_plc::execute_thread_fun()
{
	LOG(INFO) << " Dispatch_plc::execute_thread_fun() start " << this;
	Error_manager t_error;

	while (m_execute_condition.is_alive())
	{
		m_execute_condition.wait();
		if (m_execute_condition.is_alive())
		{
			std::this_thread::sleep_for(std::chrono::microseconds(1));
			std::this_thread::sleep_for(std::chrono::milliseconds(1));
//			std::this_thread::sleep_for(std::chrono::milliseconds(10));
//			std::this_thread::sleep_for(std::chrono::seconds(1));

			std::this_thread::yield();
//			std::unique_lock<std::mutex> t_lock(m_lock);


			static int t_count = 0;
			if (t_count % 1000 == 0 )
			{
				std::cout << " huli test :::: " << " m_plc_id = " << m_plc_id << std::endl;
				std::cout << " huli test :::: " << " m_dispatch_plc_status = " << m_dispatch_plc_status << std::endl;
			}
			t_count++;

			switch ((Dispatch_plc_status) m_dispatch_plc_status)
			{
				case DISPATCH_PLC_READY:
				{
					if ( m_dispatch_process_type == Common_data::Dispatch_process_type::DISPATCH_PROCESS_TYPE_UNKNOW )
					{
						update_dispatch_plc_communication();
					}
					else
					{
//                        m_result = check_dispatch_request_msg(m_dispatch_request_msg);
						//收到新指令, 进入工作阶段,强制清空错误码.
						m_result.error_manager_clear_all();
						if(m_result == Error_code::SUCCESS)
						{
							m_dispatch_plc_status = DISPATCH_PLC_REQUEST;
						}
						else
						{
							m_dispatch_plc_status = DISPATCH_PLC_RESPONSE;
						}
					}
					break;
				}
				case DISPATCH_PLC_REQUEST://给plc发送请求
				{
					//收到新指令, 进入工作阶段,强制清空错误码.
					m_result.error_manager_clear_all();
#ifdef PLC_OVER_TIME_TO_ERROR
					if ( std::chrono::system_clock::now() - m_start_time > std::chrono::milliseconds(m_timeout_ms) )
					{
						//超时直接报错
						m_result = Error_manager(Error_code::DISPATCH_PLC_TIME_OUT, Error_level::MINOR_ERROR,
												 " DISPATCH_PLC_TIME_OUT fun error ");
						m_dispatch_plc_status = DISPATCH_PLC_RESPONSE;
					}
					else
#endif
					{
						//封装 给plc的调度请求
//						m_result = encapsulate_dispatch_request_to_plc();
						m_result = encapsulate_dispatch_request_to_plc_new();
						test_start_time = std::chrono::system_clock::now();
						m_result = Error_code::SUCCESS;
						if ( m_result == Error_code::SUCCESS )
						{
							m_dispatch_plc_status = DISPATCH_PLC_WORKING;
						}
						else
						{
							m_dispatch_plc_status = DISPATCH_PLC_RESPONSE;
						}
					}
					break;
				}
				case DISPATCH_PLC_WORKING:
				{
#ifdef PLC_OVER_TIME_TO_ERROR
					if ( std::chrono::system_clock::now() - m_start_time > std::chrono::milliseconds(m_timeout_ms) )
					{
						//超时直接报错
						m_result =  Error_manager(Error_code::DISPATCH_PLC_TIME_OUT, Error_level::MINOR_ERROR,
												  " DISPATCH_PLC_TIME_OUT fun error ");
						m_dispatch_plc_status = DISPATCH_PLC_RESPONSE;
					}
					else
#endif
					{
						update_dispatch_plc_communication();
						//检查plc答复反馈
//						m_result = check_response_from_plc();
						m_result = check_response_from_plc_new();
						if ( m_result == Error_code::SUCCESS )
						{
							m_dispatch_plc_status = DISPATCH_PLC_RESPONSE;
						}
						else if ( m_result != Error_code::NODATA )
						{
							//		m_dispatch_plc_status = DISPATCH_PLC_FAULT;
							m_dispatch_plc_status = DISPATCH_PLC_RESPONSE;

						}
						//else NODATA 原地等待
					}
					break;
				}
				case DISPATCH_PLC_RESPONSE:
				{
					test_end_time = std::chrono::system_clock::now();
					auto time_dur = test_end_time - test_start_time;
					if ( time_dur < std::chrono::seconds(2) )
					{
						LOG(INFO) << " dispatch completed, time is too short, press any key to continue =  "<< time_dur.count() << " --- " << this;
//					    getchar();
					}

					//20211213. huli m_request_status = 0 after over process
					m_request_status = 0;
					clear_request_msg();

					//发送调度答复信息给主控
//					send_dispatch_response_to_main_control();
//					send_dispatch_response_to_main_control_new();
					//无论前面的流程是否正确,都要给主控答复, 反馈里面填充错误码即可.

					//最新版本不用答复消息, Dispatch_plc 切回 DISPATCH_PLC_READY 后, 由 Dispatch_manager 答复数据库




					if ( m_result == Error_code::SUCCESS )
					{
						/*
						//response add to  _map
						if ( m_dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_STORE_CAR )
						{
							std::unique_lock<std::mutex> t_lock(Dispatch_manager::get_instance_references().m_lock);
							std::chrono::system_clock::time_point t_time = std::chrono::system_clock::now();
							Dispatch_manager::get_instance_references().m_dispatch_response_store_map[t_time] = m_dispatch_response_msg;
							Dispatch_manager::get_instance_references().m_store_updata_time = std::chrono::system_clock::now();
						}
						else if( m_dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_PICKUP_CAR )
						{
							std::unique_lock<std::mutex> t_lock(Dispatch_manager::get_instance_references().m_lock);
							int t_terminal_id = m_dispatch_request_msg.id_struct().terminal_id();
							Dispatch_manager::get_instance_references().m_dispatch_response_pickup_map[t_terminal_id] = m_dispatch_response_msg;
							Dispatch_manager::get_instance_references().m_pickup_updata_time = std::chrono::system_clock::now();
						}
						 */
						//流程正常结束, 恢复到待机状态.
						m_dispatch_plc_status = DISPATCH_PLC_READY;
						m_dispatch_process_type = Common_data::Dispatch_process_type::DISPATCH_PROCESS_TYPE_UNKNOW;
//						m_result.error_manager_clear_all();
					}
					else
					{
						//流程异常结束, 进入到故障状态.
						m_dispatch_plc_status = DISPATCH_PLC_FAULT;
					}
					break;
				}
				case DISPATCH_PLC_FAULT:
				case DISPATCH_PLC_DISCONNECT:
				{
					//20211213. huli m_request_status = 0 after over process
					m_request_status = 0;
					clear_request_msg();

					//不在接受新的任务,但是保持基本的通信正常
					update_dispatch_plc_communication();
/*
					//response add to  _map
					if ( m_dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_STORE_CAR )
					{
						std::unique_lock<std::mutex> t_lock(Dispatch_manager::get_instance_references().m_lock);
						std::chrono::system_clock::time_point t_time = std::chrono::system_clock::now();
						Dispatch_manager::get_instance_references().m_dispatch_response_store_map[t_time] = m_dispatch_response_msg;
						Dispatch_manager::get_instance_references().m_store_updata_time = std::chrono::system_clock::now();
					}
					else if( m_dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_PICKUP_CAR )
					{
						std::unique_lock<std::mutex> t_lock(Dispatch_manager::get_instance_references().m_lock);
						int t_terminal_id = m_dispatch_request_msg.id_struct().terminal_id();
						Dispatch_manager::get_instance_references().m_dispatch_response_pickup_map[t_terminal_id] = m_dispatch_response_msg;
						Dispatch_manager::get_instance_references().m_pickup_updata_time = std::chrono::system_clock::now();
					}
					*/
					//20211209 huli //流程异常结束, 进入到 ready.
					m_dispatch_plc_status = DISPATCH_PLC_READY;
					m_dispatch_process_type = Common_data::Dispatch_process_type::DISPATCH_PROCESS_TYPE_UNKNOW;
//					m_result.error_manager_clear_all();
					LOG(ERROR) << " Dispatch_plc::execute_thread_fun() dispatch_plc is fault, now recover to normal " << this;

					break;
				}
			}
		}

	}
}

//数据储存线程函数
void Dispatch_plc::data_storage_thread_fun()
{
	LOG(INFO) << " Dispatch_plc::data_storage_thread_fun() start " << this;
	Error_manager t_error;

	while (m_data_storage_condition.is_alive())
	{
		m_data_storage_condition.wait();
		if (m_data_storage_condition.is_alive())
		{
			std::this_thread::sleep_for(std::chrono::microseconds(1));
			std::this_thread::sleep_for(std::chrono::milliseconds(1));
			std::this_thread::sleep_for(std::chrono::seconds(1));

			std::this_thread::yield();
//			std::unique_lock<std::mutex> t_lock(m_lock);


//			char buf[16] = {0};	//数据转字符串然后存数据库
//			std::string t_plc_data_string;
//			float t_heartbeat = Dispatch_communication::get_instance_references().m_data_storage_from_plc_to_manager.m_heartbeat;
//			{
//				std::unique_lock<std::mutex> t_lock1(Dispatch_communication::get_instance_references().m_data_lock);
//				char * tp = buf;
//				for (int i = 0; i < DATA_STORAGE_PLC_DATA_LENGTH; ++i)
//				{
//					sprintf(buf, "%g\t", Dispatch_communication::get_instance_references().m_data_storage_from_plc_to_manager.m_plc_data[i]);
//					t_plc_data_string += buf;
//				}
////				std::cout << " huli test :::: " << " t_plc_data_string = " << t_plc_data_string << std::endl;
//			}
//
//			Dispatch_manager::get_instance_references().m_dispatch_command.insert_plc_data(t_plc_data_string, t_heartbeat);


		}
	}
}

//封装 给plc的调度请求
Error_manager Dispatch_plc::encapsulate_dispatch_request_to_plc()
{
//	//把m_dispatch_request_msg的信息传给本地的数据缓存.
//	std::unique_lock<std::mutex> t_lock(m_lock);
//	m_request_key = m_dispatch_request_msg.command_key();
//	m_request_status = 1;
//	if ( m_dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_STORE_CAR )
//	{
//		m_request_dispatch_motion_direction = Common_data::Dispatch_motion_direction::DISPATCH_MOTION_DIRECTION_STORE;
//		m_request_passageway_direction = Common_data::Passageway_direction::PASSAGEWAY_DIRECTION_INLET;
//		m_request_passageway_id = m_dispatch_request_msg.mutable_id_struct()->terminal_id()+1;//0~5入口终端号改为1~6
//	}
//	else if( m_dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_PICKUP_CAR )
//	{
//		m_request_dispatch_motion_direction = Common_data::Dispatch_motion_direction::DISPATCH_MOTION_DIRECTION_PICKUP;
//		m_request_passageway_direction = Common_data::Passageway_direction::PASSAGEWAY_DIRECTION_OUTLET;
//		m_request_passageway_id = m_dispatch_request_msg.mutable_id_struct()->terminal_id()+1;//0~5入口终端号改为1~6
//
//	}
//	else
//	{
//		m_request_dispatch_motion_direction = Common_data::Dispatch_motion_direction::DISPATCH_MOTION_DIRECTION_UNKNOWN;
//		m_request_passageway_direction = Common_data::Passageway_direction::PASSAGEWAY_DIRECTION_UNKNOWN;
//		m_request_passageway_id = -1;
//	}
//
//	if ( m_dispatch_request_msg.locate_information().locate_correct() )
//	{
//		m_request_car_center_x = m_dispatch_request_msg.locate_information().locate_x();
//		m_request_car_center_y = m_dispatch_request_msg.locate_information().locate_y();
//#ifdef MEASURE_TO_PLC_CORRECTION
//		m_request_car_angle = m_dispatch_request_msg.locate_information().locate_angle()-90+0.3;//80~100改为-10~+10
//#endif
//#ifndef MEASURE_TO_PLC_CORRECTION
//		m_request_car_angle = m_dispatch_request_msg.locate_information().locate_angle();
//#endif
//		m_request_car_front_theta = m_dispatch_request_msg.locate_information().locate_front_theta();
//		m_request_car_length = m_dispatch_request_msg.locate_information().locate_length();
//		m_request_car_width = m_dispatch_request_msg.locate_information().locate_width();
//		m_request_car_height = m_dispatch_request_msg.locate_information().locate_height();
//		m_request_car_wheel_base = m_dispatch_request_msg.locate_information().locate_wheel_base();
//		m_request_car_wheel_width = m_dispatch_request_msg.locate_information().locate_wheel_width();
//		m_request_uniformed_car_x = m_dispatch_request_msg.locate_information().uniformed_car_x();
//		m_request_uniformed_car_y = m_dispatch_request_msg.locate_information().uniformed_car_y();
//	}
//	else
//	{
//		m_request_car_center_x = m_dispatch_request_msg.locate_information().locate_x();
//		m_request_car_center_y = m_dispatch_request_msg.locate_information().locate_y();
//#ifdef MEASURE_TO_PLC_CORRECTION
//		m_request_car_angle = m_dispatch_request_msg.locate_information().locate_angle()-90+0.3;//80~100改为-10~+10
//#endif
//#ifndef MEASURE_TO_PLC_CORRECTION
//		m_request_car_angle = m_dispatch_request_msg.locate_information().locate_angle();
//#endif
//		m_request_car_front_theta = m_dispatch_request_msg.locate_information().locate_front_theta();
//		m_request_car_length = m_dispatch_request_msg.locate_information().locate_length();
//		m_request_car_width = m_dispatch_request_msg.locate_information().locate_width();
//		m_request_car_height = m_dispatch_request_msg.locate_information().locate_height();
//		m_request_car_wheel_base = m_dispatch_request_msg.locate_information().locate_wheel_base();
//		m_request_car_wheel_width = m_dispatch_request_msg.locate_information().locate_wheel_width();
//		m_request_uniformed_car_x = m_dispatch_request_msg.locate_information().uniformed_car_x();
//		m_request_uniformed_car_y = m_dispatch_request_msg.locate_information().uniformed_car_y();
//	}
//
//	if ( m_dispatch_request_msg.parkspace_info_ex_size() ==1 )
//	{
//		m_request_parkingspace_index_id = m_dispatch_request_msg.parkspace_info_ex(0).parkingspace_index_id();
//		m_request_parkingspace_unit_id = m_dispatch_request_msg.parkspace_info_ex(0).parkingspace_unit_id()+1;//0~2单元号改为1~3
//		m_request_parkingspace_label_id = m_dispatch_request_msg.parkspace_info_ex(0).parkingspace_label_id();
//		m_request_parkingspace_floor_id = m_dispatch_request_msg.parkspace_info_ex(0).parkingspace_floor_id();
//		m_request_parkingspace_room_id = m_dispatch_request_msg.parkspace_info_ex(0).parkingspace_room_id();
//		//车位朝向, 小号朝前朝南, 大号朝后朝北
//		m_request_parkingspace_direction = (Common_data::Parkingspace_direction)m_dispatch_request_msg.parkspace_info_ex(0).parkingspace_direction();
//
//
//		//20211220, utf-8 -> GBK
//		m_request_car_license = String_convert::utf8_to_gbk( m_dispatch_request_msg.parkspace_info_ex(0).car_info().car_numberplate() );
//
//		m_request_car_type = (Common_data::Car_type)m_dispatch_request_msg.parkspace_info_ex(0).car_type();
//
//		//20211207, huli add wheel_base   for pickup_car
//        if( m_dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_PICKUP_CAR )
//        {
//            m_request_car_wheel_base = m_dispatch_request_msg.parkspace_info_ex(0).car_info().car_wheel_base();
//            m_request_car_wheel_width = m_dispatch_request_msg.parkspace_info_ex(0).car_info().car_wheel_width();
//        }
//	}
//	else
//	{
//		return Error_manager(Error_code::DISPATCH_PLC_REQUEST_ERROR, Error_level::MINOR_ERROR,
//							 " m_dispatch_request_msg.parkspace_info_ex_size() !=1 error ");
//	}

	return Error_code::SUCCESS;
}


//封装 给plc的调度请求
Error_manager Dispatch_plc::encapsulate_dispatch_request_to_plc_new()
{
	//把m_dispatch_request_msg的信息传给本地的数据缓存.
	std::unique_lock<std::mutex> t_lock(m_lock);

	m_request_key = m_command_key;
	m_request_status = 1;
	if ( m_dispatch_process_type == Common_data::Dispatch_process_type::DISPATCH_PROCESS_STORE ||
		 m_dispatch_process_type == Common_data::Dispatch_process_type::DISPATCH_PROCESS_REALLOCATE)
	{
		//基本信息
		m_request_dispatch_motion_direction = m_dispatch_process_type;
		m_request_passageway_direction = Common_data::Passageway_direction::PASSAGEWAY_DIRECTION_INLET;
		m_request_passageway_id = m_park_table_msg.terminal_id();

//		m_request_passageway_id = m_terminal_id;
		//感测雷达信息, 存车专有
//		if ( m_park_table_msg.entrance_measure_info().border_statu() )
		if ( true )
		{
			m_request_car_center_x = m_park_table_msg.entrance_measure_info().measure_info_to_plc_forward().cx();
			m_request_car_center_y = m_park_table_msg.entrance_measure_info().measure_info_to_plc_forward().cy();
			m_request_car_angle = m_park_table_msg.entrance_measure_info().measure_info_to_plc_forward().theta();
			m_request_car_front_theta = m_park_table_msg.entrance_measure_info().measure_info_to_plc_forward().front_theta();
			m_request_car_length = m_park_table_msg.entrance_measure_info().measure_info_to_plc_forward().length();
			m_request_car_width = m_park_table_msg.entrance_measure_info().measure_info_to_plc_forward().width();
			m_request_car_height = m_park_table_msg.entrance_measure_info().measure_info_to_plc_forward().height();
			m_request_car_wheel_base = m_park_table_msg.entrance_measure_info().measure_info_to_plc_forward().wheelbase();
			m_request_car_wheel_width = m_park_table_msg.entrance_measure_info().measure_info_to_plc_forward().width();
			m_request_uniformed_car_x = m_park_table_msg.entrance_measure_info().measure_info_to_plc_forward().cx();
			m_request_uniformed_car_y = m_park_table_msg.entrance_measure_info().measure_info_to_plc_forward().cy();

			m_request_car_center_x2 = m_park_table_msg.entrance_measure_info().measure_info_to_plc_reverse().cx();
			m_request_car_center_y2 = m_park_table_msg.entrance_measure_info().measure_info_to_plc_reverse().cy();
			m_request_car_angle2 = m_park_table_msg.entrance_measure_info().measure_info_to_plc_reverse().theta();
			m_request_car_front_theta2 = m_park_table_msg.entrance_measure_info().measure_info_to_plc_reverse().front_theta();
			m_request_car_length2 = m_park_table_msg.entrance_measure_info().measure_info_to_plc_reverse().length();
			m_request_car_width2 = m_park_table_msg.entrance_measure_info().measure_info_to_plc_reverse().width();
			m_request_car_height2 = m_park_table_msg.entrance_measure_info().measure_info_to_plc_reverse().height();
			m_request_car_wheel_base2 = m_park_table_msg.entrance_measure_info().measure_info_to_plc_reverse().wheelbase();
			m_request_car_wheel_width2 = m_park_table_msg.entrance_measure_info().measure_info_to_plc_reverse().width();
			m_request_uniformed_car_x2 = m_park_table_msg.entrance_measure_info().measure_info_to_plc_reverse().cx();
			m_request_uniformed_car_y2 = m_park_table_msg.entrance_measure_info().measure_info_to_plc_reverse().cy();
		}

		//车位信息
		m_request_parkingspace_index_id = m_park_table_msg.allocated_space_info().id();
		m_request_parkingspace_unit_id = m_park_table_msg.allocated_space_info().unit_id();
//		int t_parkingspace_label_id = (m_park_table_msg.allocated_space_info().id() - 1 )%78;
//		m_request_parkingspace_label_id = t_parkingspace_label_id+1;
		m_request_parkingspace_label_id = m_park_table_msg.allocated_space_info().table_id();
//		LOG(INFO) << " huli  m_request_parkingspace_label_id = " << m_request_parkingspace_label_id<< "     "<< this;
		m_request_parkingspace_floor_id = m_park_table_msg.allocated_space_info().floor();
		m_request_parkingspace_room_id = m_park_table_msg.allocated_space_info().room_id();

//		if(0 == m_request_car_height)
//		{
//			m_request_car_height_level = 0;
//		}
//		else if ( 0 < m_request_car_height && m_request_car_height <= CAR_HEIGHT_LIMIT_SMALL +0.000001)
//		{
//			m_request_car_height_level = 1;
//		}
//		else if ( CAR_HEIGHT_LIMIT_SMALL+0.000001 < m_request_car_height && m_request_car_height <= CAR_HEIGHT_LIMIT_MIDDLE+0.000001 )
//		{
//			m_request_car_height_level = 2;
//		}
//		else if ( CAR_HEIGHT_LIMIT_MIDDLE+0.000001 < m_request_car_height && m_request_car_height <= CAR_HEIGHT_LIMIT_BIG+0.000001 )
//		{
//			m_request_car_height_level = 3;
//		}
//		else if ( CAR_HEIGHT_LIMIT_BIG+0.000001 < m_request_car_height  )
//		{
//			m_request_car_height_level = 4;
//		}
		m_request_height_level = m_height_level;
		m_request_wheel_base_level = m_wheel_base_level;


		//车位朝向, 奇数朝南, 偶数朝北
		if ( m_request_parkingspace_room_id %6 == 1 || m_request_parkingspace_room_id %6 == 2 || m_request_parkingspace_room_id %6 == 3   )
		{
			m_request_parkingspace_direction = Common_data::Parkingspace_direction::PARKINGSPACE_DIRECTION_SOUTH;
		}
		else
		{
			m_request_parkingspace_direction = Common_data::Parkingspace_direction::PARKINGSPACE_DIRECTION_NORTH;
		}

#ifdef CHUTIAN_PROJECT_PROJECT
		//20211220, utf-8 -> GBK
		m_request_car_license = String_convert::utf8_to_gbk( m_park_table_msg.car_number() );
#endif //CHUTIAN_PROJECT_PROJECT
#ifdef SHANGGUJIE_PROJECT_PROJECT
		m_request_car_license = String_convert::utf8_to_gbk( m_park_table_msg.car_number() );
		LOG(INFO) << " m_request_car_license =  "<< m_request_car_license <<"  ----  - - - "<< this;
#endif //SHANGGUJIE_PROJECT_PROJECT


		m_request_height_level = m_height_level;
		m_request_wheel_base_level = m_wheel_base_level;
	}
	else if( m_dispatch_process_type == Common_data::Dispatch_process_type::DISPATCH_PROCESS_PICKUP ||
			 m_dispatch_process_type == Common_data::Dispatch_process_type::DISPATCH_PROCESS_REVOCATION||
			 m_dispatch_process_type == Common_data::Dispatch_process_type::DISPATCH_PROCESS_REVOCATION_EX)
	{
		m_request_dispatch_motion_direction = m_dispatch_process_type;
		m_request_passageway_direction = Common_data::Passageway_direction::PASSAGEWAY_DIRECTION_OUTLET;
		m_request_passageway_id = m_pick_table_msg.terminal_id();
//		m_request_passageway_id = m_terminal_id;

		//20211207, 取车专有, 数据库保存的汽车信息, 轮距
		m_request_car_center_x = m_pick_table_msg.actually_measure_info().measure_info_to_plc_forward().cx();
		m_request_car_center_y = m_pick_table_msg.actually_measure_info().measure_info_to_plc_forward().cy();
		m_request_car_angle = m_pick_table_msg.actually_measure_info().measure_info_to_plc_forward().theta();
		m_request_car_front_theta = m_pick_table_msg.actually_measure_info().measure_info_to_plc_forward().front_theta();
		m_request_car_length = m_pick_table_msg.actually_measure_info().measure_info_to_plc_forward().length();
		m_request_car_width = m_pick_table_msg.actually_measure_info().measure_info_to_plc_forward().width();
		m_request_car_height = m_pick_table_msg.actually_measure_info().measure_info_to_plc_forward().height();
		m_request_car_wheel_base = m_pick_table_msg.actually_measure_info().measure_info_to_plc_forward().wheelbase();
		m_request_car_wheel_width = m_pick_table_msg.actually_measure_info().measure_info_to_plc_forward().width();
		m_request_uniformed_car_x = m_pick_table_msg.actually_measure_info().measure_info_to_plc_forward().cx();
		m_request_uniformed_car_y = m_pick_table_msg.actually_measure_info().measure_info_to_plc_forward().cy();

		m_request_car_center_x2 = m_pick_table_msg.actually_measure_info().measure_info_to_plc_reverse().cx();
		m_request_car_center_y2 = m_pick_table_msg.actually_measure_info().measure_info_to_plc_reverse().cy();
		m_request_car_angle2 = m_pick_table_msg.actually_measure_info().measure_info_to_plc_reverse().theta();
		m_request_car_front_theta2 = m_pick_table_msg.actually_measure_info().measure_info_to_plc_reverse().front_theta();
		m_request_car_length2 = m_pick_table_msg.actually_measure_info().measure_info_to_plc_reverse().length();
		m_request_car_width2 = m_pick_table_msg.actually_measure_info().measure_info_to_plc_reverse().width();
		m_request_car_height2 = m_pick_table_msg.actually_measure_info().measure_info_to_plc_reverse().height();
		m_request_car_wheel_base2 = m_pick_table_msg.actually_measure_info().measure_info_to_plc_reverse().wheelbase();
		m_request_car_wheel_width2 = m_pick_table_msg.actually_measure_info().measure_info_to_plc_reverse().width();
		m_request_uniformed_car_x2 = m_pick_table_msg.actually_measure_info().measure_info_to_plc_reverse().cx();
		m_request_uniformed_car_y2 = m_pick_table_msg.actually_measure_info().measure_info_to_plc_reverse().cy();

		//车位信息
		m_request_parkingspace_index_id = m_pick_table_msg.actually_space_info().id();
		m_request_parkingspace_unit_id = m_pick_table_msg.actually_space_info().unit_id();
//		int t_parkingspace_label_id = (m_pick_table_msg.actually_space_info().id() -1 )%78;
//		m_request_parkingspace_label_id = t_parkingspace_label_id +1 ;
		m_request_parkingspace_label_id = m_pick_table_msg.actually_space_info().table_id();


		m_request_parkingspace_floor_id = m_pick_table_msg.actually_space_info().floor();
		m_request_parkingspace_room_id = m_pick_table_msg.actually_space_info().room_id();

//		if(0 == m_request_car_height)
//		{
//			m_request_car_height_level = 0;
//		}
//		else if ( 0 < m_request_car_height && m_request_car_height <= CAR_HEIGHT_LIMIT_SMALL +0.000001)
//		{
//			m_request_car_height_level = 1;
//		}
//		else if ( CAR_HEIGHT_LIMIT_SMALL +0.000001< m_request_car_height && m_request_car_height <= CAR_HEIGHT_LIMIT_MIDDLE +0.000001)
//		{
//			m_request_car_height_level = 2;
//		}
//		else if ( CAR_HEIGHT_LIMIT_MIDDLE +0.000001< m_request_car_height && m_request_car_height <= CAR_HEIGHT_LIMIT_BIG +0.000001)
//		{
//			m_request_car_height_level = 3;
//		}
//		else if ( CAR_HEIGHT_LIMIT_BIG +0.000001< m_request_car_height  )
//		{
//			m_request_car_height_level = 4;
//		}

		m_request_height_level = m_height_level;
		m_request_wheel_base_level = m_wheel_base_level;
		//车位朝向, 奇数朝南, 偶数朝北
		if ( m_request_parkingspace_index_id %2 == 1 )
		{
			m_request_parkingspace_direction = Common_data::Parkingspace_direction::PARKINGSPACE_DIRECTION_SOUTH;
		}
		else
		{
			m_request_parkingspace_direction = Common_data::Parkingspace_direction::PARKINGSPACE_DIRECTION_NORTH;
		}

#ifdef CHUTIAN_PROJECT_PROJECT
		//20211220, utf-8 -> GBK
		m_request_car_license = String_convert::utf8_to_gbk( m_park_table_msg.car_number() );
#endif //CHUTIAN_PROJECT_PROJECT
#ifdef SHANGGUJIE_PROJECT_PROJECT
		m_request_car_license = String_convert::utf8_to_gbk( m_pick_table_msg.car_number() );
		LOG(INFO) << " m_request_car_license =  "<< m_request_car_license <<"  ----  - - - "<< this;

#endif //SHANGGUJIE_PROJECT_PROJECT

		m_request_height_level = m_height_level;
		m_request_wheel_base_level = m_wheel_base_level;
	}
	else
	{
		m_request_dispatch_motion_direction = Common_data::Dispatch_process_type::DISPATCH_PROCESS_TYPE_UNKNOW;
		m_request_passageway_direction = Common_data::Passageway_direction::PASSAGEWAY_DIRECTION_UNKNOWN;
		m_request_passageway_id = -1;
	}

	return Error_code::SUCCESS;
}

//更新plc通信
Error_manager Dispatch_plc::update_dispatch_plc_communication()
{
	std::unique_lock<std::mutex> t_lock(m_lock);
	std::unique_lock<std::mutex> t_lock1(Dispatch_communication::get_instance_references().m_data_lock);


	//状态消息, plc->调度
	Dispatch_communication::Dispatch_plc_status_from_plc_to_manager * tp_dispatch_plc_status_from_plc_to_manager =
	& Dispatch_communication::get_instance_references().m_dispatch_plc_status_from_plc_to_manager;
	//状态消息, 调度->plc
	Dispatch_communication::Dispatch_plc_status_from_manager_to_plc * tp_dispatch_plc_status_from_manager_to_plc =
	& Dispatch_communication::get_instance_references().m_dispatch_plc_status_from_manager_to_plc;
	//载车板消息, plc->调度
	Dispatch_communication::Carry_board_status_from_plc_to_manager * tp_carry_board_status_from_plc_to_manager =
	& Dispatch_communication::get_instance_references().m_carry_board_status_from_plc_to_manager;
	//载车板消息, 调度->plc
	Dispatch_communication::Carry_board_control_from_manager_to_plc * tp_carry_board_control_from_manager_to_plc =
	& Dispatch_communication::get_instance_references().m_carry_board_control_from_manager_to_plc;

	memcpy(&m_dispatch_plc_status_from_plc_to_manager, tp_dispatch_plc_status_from_plc_to_manager, sizeof(Dispatch_communication::Dispatch_plc_status_from_plc_to_manager));
	memcpy(&m_carry_board_status_from_plc_to_manager, tp_carry_board_status_from_plc_to_manager, sizeof(Dispatch_communication::Carry_board_status_from_plc_to_manager));

	for (int i = 0; i < 2; ++i)
	{

		int t_car_height_level = 0;
		if ( m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[i].m_sensor_2 == 0x3F )
		{
			t_car_height_level = 0;
		}
		else if ( m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[i].m_sensor_2 == 0x3C )
		{
			t_car_height_level = 1;
		}
		else if ( m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[i].m_sensor_2 == 0x30 )
		{
			t_car_height_level = 2;
		}
		else if ( m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[i].m_sensor_2 == 0x00 )
		{
			t_car_height_level = 3;
		}
		else
		{
			t_car_height_level = 4;
		}
		m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[i].m_car_height = t_car_height_level;
	}



	//判断心跳
	if ( tp_dispatch_plc_status_from_plc_to_manager->m_plc_heartbeat == m_last_heartbeat )
	{
		if ( std::chrono::system_clock::now() - m_last_update_time > std::chrono::seconds(3)  )
		{
			m_plc_communication_status = false;
			std::cout << " huli test :::: " << "---------------------------------------------------------- tp_dispatch_plc_status_from_plc_to_manager->m_plc_heartbeat = " << tp_dispatch_plc_status_from_plc_to_manager->m_plc_heartbeat << std::endl;
			Dispatch_communication::get_instance_references().set_snap7_communication_statu(Snap7_communication_base::SNAP7_COMMUNICATION_DISCONNECT);
			m_last_update_time = std::chrono::system_clock::now();
		}
		//else 继续等待
	}
	else //plc状态 数据正常保存
	{
		m_plc_communication_status = true;
		m_last_heartbeat = tp_dispatch_plc_status_from_plc_to_manager->m_plc_heartbeat;
		m_last_update_time = std::chrono::system_clock::now();
		memcpy(&m_dispatch_plc_status_from_plc_to_manager, tp_dispatch_plc_status_from_plc_to_manager, sizeof(Dispatch_communication::Dispatch_plc_status_from_plc_to_manager));
		memcpy(&m_carry_board_status_from_plc_to_manager, tp_carry_board_status_from_plc_to_manager, sizeof(Dispatch_communication::Carry_board_status_from_plc_to_manager));
	}


	//plc通信正常且为自动模式，自动门控逻辑代码
	if ( m_plc_communication_status == true && (m_dispatch_plc_status_from_plc_to_manager.m_plc_mode_status & 0x04) == 0x04 )
	{
		m_dispatch_plc_status_from_manager_to_plc.m_dispatch_heartbeat++;

		//1号双向口
		//外门逻辑
		if(m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_1 == 0x19
		   && (m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_2 & 0x3F == 0x3F)
		   && m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_inside_door_status == 2
		   && m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_outside_door_status == 2)
		{
			//如果地感有车，入口没有车，内门关闭，外门关闭，，，那么控制外门打开
			m_dispatch_plc_status_from_manager_to_plc.m_entry1_outside_door_control = 1;
		}
		//入口终端机点击存车成功后，会触发外门关闭指令。
		//调度取车任务完成时，检查数据库和plc状态
		// 这里涉及到数据库操作, 放慢一些
		static int t_count_test1 = 0;
		if (t_count_test1 % 1000 == 0 )
		{
			//检查出口取车是否完成, 如果取车完成
			if ( Dispatch_manager::get_instance_references().m_dispatch_command.check_pickup_is_finish(m_plc_id, 1) == Error_code::SUCCESS )
			{
				//检测出口是否有车,
				if ( (m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_2 & 0x03) == 0x00)
				{
					if ( m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_inside_door_status == 2
						 && m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_outside_door_status == 2 )
					{
						//如果有车，并且内门关闭， 就打开外门
						m_dispatch_plc_status_from_manager_to_plc.m_entry1_outside_door_control = 1;
					}
					//else 无限等待
				}
				else
				{
					//如果没有车, 直接清除数据库的指令
					Dispatch_manager::get_instance_references().m_dispatch_command.delete_command_queue_for_export_id(m_plc_id, 1);
				}
			}
			//else 无限等待
		}
		t_count_test1++;

		//长时间没有车，那么自动关门。
		static auto s_entry1_outside_door_control_time = std::chrono::system_clock::now();
		if ( m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_1 == 0x18
			 && (m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_2 & 0x3F == 0x3F)
			 && m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_outside_door_status == 1	)
		{
			if ( std::chrono::system_clock::now() - s_entry1_outside_door_control_time > std::chrono::seconds(3) )
			{
				//如果地感无车，入口没有车，内门打开，并且超时，，那么控制外门关闭
				m_dispatch_plc_status_from_manager_to_plc.m_entry1_outside_door_control = 2;
			}
		}
		else
		{
			s_entry1_outside_door_control_time = std::chrono::system_clock::now();
		}
		//长时间没有车，那么自动关门。
		static auto s_entry1_inside_door_control_time = std::chrono::system_clock::now();
		if ( (m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_1 & 0x18) == 0x18
			 && (m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_2 & 0x3F == 0x3F)
			 && m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_inside_door_status == 1
			 && Dispatch_manager::get_instance_references().m_dispatch_process_type != Common_data::Dispatch_process_type::DISPATCH_PROCESS_PICKUP)
		{
			if ( std::chrono::system_clock::now() - s_entry1_inside_door_control_time > std::chrono::seconds(10) )
			{
				//如果地感无车，入口没有车，内门打开，并且超时，，那么控制nei门关闭
				m_dispatch_plc_status_from_manager_to_plc.m_entry1_inside_door_control = 2;
			}
		}
		else
		{
			s_entry1_inside_door_control_time = std::chrono::system_clock::now();
		}

		//清除任务残留
		if ( m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_outside_door_status == 1
			 && m_dispatch_plc_status_from_manager_to_plc.m_entry1_outside_door_control == 1)
		{
			m_dispatch_plc_status_from_manager_to_plc.m_entry1_outside_door_control =0;
		}
		if ( m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_outside_door_status == 2
			 && m_dispatch_plc_status_from_manager_to_plc.m_entry1_outside_door_control == 2)
		{
			m_dispatch_plc_status_from_manager_to_plc.m_entry1_outside_door_control =0;
		}

		//内门逻辑
		//调度执行存车和取车指令时，都会触发内门打开指令。
		//调度完成存车和取车指令时，都会触发内门关闭指令。
		//这里不用自动控制内门

		//清除任务残留
		if ( m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_inside_door_status == 1
			 && m_dispatch_plc_status_from_manager_to_plc.m_entry1_inside_door_control == 1)
		{
			m_dispatch_plc_status_from_manager_to_plc.m_entry1_inside_door_control =0;
		}
		if ( m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_inside_door_status == 2
			 && m_dispatch_plc_status_from_manager_to_plc.m_entry1_inside_door_control == 2)
		{
			m_dispatch_plc_status_from_manager_to_plc.m_entry1_inside_door_control =0;
		}

		//检查车是否被plc搬走 ，外门关闭，内门打开，入口从有车变为无车。就解除安全锁。
		if ( m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_outside_door_status == 2 &&
			 m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_inside_door_status == 1 )
		{
			if ( (m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_2 & 0x03) == 0x02 )
			{
				last_import_have_car[0] = 1;
			}
			if ( (m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_2 & 0x03) == 0x01 &&
				 last_import_have_car[0] == 1 )
			{
				last_import_have_car[0] = 0;
				park_safe_lock[0] = 0;
			}
		}




		//2号双向口
		//以后在写 need
	}



//	m_dispatch_plc_status_from_manager_to_plc.m_entry1_outside_door_control = 1;
//	m_dispatch_plc_status_from_manager_to_plc.m_entry1_inside_door_control = 1;

//	m_dispatch_plc_status_from_manager_to_plc.m_entry1_outside_door_control = 2;
//	m_dispatch_plc_status_from_manager_to_plc.m_entry1_inside_door_control = 2;

//	m_dispatch_plc_status_from_manager_to_plc.m_entry1_outside_door_control = 1;
//	m_dispatch_plc_status_from_manager_to_plc.m_entry1_inside_door_control = 2;

//	m_dispatch_plc_status_from_manager_to_plc.m_entry1_outside_door_control = 2;
//	m_dispatch_plc_status_from_manager_to_plc.m_entry1_inside_door_control = 1;

//	set_carry_board(147, 1);



//	std::this_thread::sleep_for(std::chrono::seconds(1));
//	LOG(INFO) << " m_dispatch_plc_status_from_plc_to_manager = ----------------------------------------------------------- "<< this;
//	LOG(INFO) << " 1 "<< " m_plc_heartbeat = " << (int)m_dispatch_plc_status_from_plc_to_manager.m_plc_heartbeat;
//	LOG(INFO) << " 1 "<< " m_plc_mode_status = " << (int)m_dispatch_plc_status_from_plc_to_manager.m_plc_mode_status;
//	LOG(INFO) << " 1 "<< " m_plc_passway_status = " << (int)m_dispatch_plc_status_from_plc_to_manager.m_plc_passway_status;
//	LOG(INFO) << " 1 "<< " m_plc_carrier_status = " << (int)m_dispatch_plc_status_from_plc_to_manager.m_plc_carrier_status;
//	LOG(INFO) << " 1 "<< " m_outside_door_status = " << (int)m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_outside_door_status;
//	LOG(INFO) << " 1 "<< " m_inside_door_status = " << (int)m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_inside_door_status;
//	LOG(INFO) << " 1 "<< " m_sensor_1 = " << (int)m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_1;
//	LOG(INFO) << " 1 "<< " m_sensor_2 = " << (int)m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_2;
//	LOG(INFO) << " 1 "<< " m_outside_door_status = " << (int)m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_outside_door_status;
//	LOG(INFO) << " 1 "<< " m_inside_door_status = " << (int)m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_inside_door_status;
//	LOG(INFO) << " 1 "<< " m_sensor_1 = " << (int)m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_1;
//	LOG(INFO) << " 1 "<< " m_sensor_2 = " << (int)m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_2;
//
//	LOG(INFO) << " m_dispatch_plc_status_from_plc_to_manager = -*******************************************************************- "<< this;
//	LOG(INFO) << " 1 "<< " m_entry1_outside_door_control = " << (int)m_dispatch_plc_status_from_manager_to_plc.m_entry1_outside_door_control;
//	LOG(INFO) << " 1 "<< " m_entry1_inside_door_control = " << (int)m_dispatch_plc_status_from_manager_to_plc.m_entry1_inside_door_control;
//	LOG(INFO) << " 1 "<< " m_entry2_outside_door_control = " << (int)m_dispatch_plc_status_from_manager_to_plc.m_entry2_outside_door_control;
//	LOG(INFO) << " 1 "<< " m_entry2_inside_door_control = " << (int)m_dispatch_plc_status_from_manager_to_plc.m_entry2_inside_door_control;


/*
    int rrr = 1;
	if ( rrr == 1 )
	{
		int b = 147;
		int m = 1;
		int tc= 0;

		get_carry_board_status(b,tc);
//		set_carry_board(140, 3);
//	get_carry_board(4,3,tc);
		LOG(INFO) << "get_carry_board  ************************************* tc = " << tc;
		if ( (tc == 1 && m == 2 ) || (tc == 2 && m == 1))
		{
			set_carry_board(b, m);
		}
		else
		{
			init_all_carry_board();
		}
	}
	else
	{
		reset_all_carry_board_ex();
	}
*/


	static int t_count_test3 = 0;
	if (t_count_test3 % 500 == 0 )
	{
//		{
//			int t_control_0 = 0;
//			get_carry_board_control(t_space_id,t_control_0);
//			int t_status_0 = 0;
//			get_carry_board_status(t_space_id,t_status_0);
//			int t_board_unit = m_carry_board_coordinate_map[t_space_id].m_carry_board_control_buf_index;
//			int t_status_1 = m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_board_unit-1].carry_board_data[1];
//			int t_status_16 = m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_board_unit-1].carry_board_data[16];
//			int t_status_17 = m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[t_board_unit-1].carry_board_data[17];
//
//			LOG(INFO) << "get_carry_board  ********************** t_space_id =  "<<t_space_id<<" , " << t_board_control<<" , "<< t_control_0<<" , " << t_status_0<<"  ...............  " << t_status_1<<" , " << t_status_16<<" , " << t_status_17;
//
//		}

		//获取载车板 的相关数据
		m_carry_board_control_buf_index = m_carry_board_coordinate_map[m_carry_board_space_id].m_carry_board_control_buf_index;
		m_carry_board_control_data_index = m_carry_board_coordinate_map[m_carry_board_space_id].m_carry_board_control_buf_index;
		get_carry_board_control(m_carry_board_space_id, m_carry_board_control);
		get_carry_board_status(m_carry_board_space_id, m_carry_board_status);
		m_carry_board_status_0 = m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[
		m_carry_board_control_buf_index - 1].carry_board_data[0];
		m_carry_board_status_1 = m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[
		m_carry_board_control_buf_index - 1].carry_board_data[1];
		m_carry_board_status_16 = m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[
		m_carry_board_control_buf_index - 1].carry_board_data[16];
		m_carry_board_status_17 = m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[
		m_carry_board_control_buf_index - 1].carry_board_data[17];
		LOG(INFO) << "get_carry_board  ********************************************* =  "
				  << m_carry_board_space_id << "  " << m_carry_board_control_buf_index << "  " << m_carry_board_control_data_index << "  "
				  << " ,,,,,,, "
				  << m_carry_board_target << "  " << m_carry_board_control << "  " << m_carry_board_status << "  "
				  << " ,,,,,,, "
				  << m_carry_board_flag << "  " << m_carry_board_status_0 << "  " << m_carry_board_status_1 << "  " << m_carry_board_status_16 << "  " << m_carry_board_status_17 << "  " ;



		//检测报错
		if ((m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[m_carry_board_control_buf_index -
																					1].carry_board_data[1] & 0x02) ==
			0x02
			&& m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[m_carry_board_control_buf_index -
																					  1].carry_board_data[16] == 0
			&& m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[m_carry_board_control_buf_index -
																					  1].carry_board_data[17] == 0)
		{
			m_carry_board_flag = true;
		}
		else
		{
			m_carry_board_flag = false;
		}


		if (m_carry_board_flag)
		{
			m_carry_board_reset_start = std::chrono::system_clock::now();
			m_carry_board_reset_end = std::chrono::system_clock::now();

			//检查任务执行情况
			if ((m_carry_board_target == 1 && m_carry_board_status == 1)
				|| (m_carry_board_target == 1 && m_carry_board_status == 11)
				|| (m_carry_board_target == 2 && m_carry_board_status == 2)
				|| (m_carry_board_target == 2 && m_carry_board_status == 12)
				|| m_carry_board_target == 0 )
			{
//				LOG(INFO) << " 44444444444444444444444444444444444444444444444444444444444444444444 = " << 1111111;

				//正常执行任务，撤销指令
				m_carry_board_control_start = std::chrono::system_clock::now();
				m_carry_board_control_end = std::chrono::system_clock::now();
				init_all_carry_board();
			}
			else
			{
				//任务没有执行， 周期性下发执行
				if (std::chrono::system_clock::now() - m_carry_board_control_start < std::chrono::seconds(1))
				{
					set_carry_board(m_carry_board_space_id, m_carry_board_target);
//					LOG(INFO) << " set_carry_board(m_carry_board_space_id, m_carry_board_target); = " << 1627;
				}
				else if (std::chrono::system_clock::now() - m_carry_board_control_start < std::chrono::seconds(3))
				{
//					LOG(INFO) << " 1111111111111111111111111111111111111111111111111111111111 = " << 1111111;
					init_all_carry_board();
				}
				else
				{
					m_carry_board_control_start = std::chrono::system_clock::now();
					m_carry_board_control_end = std::chrono::system_clock::now();
					init_all_carry_board();
				}
			}
		}
		else
		{
			//报错后，自动周期性复位
			if (std::chrono::system_clock::now() - m_carry_board_reset_start < std::chrono::seconds(1))
			{
				reset_all_carry_board();
				LOG(INFO) << " reset_all_carry_board(); = " << 1647;
			}
			else if (std::chrono::system_clock::now() - m_carry_board_reset_start < std::chrono::seconds(3))
			{
				init_all_carry_board();
			}
			else
			{
				m_carry_board_reset_start = std::chrono::system_clock::now();
				m_carry_board_reset_end = std::chrono::system_clock::now();
				init_all_carry_board();
			}
		}
	}
	t_count_test3++;



	//清除任务残留
//	bool t_reset_flag = true;	//是否重置载车板标志位
//	for (auto iter = m_carry_board_coordinate_map.begin(); iter != m_carry_board_coordinate_map.end(); ++iter)
//	{
//		int t_carry_board_status = 0;
//		get_carry_board_status(iter->first,t_carry_board_status);
//		int t_carry_board_control = 0;
//		get_carry_board_control(iter->first,t_carry_board_control);
//
//		if ( t_carry_board_control == 1 && t_carry_board_status == 2 )
//		{
//			t_reset_flag = false;
//		}
//		if ( t_carry_board_control == 2 && t_carry_board_status == 1 )
//		{
//			t_reset_flag = false;
//		}
//	}
//	if ( t_reset_flag && t_error_flag == false)
//	{
//		init_all_carry_board();
//	}

//	for (int i = 0; i < 1; ++i)
//	{
//		LOG(INFO) << " iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii = " << i+1;
//		for (int j = 0; j < 6; ++j)
//		{
//			LOG(INFO) << " m_carry_board_control_from_manager_to_plc = " << (int)m_carry_board_control_from_manager_to_plc.carry_board_control_buf_vector[i].carry_board_data[j];
//		}
//	}

//	Error_manager eee = set_carry_board(147, 1);
//std::this_thread::sleep_for(std::chrono::milliseconds(1));
//LOG(INFO) << " eee = " << eee;


//	for (int i = 0; i < 21; ++i)
//	{
//		LOG(INFO) << " iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii = " << i+1;
//		for (int j = 0; j < 18; ++j)
//		{
//			LOG(INFO) << " m_carry_board_control_from_manager_to_plc = " << (int)m_carry_board_status_from_plc_to_manager.carry_board_status_buf_vector[i].carry_board_data[j];
//		}
//	}

//	std::cout << " huli test :::: " << " m_dispatch_plc_status_from_manager_to_plc 456= " << m_dispatch_plc_status_from_manager_to_plc.m_dispatch_heartbeat << std::endl;
//	std::cout << " huli test :::: " << " tp_dispatch_plc_status_from_manager_to_plc 789= " << tp_dispatch_plc_status_from_manager_to_plc->m_dispatch_heartbeat << std::endl;




	memcpy(tp_dispatch_plc_status_from_manager_to_plc, &m_dispatch_plc_status_from_manager_to_plc, sizeof(Dispatch_communication::Dispatch_plc_status_from_manager_to_plc));
	memcpy(tp_carry_board_control_from_manager_to_plc, &m_carry_board_control_from_manager_to_plc, sizeof(Dispatch_communication::Carry_board_control_from_manager_to_plc));



#ifndef PLC_S7_COMMUNICATION
	//屏蔽plc后, 将plc的状态修改为正常
	m_dispatch_plc_status_from_plc_to_manager.m_plc_heartbeat++;
	m_dispatch_plc_status_from_plc_to_manager.m_plc_status_info  = 0xF2;
	m_dispatch_plc_status_from_plc_to_manager.m_plc_carrier_status = 3;

	m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_car_height = 1;
	m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_1 = 0xFE;
	m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[0].m_sensor_2 = 0xFF;
	m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[1].m_car_height = 1;
	m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[1].m_sensor_1 = 0xFE;
	m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[1].m_sensor_2 = 0xFF;
	m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[2].m_car_height = 0;
	m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[2].m_sensor_1 = 0xFE;
	m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[2].m_sensor_2 = 0x03;
	m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[3].m_car_height = 1;
	m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[3].m_sensor_1 = 0xFE;
	m_dispatch_plc_status_from_plc_to_manager.m_passway_vector[3].m_sensor_2 = 0x03;
#endif// WAIT_PLC_RESPONSE

	return Error_code::SUCCESS;
}

//检查plc答复反馈
Error_manager Dispatch_plc::check_response_from_plc()
{
//	std::unique_lock<std::mutex> t_lock(m_lock);
//
//
//#ifndef WAIT_PLC_RESPONSE
//	//need, 调试代码, 延时10s, 直接返回成功
//	if ( std::chrono::system_clock::now() - m_start_time > std::chrono::seconds(20) )
//	{
//		return Error_code::SUCCESS;
//	}
//		//返回没有收到数据
//	else
//	{
//		return Error_code::NODATA;
//	}
//#endif
//
//
//#ifdef WAIT_PLC_RESPONSE
//
//	static bool s_update_flag = false;
//	//检查唯一码
//	if ( m_response_key == m_request_key  )
//	{
//		//第一次同步时,刷新时间
//		if ( s_update_flag == false )
//		{
//			s_update_flag = true;
//			if ( m_dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_STORE_CAR )
//			{
//				std::unique_lock<std::mutex> t_lock(Dispatch_manager::get_instance_references().m_lock);
//				Dispatch_manager::get_instance_references().m_store_updata_time = std::chrono::system_clock::now();
//			}
//			else if( m_dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_PICKUP_CAR )
//			{
//				std::unique_lock<std::mutex> t_lock(Dispatch_manager::get_instance_references().m_lock);
//				Dispatch_manager::get_instance_references().m_pickup_updata_time = std::chrono::system_clock::now();
//			}
//		}
//
//
//		if(m_response_status == RESPONS_WORKING)
//		{
//			return Error_code::NODATA;//返回没有收到数据
//		}
//		else
//		{
//			std::cout<< "m_response_status = " << m_response_status << std::endl;
//			//如果故障,则添加错误码
//			if ( m_response_status  != RESPONS_OVER )
//			{
//				//添加错误码
//				Error_manager t_error(DISPATCH_PLC_RESPONS_ERROR, MINOR_ERROR, " Dispatch_plc::check_response_from_plc() m_respons_status is error");
//				return t_error;
//			}
//
//			return Error_code::SUCCESS;
//		}
//
//	}
//	else
//	{
//		s_update_flag = false;
//		return Error_code::NODATA;//返回没有收到数据
//	}
//#endif
	return Error_code::SUCCESS;
}


//检查plc答复反馈
Error_manager Dispatch_plc::check_response_from_plc_new()
{
	std::unique_lock<std::mutex> t_lock(m_lock);


#ifndef WAIT_PLC_RESPONSE
	//need, 调试代码, 延时10s, 直接返回成功
	if ( std::chrono::system_clock::now() - m_start_time > std::chrono::seconds(10) )
	{
		return Error_code::SUCCESS;
	}
		//返回没有收到数据
	else
	{
		return Error_code::NODATA;
	}
#endif


#ifdef WAIT_PLC_RESPONSE

	static bool s_update_flag = false;


//	LOG(INFO) << " +++++++++++++++++++++++++++++++++++++++++++++++++++++++++m_request_key =  "<< m_request_key << " --- " << this;
//	LOG(INFO) << " ++++++++++++++++++++++++++++++++++++++++++++++++++++++++m_response_key =  "<< m_response_key << " --- " << this;
//	LOG(INFO) << " +++++++++++++++++++++++++++++++++++++++++++++++++++++m_response_status =  "<< m_response_status << " --- " << this;


	//检查唯一码
	if ( m_response_key == m_request_key  )
	{
		//第一次同步时,刷新时间
		if ( s_update_flag == false )
		{
			s_update_flag = true;
//			if ( m_dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_STORE_CAR )
//			{
//				std::unique_lock<std::mutex> t_lock(Dispatch_manager::get_instance_references().m_lock);
//				Dispatch_manager::get_instance_references().m_store_updata_time = std::chrono::system_clock::now();
//			}
//			else if( m_dispatch_request_msg.dispatch_motion_direction() == message::Dispatch_motion_direction::E_PICKUP_CAR )
//			{
//				std::unique_lock<std::mutex> t_lock(Dispatch_manager::get_instance_references().m_lock);
//				Dispatch_manager::get_instance_references().m_pickup_updata_time = std::chrono::system_clock::now();
//			}
		}


		if(m_response_status == RESPONS_WORKING)
		{
			return Error_code::NODATA;//返回没有收到数据
		}
		else
		{
			std::cout<< "m_response_status = " << m_response_status << std::endl;
			//如果故障,则添加错误码
			if ( m_response_status == RESPONS_OVER )
			{
				return Error_code::SUCCESS;
			}
			else if ( m_response_status > 10  )//大于10就是要重新申请车位了。
			{
				//m_response_status的 个位数是车高等级， 百位数是车长等级， 例如：1213 = 2级高车和3级长车
				int t_response_status = m_response_status;
				m_height_level_reallocate = t_response_status % 10;
				t_response_status = t_response_status /100;
				m_wheel_base_level_reallocate = t_response_status % 10;
				return DISPATCH_PLC_REALLOCATE_SPACE;
			}
			else //如果故障,则添加错误码
			{
				//添加错误码
				Error_manager t_error(DISPATCH_PLC_RESPONS_ERROR, MINOR_ERROR, " Dispatch_plc::check_response_from_plc() m_respons_status is error");
				return t_error;
			}


		}

	}
	else
	{
		s_update_flag = false;
		return Error_code::NODATA;//返回没有收到数据
	}
#endif
	return Error_code::SUCCESS;
}

//发送调度答复信息给主控
Error_manager Dispatch_plc::send_dispatch_response_to_main_control()
{
//	std::unique_lock<std::mutex> t_lock(m_lock);
//	m_dispatch_response_msg.mutable_base_info()->set_msg_type(message::Message_type::eDispatch_response_msg);
//	m_dispatch_response_msg.mutable_base_info()->set_timeout_ms(m_dispatch_request_msg.base_info().timeout_ms());
//	m_dispatch_response_msg.mutable_base_info()->set_sender(message::Communicator::eDispatch_manager);
//	m_dispatch_response_msg.mutable_base_info()->set_receiver(message::Communicator::eMain);
//
//	m_dispatch_response_msg.set_command_key(m_dispatch_request_msg.command_key());
//	m_dispatch_response_msg.set_dispatch_motion_direction(m_dispatch_request_msg.dispatch_motion_direction());
//	m_dispatch_response_msg.mutable_id_struct()->set_terminal_id(m_dispatch_request_msg.mutable_id_struct()->terminal_id());
//	m_dispatch_response_msg.mutable_id_struct()->set_unit_id(m_dispatch_request_msg.mutable_id_struct()->unit_id());
//	m_dispatch_response_msg.mutable_locate_information()->CopyFrom(m_dispatch_request_msg.locate_information());
//	m_dispatch_response_msg.mutable_parkspace_info_ex()->CopyFrom(m_dispatch_request_msg.parkspace_info_ex());
//	m_dispatch_response_msg.set_car_type(m_dispatch_request_msg.car_type());
//
//	if ( m_dispatch_response_msg.dispatch_motion_direction() == message::E_STORE_CAR )
//	{
//		for (int i = 0; i < m_dispatch_response_msg.parkspace_info_ex_size(); ++i)
//		{
//			if ( m_result == Error_code::SUCCESS )
//			{
//				m_dispatch_response_msg.mutable_parkspace_info_ex(i)->set_parkspace_status_target(message::Parkspace_status::eParkspace_occupied);
//			}
//			else
//			{
//				m_dispatch_response_msg.mutable_parkspace_info_ex(i)->set_parkspace_status_target(message::Parkspace_status::eParkspace_empty);
//			}
//		}
//	}
//	else if( m_dispatch_response_msg.dispatch_motion_direction() == message::E_PICKUP_CAR )
//	{
//		for (int i = 0; i < m_dispatch_response_msg.parkspace_info_ex_size(); ++i)
//		{
//			if ( m_result == Error_code::SUCCESS )
//			{
//				m_dispatch_response_msg.mutable_parkspace_info_ex(i)->set_parkspace_status_target(message::Parkspace_status::eParkspace_empty);
//			}
//			else
//			{
//				m_dispatch_response_msg.mutable_parkspace_info_ex(i)->set_parkspace_status_target(message::Parkspace_status::eParkspace_occupied);
//			}
//		}
//	}
//
//
//	m_dispatch_response_msg.mutable_error_manager()->set_error_code(m_result.get_error_code());
//	m_dispatch_response_msg.mutable_error_manager()->set_error_level((message::Error_level)m_result.get_error_level());
//	m_dispatch_response_msg.mutable_error_manager()->set_error_description(m_result.get_error_description());
//
//
//	std::cout << " huli test :::: " << " m_dispatch_response_msg = " << m_dispatch_response_msg.DebugString()<< std::endl;
//
//	std::string t_msg = m_dispatch_response_msg.SerializeAsString();
//	System_communication::get_instance_references().encapsulate_task_msg(t_msg);
	return Error_code::SUCCESS;
}


//发送调度答复信息给主控
Error_manager Dispatch_plc::send_dispatch_response_to_main_control_new()
{
//	std::unique_lock<std::mutex> t_lock(m_lock);
//
//	std::string t_msg;
//	if ( m_dispatch_process_type == Common_data::Dispatch_process_type::DISPATCH_PROCESS_STORE )
//	{
//		measure_info t_measure_info =  m_park_table_msg.entrance_measure_info();
//		m_park_table_msg.mutable_actually_measure_info()->CopyFrom(t_measure_info);
//		parkspace_info t_parkspace_info =  m_park_table_msg.allocated_space_info();
//		m_park_table_msg.mutable_actually_space_info()->CopyFrom(t_parkspace_info);
//		//存车真实轴距
//		m_park_table_msg.mutable_actually_measure_info()->set_wheelbase(m_response_car_wheel_base_exact_value);
//
//		if ( m_result != Error_code::SUCCESS )
//		{
//			std::string t_error_string = m_result.to_string();
//			m_park_table_msg.mutable_statu()->set_execute_statu(eError);
//			m_park_table_msg.mutable_statu()->set_statu_description(t_error_string);
//		}
//		t_msg = m_park_table_msg.DebugString();
//	}
//	else if ( m_dispatch_process_type == Common_data::Dispatch_process_type::DISPATCH_PROCESS_PICKUP )
//	{
//		m_pick_table_msg.set_export_id(1);
//		if ( m_result != Error_code::SUCCESS )
//		{
//			std::string t_error_string = m_result.to_string();
//			m_pick_table_msg.mutable_statu()->set_execute_statu(eError);
//			m_pick_table_msg.mutable_statu()->set_statu_description(t_error_string);
//		}
//		t_msg = m_pick_table_msg.DebugString();
//	}
//
//	System_communication::get_instance_references().encapsulate_task_msg(t_msg, 1);
//	std::cout << " huli test :::: " << " m_command_completed_msg = " << t_msg << std::endl;
//	Dispatch_manager::get_instance_references().ack_rabbitmq_message_new();
	return Error_code::SUCCESS;
}









