//
// Created by huli on 2021/12/30.
//

#ifndef NNXX_TESTS_LED_OUTLET_H
#define NNXX_TESTS_LED_OUTLET_H

#include <map>
#include <vector>
#include <string>
#include <chrono>
#include<time.h>
#include <cstdlib>
#include <stdio.h>
#include <stdlib.h>
#include "../tool/singleton.h"


//出口led屏的显示
class Led_outlet:public Singleton<Led_outlet>
{
public:
	// 子类必须把父类设定为友元函数，这样父类才能使用子类的私有构造函数。
	friend class Singleton<Led_outlet>;
	//出口汽车状态
	enum  Outlet_car_status
	{
		OUTLET_CAR_STATUS_UNKNOW		=0,	        //出口汽车状态 未知
		OUTLET_CAR_STATUS_READY			=1,	        //出口汽车状态 准备中
		OUTLET_CAR_STATUS_WORKING		=2,	        //出口汽车状态 工作中
		OUTLET_CAR_STATUS_OVER			=3,	        //出口汽车状态 已完成

		OUTLET_CAR_STATUS_FAULT			=4,	        //出口汽车状态 故障
	};
	//出口汽车信息
	struct Outlet_car_information
	{
		std::string					m_car_licence;										//车牌号
		int 						m_unit_id = -1;										//单元号
		int 						m_outlet_id = -1;									//出口号
		Outlet_car_status			m_outlet_car_status = OUTLET_CAR_STATUS_UNKNOW;		//出口汽车状态
		int 						m_wait_number = -1;									//等待顺序编号
		//注意了,如果数值为-1, 则不显示
	};

private:
	Led_outlet() = default;
public:
	Led_outlet(const Led_outlet& other)= delete;
	Led_outlet& operator =(const Led_outlet& other)= delete;
	~Led_outlet() = default;
public://API functions
	//更新车辆信息
	void update_car_information(std::string car_licence, int unit_id, int outlet_id, Outlet_car_status outlet_car_status, int m_time_remaining = -1);
	//更新车辆信息
	void update_car_information(std::string car_licence, Outlet_car_status outlet_car_status, int m_time_remaining = -1);
	//删除车辆信息
	void delete_car_information(std::string car_licence);
	//获取显示字符串
	std::string get_show_string();
public://get or set member variable

protected://member functions

protected://member variable
	std::vector<Outlet_car_information>										m_pickup_process_A_vector;			//A单元取车流程显示
	std::vector<Outlet_car_information>										m_pickup_process_B_vector;			//B单元取车流程显示
	std::vector<Outlet_car_information>										m_pickup_process_C_vector;			//C单元取车流程显示
	std::string											Led_outlet_show_string;	//出口led显示信息的字符串

private:

};


#endif //NNXX_TESTS_LED_OUTLET_H
