import sys
from PyQt5.QtWidgets import QApplication
import async_communication as cmt
import tool.db_helper.db_operation as spmng
import tool.json_helper.parse_json as parse_json
from 管理节点.window_controller.main_window import MainWindow

if __name__ == '__main__':
    # 读取文件
    config = parse_json.parse_json_with_comments('./config.json')
    # 数据库配置
    db_config = config['db_config']
    # 车库配置配置
    parking_config = config['parking_config']
    # rabbitmq配置
    mq_config = config['mq_config']
    passwd = parking_config['passwd']
    g_rabbitmq = cmt.RabbitAsyncCommunicator(mq_config['mq_ip'], mq_config['mq_port'], mq_config['mq_user'],
                                             mq_config['mq_password'])
    try:
        g_rabbitmq.Init(None, None)
        g_rabbitmq.start()
    except Exception as e:
        print('rabbitmq启动失败！' + str(e.args))

    g_space = spmng.DBOperation(db_config['db_ip'], db_config['db_port'], db_config['db_name'], db_config['db_user'],
                                db_config['db_password'])

    app = QApplication(sys.argv)
    mainWindow = MainWindow(parking_config, g_space, g_rabbitmq)
    mainWindow.showMaximized()
    mainWindow.plate_full_image_label.setMaximumSize(mainWindow.plate_full_image_label.size())
    mainWindow.plate_clip_image_label.setMaximumSize(mainWindow.plate_clip_image_label.size())

    sys.exit(app.exec_())
